
PROGRAM CLIENT;

{$R CLIENT.RES}

Uses STRINGS, WINTYPES, WINPROCS, OWINDOWS;

{$I CLIENT.INC}

Const ac_Aucune = 0;
      ac_DDE_Initiate = 1;
      ac_DDE_Poke = 2;
      ac_DDE_Request = 3;
      ac_DDE_Terminate = 4;

Type tProgramme = Object(tApplication)
                    Procedure INITMAINWINDOW; virtual;
                  end;

     pFenetre = ^tFenetre;
     tFenetre = Object(tWindow)
                  ActionCourante : Byte;
                  AtomeApplication, AtomeRubrique : tAtom;
                  HandleServeur : hWnd;
                  HandleDonnees : tHandle;
                  Chaine : Array [0..65000] of Char;
                  Constructor INIT (ApplicationParent : pWindowsObject; Titre : pChar);
                  Procedure CMDDEINITIATE (var Msg : tMessage); virtual cm_First + cm_DDE_Initiate;
                  Procedure CMDDEPOKE (var Msg : tMessage); virtual cm_First + cm_DDE_Poke;
                  Procedure REQUETE (Message : pChar);
                  Procedure CMDDEREQUEST1 (var Msg : tMessage); virtual cm_First + cm_DDE_Request1;
                  Procedure CMDDEREQUEST2 (var Msg : tMessage); virtual cm_First + cm_DDE_Request2;
                  Procedure CMDDEREQUEST3 (var Msg : tMessage); virtual cm_First + cm_DDE_Request3;
                  Procedure CMDDETERMINATE (var Msg : tMessage); virtual cm_First + cm_DDE_Terminate;
                  Procedure WMDDEACK (var Msg : tMessage); virtual wm_First + wm_DDE_ACK;
                  Procedure WMDDEDATA (var Msg : tMessage); virtual wm_First + wm_DDE_Data;
                  Procedure WMDDETERMINATE (var Msg : tMessage); virtual wm_First + wm_DDE_Terminate;
                end;

Var Programme : tProgramme;


Procedure tProgramme.INITMAINWINDOW;
Begin
  MainWindow:=New(pFenetre,INIT(nil,'Application client DDE'));
End;


Constructor tFenetre.INIT (ApplicationParent : pWindowsObject; Titre : pChar);
Begin
  tWindow.INIT(ApplicationParent,Titre);
  Attr.Menu:=LoadMenu(hInstance,pChar(id_Menu));
  ActionCourante:=ac_Aucune;
End;

Procedure tFenetre.CMDDEINITIATE (var Msg : tMessage);
Begin
  ActionCourante:=ac_DDE_Initiate;
  AtomeApplication:=GlobalAddAtom('ADRESSES');
  AtomeRubrique:=GlobalAddAtom('Mailing');
  SendMessage($FFFF,wm_DDE_Initiate,hWindow,MakeLong(AtomeApplication,AtomeRubrique));
  GlobalDeleteAtom(AtomeApplication);
  GlobalDeleteAtom(AtomeRubrique);
End;

Procedure tFenetre.CMDDEPOKE (var Msg : tMessage);
Var c : Array [0..12] of Char;
    Donnees : pDDEPoke;
Begin
  ActionCourante:=ac_DDE_Poke;
  AtomeRubrique:=GlobalAddAtom('ListeChamps');
  HandleDonnees:=GlobalAlloc(gmem_Moveable or gmem_DDEShare,SizeOf(tDDEPoke)+SizeOf(c));
  if HandleDonnees <> 0
     then
       begin
         Donnees:=GlobalLock(HandleDonnees);
         if Donnees <> nil
            then with Donnees^ do
              begin
                Flags:=dde_Release;
                cfFormat:=cf_Text;
                StrCopy(c,'011111100000'); Move(c,Value,SizeOf(c));
                GlobalUnlock(HandleDonnees);
                if not PostMessage(HandleServeur,wm_DDE_Poke,hWindow,MakeLong(HandleDonnees,AtomeRubrique))
                   then
                     begin
                       GlobalDeleteAtom(AtomeRubrique);
                       GlobalFree(HandleDonnees);
                       MessageBox(hWindow,'Message non reu','wm_DDE_Poke',mb_IconExclamation or mb_Ok);
                     end;
              end
            else
              MessageBox(hWindow,'Erreur de verrouillage du bloc de mmoire','wm_DDE_Poke',mb_IconExclamation or mb_Ok);
       end
     else
       MessageBox(hWindow,'Erreur d''allocation du bloc de mmoire','wm_DDE_Poke',mb_IconExclamation or mb_Ok);
End;

Procedure tFenetre.REQUETE (Message : pChar);
Var c : Array [0..6] of Char;
Begin
  ActionCourante:=ac_DDE_Request;
  AtomeRubrique:=GlobalAddAtom(Message);
  if not PostMessage(HandleServeur,wm_DDE_Request,hWindow,MakeLong(cf_Text,AtomeRubrique))
     then
       begin
         GlobalDeleteAtom(AtomeRubrique);
         GlobalFree(HandleDonnees);
         MessageBox(hWindow,'Message non reu','wm_DDE_Request',mb_IconExclamation or mb_Ok);
       end;
End;

Procedure tFenetre.CMDDEREQUEST1 (var Msg : tMessage);
Begin
  REQUETE('Tout');
End;

Procedure tFenetre.CMDDEREQUEST2 (var Msg : tMessage);
Begin
  REQUETE('Manuel');
End;

Procedure tFenetre.CMDDEREQUEST3 (var Msg : tMessage);
Begin
  REQUETE('AutoLPJJL');
End;

Procedure tFenetre.CMDDETERMINATE (var Msg : tMessage);
Begin
  if not PostMessage(HandleServeur,wm_DDE_Terminate,hWindow,0)
     then
       MessageBox(hWindow,'Message non reu','wm_DDE_Terminate',mb_IconExclamation or mb_Ok);
End;

Procedure tFenetre.WMDDEACK (var Msg : tMessage);
Begin
  case ActionCourante of
    ac_DDE_Initiate : begin
                        HandleServeur:=Msg.wParam;
                        AtomeApplication:=LoWord(Msg.lParam); if AtomeApplication <> 0 then GlobalDeleteAtom(AtomeApplication);
                        AtomeRubrique:=HiWord(Msg.lParam); if AtomeRubrique <> 0 then GlobalDeleteAtom(AtomeRubrique);
                        MessageBox(hWindow,'Reu l''accus de rception','wm_DDE_Initiate',mb_IconExclamation or mb_Ok);
                      end;
    ac_DDE_Poke : begin
                    AtomeRubrique:=HiWord(Msg.lParam); if AtomeRubrique <> 0 then GlobalDeleteAtom(AtomeRubrique);
                    if (LoWord(Msg.lParam) and dde_ACK) = 0
                       then
                         begin
                           GlobalFree(HandleDonnees);
                           MessageBox(hWindow,'Accus de rception ngatif','wm_DDE_Poke',mb_IconExclamation or mb_Ok);
                         end
                       else
                         MessageBox(hWindow,'Accus de rception positif','wm_DDE_Poke',mb_IconExclamation or mb_Ok);
                  end;
    ac_DDE_Request : begin
                       if (LoWord(Msg.lParam) and dde_ACK) = 0
                          then
                            begin
                              AtomeRubrique:=HiWord(Msg.lParam); if AtomeRubrique <> 0 then GlobalDeleteAtom(AtomeRubrique);
                              MessageBox(hWindow,'Accus de rception ngatif','wm_DDE_Request',mb_IconExclamation or mb_Ok);
                            end
                          else
                            MessageBox(hWindow,'Accus de rception positif','wm_DDE_Request',mb_IconExclamation or mb_Ok);
                     end;
  end;
End;

Procedure tFenetre.WMDDEDATA (var Msg : tMessage);
Var Supprimer : Boolean;
    Donnees : pDDEData;
Begin
  HandleDonnees:=LoWord(Msg.lParam);
  Donnees:=GlobalLock(HandleDonnees);
  if Donnees <> nil
     then
       begin
         StrCopy(Chaine,'(pas de donnes)');
         if Donnees^.cfFormat = cf_Text
            then
              begin
                StrCopy(Chaine,Donnees^.Value);
                Supprimer:=(Donnees^.Flags and dde_Release <> 0);
                if Donnees^.Flags and dde_ACKReq <> 0
                   then
                     begin
                       StrCat(Chaine,#10#13'Accus de rception demand');
                       if not PostMessage(Msg.wParam,wm_DDE_ACK,hWindow,MakeLong(dde_ACK,HiWord(Msg.lParam)))
                          then
                            begin
                              AtomeRubrique:=HiWord(Msg.lParam); if AtomeRubrique <> 0 then GlobalDeleteAtom(AtomeRubrique);
                              MessageBox(hWindow,'Message non reu','wm_DDE_ACK',mb_IconExclamation or mb_Ok);
                            end;
                     end
                   else
                     begin
                       AtomeRubrique:=HiWord(Msg.lParam); if AtomeRubrique <> 0 then GlobalDeleteAtom(AtomeRubrique);
                     end;
                GlobalUnlock(HandleDonnees);
                if Supprimer then GlobalFree(HandleDonnees);
                MessageBox(hWindow,Chaine,'wm_DDE_Data',mb_IconExclamation or mb_Ok);
              end
            else
              MessageBox(hWindow,'Format de donnes incorrect','wm_DDE_Data',mb_IconExclamation or mb_Ok);
       end
     else
       MessageBox(hWindow,'Erreur de verrouillage du bloc de mmoire','wm_DDE_Data',mb_IconExclamation or mb_Ok);
End;

Procedure tFenetre.WMDDETERMINATE (var Msg : tMessage);
Begin
  MessageBox(hWindow,'Fin de communication','wm_DDE_Terminate',mb_IconHand or mb_Ok);
End;


BEGIN
  Programme.INIT('Client');
  Programme.RUN;
  Programme.DONE;
END.
