
PROGRAM ADRESSES;

(* CARNET D'ADRESSES AVEC POSSIBILITE DE TRIER ET D'IMPRIMER DES LISTINGS ET DES ETIQUETTES.
   DEPUIS LA VERSION 1.10, PEUT SERVIR DE SOURCE DE DONNEES POUR UN MAILING WORD 6 (PROTOCOLE DDE). MACRO WORD 6 FOURNIE.
   POSSIBILITE DE PERSONNALISER LES COULEURS D'AFFICHAGE.

   VERSION 1.10.

   DATE DE CREATION     : 07-04-1999.
   DERNIERE MISE A JOUR : 22-06-1999.

   VERSION 1.00 COMMANDEE PAR P. GERARD DE LA BSR DE LIEGE;
   VERSION 1.10 COMMANDEE PAR M. BAPS DE LA BSR DE LIEGE.

   NOUVELLE FONCTIONNALITE DEPUIS LA VERSION 1.00 : COMMUNICATION DDE AVEC UNE APPLICATION CLIENT AFIN DE RETOURNER
   UNE LISTE DE FICHES. 3 POSSIBILITES :
   - TOUTES LES FICHES;
   - LES FICHES DANS LESQUELLES APPARAIT UNE CERTAINE CHAINE DE CARACTERES;
   - DES FICHES SELECTIONNEES MANUELLEMENT. *)

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                              DIRECTIVES DE COMPILATION                                                 *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

{$R ADRESSES.RES}   (* FICHIER DE RESSOURCES *)
{$I-}               (* GESTION DES ERREURS I/O PAR LE PROGRAMME *)

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                               UNITES ET DLL UTILISEES                                                  *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Uses STRINGS, WINTYPES, WINPROCS, OWINDOWS, ODIALOGS, OBJECTS, WIN31, COMMDLG;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                   CONSTANTES NON TYPEES (DIRECTIVES AU COMPILATEUR)                                    *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

{$I ADRESSES.INC}   (* CONSTANTES *)

Const (* NOMS DU PROGRAMME ET DE LA FENETRE PRINCIPALE *)
      NomApplication = 'Adresses';
      NomFenetrePrincipale = 'Carnet d''adresses';

      (* TAILLE DU BUFFER DE LECTURE/ECRITURE DU FICHIER DE DONNEES PERSONNELLES *)
      TailleBuffer = 458;

      (* TYPE DE REQUETE DDE *)
      req_Tout = 1;
      req_Manuel = 2;
      req_Auto = 3;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                    TYPES PREDEFINIS                                                    *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Type pReal = ^Real;
     pBoolean = ^Boolean;

     (* TABLEAU DES 16 COULEURS PERSONNALISEES DU DIALOGUE WINDOWS 3.1 DE CHOIX DE COULEUR *)
     tCouleursPerso = Array [1..16] of tColorRef;

     (* COULEURS DES ELEMENTS AFFICHES *)
     tCouleurs = Array [cm_CouleurFormule..cm_CouleurTitres] of tColorRef;

     (* GROUPE NOM+PRENOM (ELEMENT DE LA BOITE LISTE DES DONNEES PERSONNELLES) *)
     tNomPrenom = Array [0..190] of Char;

     (* DONNEES PERSONNELLES *)
     pDonneesPers = ^tDonneesPers;
     tDonneesPers = Record
                      Formule : Array [0..30] of Char;                (* FORMULE D'INTRODUCTION (M., Mme, ETC) *)
                      Nom, Prenom : Array [0..30] of Char;            (* NOM ET PRENOM *)
                      Rue : Array [0..120] of Char;                   (* RUE ET N, EN 2 LIGNES *)
                      CP : Array [0..6] of Char;                      (* CODE POSTAL *)
                      Localite : Array [0..50] of Char;               (* LOCALITE *)
                      TelPrive, FaxPrive : Array [0..20] of Char;     (* TELEPHONE ET FAX PRIVES *)
                      TelBureau, FaxBureau : Array [0..20] of Char;   (* TELEPHONE ET FAX AU BUREAU *)
                      eMail : Array [0..50] of Char;                  (* ADRESSE D'E-MAIL *)
                      Remarque : Array [0..50] of Char;               (* REMARQUE FACULTATIVE *)
                    end;

     (* LISTE CHAINEE DES DONNEES PERSONNELLES *)
     pListeDonneesPers = ^tListeDonneesPers;
     tListeDonneesPers = Record
                           DonneesPers : tDonneesPers;         (* DONNEES PERSONNELLES *)
                           Selection : Boolean;                (* INDIQUE SI LA FICHE EST SELECTIONNEE *)
                           pPrec, pSuiv : pListeDonneesPers;   (* LIENS AVEC LES ELEMENTS PRECEDENT ET SUIVANT *)
                         end;

     (* FICHIER DES DONNEES PERSONNELLES *)
     tBufferDonneesPers = Array [0..TailleBuffer] of Char;   (* TRANSTYPAGE DES DONNEES EN CHAINE UNIQUE *)
     tFichierDonneesPers = File of tBufferDonneesPers;

     (* DONNEES A TRANSMETTRE A UNE APPLICATION CLIENT DDE *)
     pChaineDDE = ^tChaineDDE;
     tChaineDDE = Array [0..65000] of Char;

     (* STYLES DES DONNEES AU MOMENT DE L'IMPRESSION *)
     tStyleTexte = Record
                     Fonte : tLogFont;      (* PARAMETRES GENERAUX DE LA FONTE *)
                     Taille : Integer;      (* HAUTEUR (EN POINTS) DE LA FONTE *)
                     Couleur : tColorRef;   (* COULEUR DU TEXTE *)
                   end;
     pStyles = ^tStyles;
     tStyles = Array [id_Formule..id_Remarque] of tStyleTexte;

     (* TABLEAU DES HANDLES DES DIFFERENTES FONTES UTILISEES *)
     tFontes = Array [id_Formule..id_Remarque] of hFont;

     (* PLAN D'UNE FEUILLE D'ETIQUETTES *)
     tEtiquette = Record
                    Imprimer : Boolean;            (* INDIQUE SI L'ETIQUETTE DOIT ETRE IMPRIMEE *)
                    Adresse : pListeDonneesPers;   (* ADRESSE DES DONNEES PERSONNELLES ASSOCIEES A L'ETIQUETTE *)
                  end;
     pPlanEtiquettes = ^tPlanEtiquettes;
     tPlanEtiquettes = Array [1..17,1..4] of tEtiquette;

     (* TABLEAU DES CHAMPS A IMPRIMER SUR LE LISTING *)
     pChamps = ^tChamps;
     tChamps = Array [id_Formule..id_Remarque] of Word;

     (* BOITE LISTE A SELECTION MULTIPLE *)
     pListePers = ^tListePers;
     tListePers = Object(tListBox)
                    Constructor INIT (FenetreParent : pWindowsObject; Id, x, y, w, h : Integer);
                       (* DEFINITION DU STYLE DU CONTROLE *)
                  end;

     (* MODULE D'IMPRESSION *)
     pImprimante = ^tImprimante;
     tImprimante = Object(tObject)
                     DC : hDC;                                                (* CONTEXTE DE PERIPHERIQUE D'IMPRESSION *)
                     Fontes : tFontes;                                        (* HANDLES DE TOUTES LES FONTES UTILISEES *)
                     hTitres : Integer;                                       (* HAUTEUR DES TITRES *)
                     Hauteurs : Array [id_Formule..id_Remarque] of Integer;   (* HAUTEUR DE TOUTES LES LIGNES DE TEXTE *)
                     mH, mB, mG, mD : Integer;                                (* MARGES A APPLIQUER *)
                     lEtiq, hEtiq : Integer;                                  (* LARGEUR ET HAUTEUR D'UNE ETIQUETTE *)
                     dy : Integer;                                            (* NOMBRE DE PIXELS PAR POUCE *)
                     h3, h4 : Integer;                                        (* ESPACE ENTRE HAUT ETIQUETTE ET 1ERE LIGNE *)
                     NbElements : Integer;                                    (* NOMBRE D'ELEMENTS PAR PAGE DE LISTING *)
                     Constructor INIT;
                        (* CREATION DU CONTEXTE DE PERIPHERIQUE D'IMPRESSION *)
                     Function MESSAGE_ERREUR_IMPRIMANTE (nTitre, nTexte : Word) : Boolean;
                        (* MESSAGE D'ERREUR D'IMPRIMANTE - RENVOIE true S'IL FAUT REESSAYER *)
                     Procedure INITIALISATION_FONTES (Styles : pStyles);
                        (* CREATION DES FONTES NECESSAIRES A L'IMPRESSION *)
                     Procedure INITIALISATION_ETIQUETTES (MargeHaut, MargeBas, MargeGauche, MargeDroite : pReal;
                                                          NbParLigne, NbParColonne : pByte; Styles : pStyles);
                        (* CALCULS ET CREATION DES FONTES NECESSAIRES A L'IMPRESSION D'ETIQUETTES *)
                     Function IMPRIMER_ETIQUETTES (Plan : pPlanEtiquettes; Styles : pStyles) : Boolean;
                        (* IMPRESSION D'UNE PAGE D'ETIQUETTES *)
                     Procedure INITIALISATION_LISTING (Styles : pStyles; Champs : pChamps);
                        (* CALCULS ET CREATION DES FONTES NECESSAIRES A L'IMPRESSION DU LISTING *)
                     Function IMPRIMER_LISTING (NbTotal : Word; Styles : pStyles; pTete : pListeDonneesPers;
                                                Champs : pChamps) : Boolean;
                        (* IMPRESSION DU LISTING COMPLET *)
                     Destructor DONE; virtual;
                        (* DESTRUCTION DU CONTEXTE DE PERIPHERIQUE D'IMPRESSION *)
                   end;

     (* DIALOGUE DE DEMARRAGE *)
     pDlgDemarrage = ^tDlgDemarrage;
     tDlgDemarrage = Object(tDialog)
                       Procedure SETUPWINDOW; virtual;
                          (* CENTRAGE DU DIALOGUE A L'ECRAN *)
                       Procedure DEBUT;
                          (* AFFICHAGE DU DIALOGUE *)
                       Procedure FIN;
                          (* DESTRUCTION DU DIALOGUE *)
                     end;

     (* DIALOGUE DE MODIFICATION DES DONNEES PERSONNELLES *)
     pDlgDonneesPers = ^tDlgDonneesPers;
     tDlgDonneesPers = Object(tDialog)
                         DonneesPers : pDonneesPers;   (* ADRESSE DE L'ENREGISTREMENT A MODIFIER *)
                         Constructor INIT (FenetreParent : pWindowsObject; NomDialogue : pChar; Pointeur : pDonneesPers);
                            (* PASSAGE DE L'ADRESSE DE L'ENREGISTREMENT DE DONNEES A MODIFIER *)
                         Procedure SETUPWINDOW; virtual;
                            (* CENTRAGE A L'ECRAN ET INITIALISATION DES CONTROLES ENFANTS *)
                         Procedure OK (var Msg : tMessage); virtual id_First + id_Ok;
                            (* LORSQUE LE BOUTON "OK" EST PRESSE, CONTROLE DU CONTENU DES CONTROLES AVANT DE QUITTER *)
                       end;

     (* DIALOGUE DE CHOIX DE L'OPTION DE TRI *)
     pDlgTri = ^tDlgTri;
     tDlgTri = Object(tDialog)
                 Tri : pInteger;   (* ADRESSE DU TYPE DE TRI *)
                 Sens : pByte;     (* ADRESSE DU SENS DE TRI *)
                 Constructor INIT (FenetreParent : pWindowsObject; NomDialogue : pChar; Ptr1 : pInteger; Ptr2 : pByte);
                   (* PASSAGE DE L'ADRESSE DES OPTIONS A MODIFIER *)
                 Procedure SETUPWINDOW; virtual;
                   (* CENTRAGE A L'ECRAN ET INITIALISATION DES CONTROLES ENFANTS *)
                 Procedure OK (var Msg : tMessage); virtual id_First + id_Ok;
                   (* LORSQUE LE BOUTON "OK" EST PRESSE, MISE A JOUR DES OPTIONS *)
               end;

     (* DIALOGUE DE DEFINITION DES OPTIONS DE RECHERCHE *)
     pDlgChercher = ^tDlgChercher;
     tDlgChercher = Object(tDialog)
                      Champs : pChamps;      (* ADRESSE DU TABLEAU DES CHAMPS *)
                      Chercher : pChar;      (* ADRESSE DE LA CHAINE A RECHERCHER *)
                      Resultat : pBoolean;   (* ADRESSE DU RESULTAT (true SI BOUTON "OK") *)
                      Constructor INIT (FenetreParent : pWindowsObject; NomDialogue : pChar;
                                        Ptr1 : pChamps; Ptr2 : pChar; Ptr3 : pBoolean);
                         (* PASSAGE DE L'ADRESSE DES OPTIONS A MODIFIER ET DU RESULTAT *)
                      Procedure SETUPWINDOW; virtual;
                         (* CENTRAGE A L'ECRAN ET INITIALISATION DES CONTROLES ENFANTS *)
                      Procedure OK (var Msg : tMessage); virtual id_First + id_Ok;
                         (* LORSQUE LE BOUTON "OK" EST PRESSE, MISE A JOUR DES OPTIONS *)
                      Procedure CANCEL (var Msg : tMessage); virtual id_First + id_Cancel;
                         (* LORSQUE LE BOUTON "Annuler" EST PRESSE, RETOURNE UN RESULTAT false *)
                    end;

     (* DIALOGUE DE DEFINITION DES OPTIONS D'IMPRESSION D'ETIQUETTES *)
     pDlgEtiquettes = ^tDlgEtiquettes;
     tDlgEtiquettes = Object(tDialog)
                        MargeHaut, MargeBas, MargeGauche, MargeDroite : pReal;   (* MARGES DE LA FEUILLE D'ETIQUETTES *)
                        NbParLigne, NbParColonne : pByte;                        (* NOMBRE D'ETIQUETTES PAR FEUILLE *)
                        Retour : pByte;                                          (* RETOURNE 0 SI ANNULATION *)
                        Constructor INIT (FenetreParent : pWindowsObject; NomDialogue : pChar;
                                          Ptr1, Ptr2, Ptr3, Ptr4 : pReal; Ptr5, Ptr6, Resultat : pByte);
                           (* PASSAGE DE L'ADRESSE DES OPTIONS A MODIFIER *)
                        Procedure SETUPWINDOW; virtual;
                           (* CENTRAGE A L'ECRAN ET INITIALISATION DES CONTROLES ENFANTS *)
                        Procedure OK (var Msg : tMessage); virtual id_First + id_Ok;
                           (* LORSQUE LE BOUTON "OK" EST PRESSE, MISE A JOUR DES OPTIONS *)
                        Procedure CANCEL (var Msg : tMessage); virtual id_First + id_Cancel;
                           (* LORSQUE LE BOUTON "Annuler" EST PRESSE, RETOURNE LA VALEUR 0 *)
                      end;

     (* DIALOGUE DE REPARTITION DES ETIQUETTES SUR LA FEUILLE D'ETIQUETTES *)
     pDlgRepartition = ^tDlgRepartition;
     tDlgRepartition = Object(tDialog)
                         NbParLigne, NbParColonne : pByte;   (* NOMBRES D'ETIQUETTES PAR LIGNE ET PAR COLONNE *)
                         NbTotal : pWord;                    (* NOMBRE TOTAL D'ETIQUETTES RESTANT A IMPRIMER *)
                         NumeroFeuille : pWord;              (* N0 DE LA FEUILLE D'ETIQUETTES *)
                         Plan : pPlanEtiquettes;             (* ADRESSE DU PLAN DE LA FEUILLE D'ETIQUETTES *)
                         NbEtiquettes : pWord;               (* ADRESSE DU NOMBRE D'ETIQUETTES A IMPRIMER *)
                         Constructor INIT (FenetreParent : pWindowsObject; NomDialogue : pChar; NbL, NbC : pByte;
                                           No, NbT : pWord; Donnees : pPlanEtiquettes; Resultat : pWord);
                            (* PASSAGE DES PARAMETRES DE REPARTITION ET DE L'ADRESSE DU RESULTAT *)
                         Procedure SETUPWINDOW; virtual;
                            (* CENTRAGE A L'ECRAN ET INITIALISATION DES CONTROLES ENFANTS *)
                         Procedure WMCOMMAND (var Msg : tMessage); virtual wm_First + wm_Command;
                            (* ACTIVATION OU DESACTIVATION DES BOUTONS REPRESENTANT LES ETIQUETTES *)
                         Procedure CANCEL (var Msg : tMessage); virtual id_First + id_Cancel;
                            (* LORSQUE LE BOUTON "Annuler" EST PRESSE, LE NOMBRE D'ETIQUETTES A IMPRIMER EST 0 *)
                       end;

     (* DIALOGUE DE CHOIX DES CHAMPS A IMPRIMER SUR LE LISTING *)
     pDlgListing = ^tDlgListing;
     tDlgListing = Object(tDialog)
                     Champs : pChamps;   (* TABLEAU DES CHAMPS A IMPRIMER *)
                     Constructor INIT (FenetreParent : pWindowsObject; NomDialogue : pChar; Donnees : pChamps);
                        (* PASSAGE DE L'ADRESSE DES OPTIONS A MODIFIER *)
                     Procedure SETUPWINDOW; virtual;
                        (* CENTRAGE A L'ECRAN ET INITIALISATION DES CONTROLES ENFANTS *)
                     Procedure OK (var Msg : tMessage); virtual id_First + id_Ok;
                        (* LORSQUE LE BOUTON "OK" EST PRESSE, MISE A JOUR DES OPTIONS *)
                   end;

     (* FENETRE D'APERCU DES POLICES UTILISEES *)
     pApercu = ^tApercu;
     tApercu = Object(tWindow)
                 Styles : pStyles;                                        (* TABLEAU DES POLICES UTILISEES *)
                 Fontes : tFontes;                                        (* HANDLES DE TOUTES LES FONTES UTILISEES *)
                 dy : Integer;                                            (* NOMBRE DE PIXELS PAR POUCE *)
                 hTitre : Integer;                                        (* HAUTEUR DES TITRES *)
                 lTitres : Array [id_TelPrive..id_Remarque] of Integer;   (* LARGEURS DES TITRES *)
                 Largeurs : Array [id_Formule..id_Remarque] of Integer;   (* LARGEUR DE TOUTES LES CHAINES A DESSINER *)
                 Hauteurs : Array [id_Formule..id_Remarque] of Integer;   (* HAUTEUR DE TOUTES LES LIGNES DE TEXTE *)
                 Constructor INIT (FenetreParent : pWindowsObject; Donnees : pStyles);
                    (* PASSAGE DE L'ADRESSE DU TABLEAU DES POLICES DE CARACTERES *)
                 Procedure SETUPWINDOW; virtual;
                    (* CREATION DES FONTES, CENTRAGE ET ADAPTATION DE LA TAILLE DE LA FENETRE *)
                 Procedure PAINT (PaintDC : hDC; var PaintInfo : tPaintStruct); virtual;
                    (* AFFICHAGE DU CONTENU DE LA FENETRE *)
                 Procedure WMKEYDOWN (var Msg : tMessage); virtual wm_First + wm_KeyDown;
                    (* SI LA TOUCHE ESCAPE A ETE PRESSEE, FERMETURE DE LA FENETRE *)
                 Destructor DONE; virtual;
                    (* DESTRUCTION DES FONTES CREEES *)
               end;

     (* DIALOGUE "A PROPOS DE" *)
     pDlgAPropos = ^tDlgAPropos;
     tDlgAPropos = Object(tDialog)
                     Procedure SETUPWINDOW; virtual;
                        (* CENTRAGE A L'ECRAN *)
                   end;

     (* APPLICATION *)
     tProgramme = Object(tApplication)
                    Constructor INIT (NomProgramme : pChar);
                       (* REMPLACEMENT DE LA ROUTINE DE GESTION DES ALLOCATIONS DYNAMIQUES *)
                    Procedure INITMAINWINDOW; virtual;
                       (* CHOIX DE LA FENETRE PRINCIPALE DE L'APPLICATION *)
                  end;

     (* FENETRE PRINCIPALE *)
     pFenetrePrincipale = ^tFenetrePrincipale;
     tFenetrePrincipale = Object(tWindow)
                            DialogueDemarrage : pDlgDemarrage;    (* POINTEUR SUR LE PETIT DIALOGUE DE DEMARRAGE *)
                            CouleursPerso : tCouleursPerso;       (* COULEURS PREDEFINIES DU DIALOGUE DE CHOIX DE COULEUR *)
                            Couleurs : tCouleurs;                 (* COULEURS DES ELEMENTS AFFICHES *)
                            RectDonneesPers : tRect;              (* ZONE A REDESSINER (DONNEES PERSONNELLES) *)
                            Ctl_ListePers : pListePers;           (* CONTROLE BOITE LISTE GENERALE DES PERSONNES *)
                            NomFichier : Array [0..12] of Char;   (* NOM DU FICHIER DE DONNEES *)
                            HandleFichier : Integer;              (* HANDLE DU FICHIER DE DONNEES *)
                            Buffer : tBufferDonneesPers;          (* BUFFER DE LECTURE/ECRITURE DU FICHIER DE DONNEES *)
                            pTete, pQueue  : pListeDonneesPers;   (* TETE ET QUEUE DE LA LISTE CHAINEE DES PERSONNES *)
                            Tri : Integer;                        (* TYPE DE TRI COURANT *)
                            SensTri : Byte;                       (* INDIQUE SI TRI CROISSANT (1) OU DECROISSANT (0) *)
                            Styles : tStyles;                     (* STYLES D'IMPRESSION DES DIFFERENTES DONNEES *)
                            MargeHaut, MargeBas : Real;           (* MARGES DE LA FEUILLE D'ETIQUETTES *)
                            MargeGauche, MargeDroite : Real;      (* MARGES DE LA FEUILLE D'ETIQUETTES *)
                            NbParLigne, NbParColonne : Byte;      (* DISPOSITION DES ETIQUETTES SUR LA FEUILLE *)
                            PlanEtiquettes : tPlanEtiquettes;     (* IMPLANTATION DES ETIQUETTES SUR LA FEUILLE *)
                            ChampsListing : tChamps;              (* TABLEAU DES CHAMPS A IMPRIMER SUR LE LISTING *)
                            ChampsChercher : tChamps;             (* TABLEAU DES CHAMPS OU EFFECTUER UNE RECHERCHE *)
                            Chercher : Array [0..60] of Char;     (* EXTRAIT DE CHAINE A RECHERCHER *)
                            Imprimante : pImprimante;             (* MODULE D'IMPRESSION *)
                            Modification : Boolean;               (* INDIQUE S'IL Y A EU DES MODIFICATIONS *)
                            ModificationOptions : Boolean;        (* INDIQUE SI LES OPTIONS ONT ETE MODIFIEES *)
                            Ctl_EnvoiDDE : pButton;               (* BOUTON D'ENVOI DES DONNEES AU CLIENT DDE *)
                            EnvoiManuel : Boolean;                (* INDIQUE SI ENVOI MANUEL DES DONNEES AU CLIENT DDE *)
                            EnvoiPressePapier : Boolean;          (* INDIQUE SI DONNEES A ENVOYER AU PRESSE-PAPIER *)
                            HandleClient : hWnd;                  (* HANDLE DE FENETRE DE L'APPLICATION CLIENT *)
                            HandleDonnees : tHandle;              (* HANDLE DU BLOC MEMOIRE DES DONNEES TRANSMISES *)
                            AtomeRequete : tAtom;                 (* ATOME DE RUBRIQUE DE LA REQUETE DDE *)
                            Separateur : Array [0..1] of Char;    (* SEPARATEUR DE CHAMPS PAR DEFAUT DE WINDOWS *)
                            Constructor INIT (ApplicationParent : pWindowsObject; Titre : pChar);
                               (* DIMENSIONS DE LA FENETRE, CHARGEMENT DU MENU, CONSTRUCTION DES CONTROLES ENFANTS *)
                            Procedure GETWINDOWCLASS (var aWndClass : tWndClass); virtual;
                               (* DEFINITION DE L'ICONE DE CLASSE DU PROGRAMME *)
                            Procedure CHARGEMENT_OPTIONS;
                               (* CHARGEMENT DES OPTIONS CONTENUES DANS LE FICHIER ADRESSES.INI *)
                            Procedure SAUVEGARDE_OPTIONS;
                               (* SAUVEGARDE DES OPTIONS DANS LE FICHIER ADRESSES.INI *)
                            Procedure MESSAGE_ERREUR_FICHIER (n : Word);
                               (* AFFICHAGE D'UN MESSAGE D'ERREUR DE MANIPULATION DU FICHIER ADRESSES.DTA *)
                            Procedure MESSAGE_ERREUR_MEMOIRE (n : Word);
                               (* MESSAGE D'ERREUR FATALE D'ALLOCATION DE MEMOIRE *)
                            Function CREATION_FICHIER : Boolean;
                               (* CREATION DU FICHIER ADRESSES.DTA *)
                            Function OUVERTURE_FICHIER : Boolean;
                               (* OUVERTURE DU FICHIER ADRESSES.DTA *)
                            Function LECTURE_FICHIER : Boolean;
                               (* LECTURE DU FICHIER ADRESSES.DTA *)
                            Function ECRITURE_FICHIER : Boolean;
                               (* ECRITURE DU FICHIER ADRESSES.DTA *)
                            Function FERMETURE_FICHIER : Boolean;
                               (* FERMETURE DU FICHIER ADRESSES.DTA *)
                            Procedure CHARGEMENT_DONNEES_PERS;
                               (* CHARGEMENT DES DONNEES CONTENUES DANS LE FICHIER ADRESSES.DTA *)
                            Function SAUVEGARDE_DONNEES_PERS : Boolean;
                               (* ENREGISTREMENT DES DONNEES PERSONNELLES DANS LE FICHIER ADRESSES.DTA *)
                            Procedure SETUPWINDOW; virtual;
                               (* CHARGEMENT DU FICHIER D'ADRESSES, INITIALISATION DES CHAMPS ET DES CONTROLES ENFANTS *)
                            Procedure PAINT (PaintDC : hDC; var PaintInfo : tPaintStruct); virtual;
                               (* AFFICHAGE DES DONNEES DE LA PERSONNE AYANT LE FOCUS DANS LA BOITE LISTE *)
                            Procedure WMCOMMAND (var Msg : tMessage); virtual wm_First + wm_Command;
                               (* RECEPTION DES MESSAGES DE NOTIFICATION EMANANT DE LA BOITE LISTE *)
                            Procedure TRI_LISTE_DONNEES_PERS;
                               (* TRI DE LA LISTE DES DONNEES PERSONNELLES SELON LE CRITERE COURANT *)
                            Function POINTEUR_CORRESPONDANT_NOM_PRENOM (Chaine : pChar) : pListeDonneesPers;
                               (* RETOURNE L'ELEMENT DE LISTE CHAINEE CORRESPONDANT A UN NOM ET UN PRENOM *)
                            Procedure CONSTRUCTION_GROUPE_NOM_PRENOM (p : pListeDonneesPers; NomPrenom : pChar);
                               (* CONSTRUCTION D'UN GROUPE NOM+PRENOM *)
                            Function LECTURE_SELECTIONS : Word;
                               (* DANS LA LISTE CHAINEE, SELECTION DES ELEMENTS DE LA BOITE LISTE SELECTIONNES *)
                            Procedure ECRITURE_SELECTIONS;
                               (* DANS LA BOITE LISTE, SELECTION DES ELEMENTS DE LA LISTE CHAINEE SELECTIONNES *)
                            Procedure MISE_A_JOUR_BOITE_LISTE;
                               (* MISE A JOUR DU CONTENU DE LA BOITE LISTE *)
                            Function DDE_TOUTES : pChaineDDE;
                               (* SELECTION DE TOUTES LES FICHES POUR ENVOYER AU CLIENT DDE *)
                            Function DDE_MANUELLEMENT : pChaineDDE;
                               (* CONSTRUCTION DE LA CHAINE DE DONNEES AVEC LES FICHES SELECTIONNEES MANUELLEMENT *)
                            Function DDE_AUTOMATIQUE : pChaineDDE;
                               (* RECHERCHE AUTOMATIQUE DE FICHES POUR ENVOYER AU CLIENT DDE *)
                            Procedure ENVOI_DDE_PRESSE_PAPIER (Requete : Byte);
                               (* ENVOI DES DONNEES DANS LE PRESSE-PAOPIER ET D'UN ACCUSE DE RECEPTION *)
                            Procedure ENVOI_DDE_REQUETE (Requete : Byte);
                               (* ENVOI DES DONNEES DDE VIA UN MESSAGE wm_DDE_Data *)
                            Procedure IDENVOIDDE (var Msg : tMessage); virtual id_First + id_EnvoiDDE;
                               (* ENVOI MANUEL DES DONNEES SELECTIONNEES AU CLIENT DDE *)
                            Procedure WMDDEINITIATE (var Msg : tMessage); virtual wm_First + wm_DDE_Initiate;
                               (* APPEL DDE D'UNE APPLICATION CLIENT *)
                            Procedure WMDDEPOKE (var Msg : tMessage); virtual wm_First + wm_DDE_Poke;
                               (* RECEPTION DE LA LISTE DES CHAMPS OU DE LA SELECTION DESIRES PAR L'APPLICATION CLIENT *)
                            Procedure WMDDEREQUEST (var Msg : tMessage); virtual wm_First + wm_DDE_Request;
                               (* REPONSE A LA REQUETE DDE DE L'APPLICATION CLIENT *)
                            Procedure WMDDEACK (var Msg : tMessage); virtual wm_First + wm_DDE_ACK;
                               (* RECEPTION D'UN ACCUSE DE RECEPTION DES DONNEES DE LA REQUETE *)
                            Procedure WMDDETERMINATE (var Msg : tMessage); virtual wm_First + wm_DDE_Terminate;
                               (* FIN DE COMMUNICATION DDE AVEC L'APPLICATION CLIENT *)
                            Procedure IDAJOUTER (var Msg : tMessage); virtual id_First + id_Ajouter;
                               (* AJOUT D'UNE NOUVELLE PERSONNE DANS LA LISTE *)
                            Procedure IDMODIFIER (var Msg : tMessage); virtual id_First + id_Modifier;
                               (* MODIFICATION DES DONNEES PERSONNELLES DE LA PERSONNE COURANTE *)
                            Procedure IDSUPPRIMER (var Msg : tMessage); virtual id_First + id_Supprimer;
                               (* SUPPRESSION DE LA PERSONNE COURANTE *)
                            Procedure IDTRIER (var Msg : tMessage); virtual id_First + id_Trier;
                               (* TRI DE LA LISTE DES DONNEES PERSONNELLES *)
                            Function RECHERCHE (pDepart : pListeDonneesPers; MsgFin : Boolean) : pListeDonneesPers;
                               (* RECHERCHE DE L'OCCURENCE SUIVANTE D'UN L'EXTRAIT DE TEXTE *)
                            Procedure IDCHERCHER (var Msg : tMessage); virtual id_First + id_Chercher;
                               (* RECHERCHE D'UN EXTRAIT DE TEXTE DANS UN OU PLUSIEURS CHAMPS *)
                            Procedure IDCHERCHERSUIVANT (var Msg : tMessage); virtual id_First + id_ChercherSuivant;
                               (* RECHERCHE DE L'OCCURENCE SUIVANTE D'UN EXTRAIT DE CHAINE DANS UN OU PLUSIEURS CHAMPS *)
                            Procedure IDSELECTIONNERTOUT (var Msg : tMessage); virtual id_First + id_SelectionnerTout;
                               (* SELECTION DE TOUS LES ELEMENTS DE LA BOITE LISTE *)
                            Procedure IDDESELECTIONNERTOUT (var Msg : tMessage); virtual id_First + id_DeSelectionnerTout;
                               (* DESELECTION DE TOUS LES ELEMENTS DE LA BOITE LISTE *)
                            Procedure IDETIQUETTES (var Msg : tMessage); virtual id_First + id_Etiquettes;
                               (* IMPRESSION D'ETIQUETTES *)
                            Procedure IDLISTING (var Msg : tMessage); virtual id_First + id_Listing;
                               (* IMPRESSION D'UN LISTING DES FICHES SELECTIONNEES *)
                            Procedure IDPOLICES (var Msg : tMessage); virtual id_First + id_Polices;
                               (* AFFICHAGE DU MENU FLOTTANT DE MISE EN FORME DES DONNEES LORS DE L'IMPRESSION *)
                            Procedure IDQUITTER (var Msg : tMessage); virtual id_First + id_Quitter;
                               (* ACTIVATION DU BOUTON "QUITTER" : FIN DE PROGRAMME *)
                            Procedure CMAJOUTER (var Msg : tMessage); virtual cm_First + cm_Ajouter;
                               (* AJOUT D'UNE NOUVELLE PERSONNE DANS LA LISTE *)
                            Procedure CMMODIFIER (var Msg : tMessage); virtual cm_First + cm_Modifier;
                               (* MODIFICATION DES DONNEES PERSONNELLES DE LA PERSONNE COURANTE *)
                            Procedure CMSUPPRIMER (var Msg : tMessage); virtual cm_First + cm_Supprimer;
                               (* SUPPRESSION DE LA PERSONNE COURANTE *)
                            Procedure CMTRIER (var Msg : tMessage); virtual cm_First + cm_Trier;
                               (* TRI DE LA LISTE DES DONNEES PERSONNELLES *)
                            Procedure CMCHERCHER (var Msg : tMessage); virtual cm_First + cm_Chercher;
                               (* RECHERCHE D'UN EXTRAIT DE TEXTE DANS UN OU PLUSIEURS CHAMPS *)
                            Procedure CMCHERCHERSUIVANT (var Msg : tMessage); virtual cm_First + cm_ChercherSuivant;
                               (* RECHERCHE DE L'OCCURENCE SUIVANTE D'UN EXTRAIT DE TEXTE DANS UN OU PLUSIEURS CHAMPS *)
                            Procedure CMLISTING (var Msg : tMessage); virtual cm_First + cm_Listing;
                               (* ACTIVATION DU MENU "COMMANDES/LISTING" *)
                            Procedure CMETIQUETTES (var Msg : tMessage); virtual cm_First + cm_Etiquettes;
                               (* ACTIVATION DU MENU "COMMANDES/ETIQUETTES" *)
                            Procedure CMQUITTER (var Msg : tMessage); virtual cm_First + cm_Quitter;
                               (* ACTIVATION DU MENU "COMMANDES/QUITTER" *)
                            Procedure STYLE_TEXTE (Id : Word);
                               (* DIALOGUE WINDOWS 3.1 DE CHOIX DE LA POLICE ET DE LA MISE EN FORME D'UN CHAMP *)
                            Procedure CMPOLICEFORMULE (var Msg : tMessage); virtual cm_First + cm_PoliceFormule;
                               (* DEFINITION DE LA MISE EN FORME DE LA FORMULE D'INTRODUCTION *)
                            Procedure CMPOLICENOM (var Msg : tMessage); virtual cm_First + cm_PoliceNom;
                               (* DEFINITION DE LA MISE EN FORME DU NOM *)
                            Procedure CMPOLICEPRENOM (var Msg : tMessage); virtual cm_First + cm_PolicePrenom;
                               (* DEFINITION DE LA MISE EN FORME DU PRENOM *)
                            Procedure CMPOLICERUE (var Msg : tMessage); virtual cm_First + cm_PoliceRue;
                               (* DEFINITION DE LA MISE EN FORME DU NOM DE RUE *)
                            Procedure CMPOLICECP (var Msg : tMessage); virtual cm_First + cm_PoliceCP;
                               (* DEFINITION DE LA MISE EN FORME DU CODE POSTAL *)
                            Procedure CMPOLICELOCALITE (var Msg : tMessage); virtual cm_First + cm_PoliceLocalite;
                               (* DEFINITION DE LA MISE EN FORME DU NOM DE LOCALITE *)
                            Procedure CMPOLICETELPRIVE (var Msg : tMessage); virtual cm_First + cm_PoliceTelPrive;
                               (* DEFINITION DE LA MISE EN FORME DU N DE TELEPHONE PRIVE *)
                            Procedure CMPOLICEFAXPRIVE (var Msg : tMessage); virtual cm_First + cm_PoliceFaxPrive;
                               (* DEFINITION DE LA MISE EN FORME DU N DE FAX PRIVE *)
                            Procedure CMPOLICETELBUREAU (var Msg : tMessage); virtual cm_First + cm_PoliceTelBureau;
                               (* DEFINITION DE LA MISE EN FORME DU N DE TELEPHONE AU BUREAU *)
                            Procedure CMPOLICEFAXBUREAU (var Msg : tMessage); virtual cm_First + cm_PoliceFaxBureau;
                               (* DEFINITION DE LA MISE EN FORME DU N DE FAX AU BUREAU *)
                            Procedure CMPOLICEEMAIL (var Msg : tMessage); virtual cm_First + cm_PoliceEMail;
                               (* DEFINITION DE LA MISE EN FORME L'ADRESSE E-MAIL *)
                            Procedure CMPOLICEREMARQUE (var Msg : tMessage); virtual cm_First + cm_PoliceRemarque;
                               (* DEFINITION DE LA MISE EN FORME DE LA REMARQUE FACULTATIVE *)
                            Procedure CMPOLICEAPERCU (var Msg : tMessage); virtual cm_First + cm_PoliceApercu;
                               (* AFFICHAGE DE L'APERCU DES POLICES DE CARACTERES *)
                            Procedure CMCOULEURSDEFAUT (var Msg : tMessage); virtual cm_First + cm_CouleursDefaut;
                               (* COCHAGE OU DECOCHAGE DU MENU D'UTILISATION DES COULEURS PAR DEFAUT *)
                            Procedure COULEUR_ELEMENT (Id : Word);
                               (* DIALOGUE WINDOWS 3.1 DE CHOIX DE LA COULEUR D'UN ELEMENT AFFICHE *)
                            Procedure CMCOULEURFOND (var Msg : tMessage); virtual cm_First + cm_CouleurFond;
                               (* MODIFICATION DE LA COULEUR DE FOND DE LA FENETRE *)
                            Procedure CMCOULEURTITRES (var Msg : tMessage); virtual cm_First + cm_CouleurTitres;
                               (* MODIFICATION DE LA COULEUR DES TITRES DE CHAMPS *)
                            Procedure CMCOULEURFORMULE (var Msg : tMessage); virtual cm_First + cm_CouleurFormule;
                               (* MODIFICATION DE LA COULEUR DU CHAMP Formule *)
                            Procedure CMCOULEURNOM (var Msg : tMessage); virtual cm_First + cm_CouleurNom;
                               (* MODIFICATION DE LA COULEUR DU CHAMP Nom *)
                            Procedure CMCOULEURPRENOM (var Msg : tMessage); virtual cm_First + cm_CouleurPrenom;
                               (* MODIFICATION DE LA COULEUR DU CHAMP Prenom *)
                            Procedure CMCOULEURRUE (var Msg : tMessage); virtual cm_First + cm_CouleurRue;
                               (* MODIFICATION DE LA COULEUR DU CHAMP Rue *)
                            Procedure CMCOULEURCP (var Msg : tMessage); virtual cm_First + cm_CouleurCP;
                               (* MODIFICATION DE LA COULEUR DU CHAMP CP *)
                            Procedure CMCOULEURLOCALITE (var Msg : tMessage); virtual cm_First + cm_CouleurLocalite;
                               (* MODIFICATION DE LA COULEUR DU CHAMP Localite *)
                            Procedure CMCOULEURTELPRIVE (var Msg : tMessage); virtual cm_First + cm_CouleurTelPrive;
                               (* MODIFICATION DE LA COULEUR DU CHAMP TelPrive *)
                            Procedure CMCOULEURFAXPRIVE (var Msg : tMessage); virtual cm_First + cm_CouleurFaxPrive;
                               (* MODIFICATION DE LA COULEUR DU CHAMP FaxPrive *)
                            Procedure CMCOULEURTELBUREAU (var Msg : tMessage); virtual cm_First + cm_CouleurTelBureau;
                               (* MODIFICATION DE LA COULEUR DU CHAMP TelBureau *)
                            Procedure CMCOULEURFAXBUREAU (var Msg : tMessage); virtual cm_First + cm_CouleurFaxBureau;
                               (* MODIFICATION DE LA COULEUR DU CHAMP FaxBureau *)
                            Procedure CMCOULEUREMAIL (var Msg : tMessage); virtual cm_First + cm_CouleurEMail;
                               (* MODIFICATION DE LA COULEUR DU CHAMP eMail *)
                            Procedure CMCOULEURREMARQUE (var Msg : tMessage); virtual cm_First + cm_CouleurRemarque;
                               (* MODIFICATION DE LA COULEUR DU CHAMP Remarque *)
                            Procedure CMAPROPOS (var Msg : tMessage); virtual cm_First + cm_APropos;
                               (* AFFICHAGE DU DIALOGUE "A PROPOS DE" *)
                            Function CANCLOSE : Boolean; virtual;
                               (* SAUVEGARDE EVENTUELLE DES OPTIONS ET DE LA LISTE DES DONNEES PERSONNELLES *)
                            Destructor DONE; virtual;
                               (* DESALLOCATION DES VARIABLES DYNAMIQUES *)
                          end;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                  VARIABLES GLOBALES                                                    *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Var Programme : tProgramme;   (* PROGRAMME PRINCIPAL *)

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                            FONCTION DE GESTION DU TAS                                                *)
(* -------------------------------------------------------------------------------------------------------------------- *)

{$F+}
Function ERREUR_ALLOCATION (Taille : Word) : Integer;
(* FORCE LES PROCEDURES D'ALLOCATION DE MEMOIRE DYNAMIQUE A RENVOYER nil SI ERREUR *)
Begin
  ERREUR_ALLOCATION:=1;
End;
{$F-}

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                    COMPARAISON DE DEUX STRUCTURES QUELCONQUES                                        *)
(* -------------------------------------------------------------------------------------------------------------------- *)

Function COMPARE (d1, d2 : pByte; Taille : Word) : Byte;
(* COMPARE DEUX STRUCTURES ET RETOURNE : 0 SI ELLES SONT EGALES, 1 SI d1 > d2, 2 SI d2 > d1 *)
Var i : Word;          (* INDICE *)
    Resultat : Byte;   (* RESULTAT DE L'OPERATION *)
Begin
  i:=1; Resultat:=0;
  while (i <= Taille) and (Resultat = 0) do
    if d1^ > d2^
       then
         Resultat:=1
       else
         if d1^ < d2^
            then
              Resultat:=2
            else
              begin
                Inc(i); Inc(d1); Inc(d2);
              end;
  COMPARE:=Resultat;
End;

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                          METHODES DE L'OBJET tImprimante                                             *)
(* -------------------------------------------------------------------------------------------------------------------- *)

Constructor tImprimante.INIT;
(* CREATION DU CONTEXTE DE PERIPHERIQUE D'IMPRESSION *)
Var c : Array [0..255] of Char;              (* CHAINE "device=" DANS LE FICHIER WIN.INI *)
    Section, Texte : Array [0..7] of Char;   (* ELEMENTS DE LA TABLE DE CHAINES *)
    NomDriver, NomDevice, NomPort : pChar;   (* NOMS DU DRIVER, DU PERIPHERIQUE ET DU PORT DE SORTIE *)
Begin
  tObject.INIT;
  (* LECTURE DE L'IMPRIMANTE DECLAREE DANS LE FICHIER WIN.INI *)
  LoadString(hInstance,ini_SectionWinIni,Section,SizeOf(Section));
  LoadString(hInstance,ini_EntreeWinIni,Texte,SizeOf(Texte));
  GetProfileString(Section,Texte,',,',c,SizeOf(c));
  NomDevice:=c;
  NomDriver:=StrPos(c,','); NomDriver[0]:=#0; Inc(NomDriver);
  NomPort:=StrPos(NomDriver,','); NomPort[0]:=#0; Inc(NomPort);
  (* CREATION DU CONTEXTE DE PERIPHERIQUE *)
  DC:=CreateDC(NomDriver,NomDevice,NomPort,nil);
  (* CALCUL DU NOMBRE DE PIXELS PAR POUCE *)
  if DC <> 0 then dy:=GetDeviceCaps(DC,LogPixelsY);
End;

Function tImprimante.MESSAGE_ERREUR_IMPRIMANTE (nTitre, nTexte : Word) : Boolean;
(* MESSAGE D'ERREUR D'IMPRIMANTE - RENVOIE true S'IL FAUT REESSAYER *)
Var Texte : Array [0..80] of Char;   (* MESSAGE D'ERREUR *)
    Titre : Array [0..19] of Char;   (* TITRE DE LA BOITE MESSAGE *)
Begin
  LoadString(hInstance,nTexte,Texte,SizeOf(Texte));
  LoadString(hInstance,nTitre,Titre,SizeOf(Titre));
  MESSAGE_ERREUR_IMPRIMANTE:=(MessageBox(GetFocus,Texte,Titre,mb_IconQuestion or mb_YesNoCancel) = id_Yes);
End;

Procedure tImprimante.INITIALISATION_FONTES (Styles : pStyles);
(* CREATION DES FONTES NECESSAIRES A L'IMPRESSION *)
Var AncienneFonte : hFont;        (* ANCIENNE FONTE DANS LE DC *)
    MesuresTexte : tTextMetric;   (* MESURES DE FONTE *)
    n1, n2 : Word;                (* INDICES DANS LE TABLEAU DES FONTES *)
          Function FONTE_IDENTIQUE (n1, n2 : Integer) : Boolean;
          (* INDIQUE SI DEUX FONTES LOGIQUES SONT IDENTIQUES *)
          Begin
{
            FONTE_IDENTIQUE:=(Styles^[n1].Taille = Styles^[n2].Taille) and
                             (StrComp(Styles^[n1].Fonte.lfFaceName,Styles^[n2].Fonte.lfFaceName) = 0) and
                             (Styles^[n1].Fonte.lfWeight = Styles^[n2].Fonte.lfWeight) and
                             (Styles^[n1].Fonte.lfItalic = Styles^[n2].Fonte.lfItalic) and
                             (Styles^[n1].Fonte.lfUnderline = Styles^[n2].Fonte.lfUnderline) and
                             (Styles^[n1].Fonte.lfStrikeOut = Styles^[n2].Fonte.lfStrikeOut) and
                             (Styles^[n1].Fonte.lfWidth = Styles^[n2].Fonte.lfWidth) and
                             (Styles^[n1].Fonte.lfEscapement = Styles^[n2].Fonte.lfEscapement) and
                             (Styles^[n1].Fonte.lfOrientation = Styles^[n2].Fonte.lfOrientation) and
                             (Styles^[n1].Fonte.lfCharSet = Styles^[n2].Fonte.lfCharSet) and
                             (Styles^[n1].Fonte.lfOutPrecision = Styles^[n2].Fonte.lfOutPrecision) and
                             (Styles^[n1].Fonte.lfClipPrecision = Styles^[n2].Fonte.lfClipPrecision) and
                             (Styles^[n1].Fonte.lfQuality = Styles^[n2].Fonte.lfQuality) and
                             (Styles^[n1].Fonte.lfPitchAndFamily = Styles^[n2].Fonte.lfPitchAndFamily);
}
            FONTE_IDENTIQUE:=(COMPARE(@Styles^[n1],@Styles^[n2],SizeOf(Styles^[n1]))=0);
          End;
Begin
  for n1:=id_Formule to id_Remarque do Fontes[n1]:=0;
  with Styles^[id_Formule] do
    begin
      Fonte.lfHeight:=-MulDiv(Taille,dy,9);
      Fontes[id_Formule]:=CreateFontIndirect(Fonte);
    end;
  for n1:=id_Nom to id_Remarque do with Styles^[n1] do
    begin
      (* RECHERCHE D'UNE FONTE IDENTIQUE DEJA CREEE *)
      n2:=id_Formule;
      while n2 < n1 do
        if FONTE_IDENTIQUE(n2,n1)
           then   (* LES FONTES SONT IDENTIQUES : MEME HANDLE *)
             begin
               Fontes[n1]:=Fontes[n2];
               n2:=id_Remarque;   (* FIN DE BOUCLE *)
             end
           else
             Inc(n2);
      if Fontes[n1] = 0
         then   (* PAS DE FONTE IDENTIQUE DEJA CREEE : LA CREER *)
           begin
             Fonte.lfHeight:=-MulDiv(Taille,dy,9);
             Fontes[n1]:=CreateFontIndirect(Fonte);
           end;
    end;
  (* CALCUL DE LA HAUTEUR DE LA FONTE SYSTEME *)
  GetTextMetrics(DC,MesuresTexte);
  with MesuresTexte do hTitres:=tmHeight + tmExternalLeading;
  (* CALCUL DES HAUTEURS DES DIFFERENTES LIGNES *)
  AncienneFonte:=SelectObject(DC,Fontes[id_Formule]);
  GetTextMetrics(DC,MesuresTexte);
  with MesuresTexte do
    Hauteurs[id_Nom]:=tmHeight + tmExternalLeading;
  SelectObject(DC,Fontes[id_Nom]);
  GetTextMetrics(DC,MesuresTexte);
  with MesuresTexte do
    if Hauteurs[id_Nom] < (tmHeight + tmExternalLeading) then Hauteurs[id_Nom]:=tmHeight + tmExternalLeading;
  SelectObject(DC,Fontes[id_Prenom]);
  GetTextMetrics(DC,MesuresTexte);
  with MesuresTexte do
    if Hauteurs[id_Nom] < (tmHeight + tmExternalLeading) then Hauteurs[id_Nom]:=tmHeight + tmExternalLeading;
  SelectObject(DC,Fontes[id_Rue]);
  GetTextMetrics(DC,MesuresTexte);
  with MesuresTexte do
    Hauteurs[id_Rue]:=tmHeight + tmExternalLeading;
  SelectObject(DC,Fontes[id_CP]);
  GetTextMetrics(DC,MesuresTexte);
  with MesuresTexte do
    Hauteurs[id_CP]:=tmHeight + tmExternalLeading;
  SelectObject(DC,Fontes[id_Localite]);
  GetTextMetrics(DC,MesuresTexte);
  with MesuresTexte do
    if Hauteurs[id_CP] < (tmHeight + tmExternalLeading) then Hauteurs[id_CP]:=tmHeight + tmExternalLeading;
  for n1:=id_TelPrive to id_Remarque do
    begin
      Hauteurs[n1]:=hTitres;
      SelectObject(DC,Fontes[n1]);
      GetTextMetrics(DC,MesuresTexte);
      with MesuresTexte do
        if Hauteurs[n1] < (tmHeight + tmExternalLeading) then Hauteurs[n1]:=tmHeight + tmExternalLeading;
    end;
  SelectObject(DC,AncienneFonte);
End;

Procedure tImprimante.INITIALISATION_ETIQUETTES (MargeHaut, MargeBas, MargeGauche, MargeDroite : pReal;
                                                 NbParLigne, NbParColonne : pByte; Styles : pStyles);
(* CALCULS ET CREATION DES FONTES NECESSAIRES A L'IMPRESSION D'ETIQUETTES *)
Var lPage, hPage : Integer;       (* TAILLE DE LA ZONE IMPRIMABLE DE LA PAGE (EN 1/100 MM) *)
    MargeV, MargeH : Integer;     (* MARGES PAR DEFAUT DE L'IMPRIMANTE *)
    AncienMode : Integer;         (* ANCIENNE UNITE D'ECRAN *)
    n1, n2 : Word;                (* INDICES DANS LE TABLEAU DES FONTES *)
Begin
  if DC <> 0
     then
       begin
         (* PASSAGE EN UNITES METRIQUES (1/100 MM) *)
         AncienMode:=SetMapMode(DC,mm_HiMetric);
         (* CALCUL DES MARGES PAR DEFAUT UTILISEES PAR L'IMPRIMANTE *)
         lPage:=100 * GetDeviceCaps(DC,HorzSize); MargeH:=(21000-lPage) div 2;
         hPage:=100 * GetDeviceCaps(DC,VertSize); MargeV:=(29700-hPage) div 2;
         (* ADAPTATION DES MARGES DEFINIES PAR L'UTILISATEUR EN CONSEQUENCE *)
         mH:=Round(MargeHaut^*100); mB:=Round(MargeBas^*100);
         mG:=Round(MargeGauche^*100); mD:=Round(MargeDroite^*100);
         if mH < MargeV then mH:=0 else Dec(mH,MargeV);
         if mB < MargeV then mB:=0 else Dec(mB,MargeV);
         if mG < MargeH then mG:=0 else Dec(mG,MargeH);
         if mD < MargeH then mD:=0 else Dec(mD,MargeH);
         (* CALCUL DES DIMENSIONS D'UNE ETIQUETTE *)
         lEtiq:=lPage div NbParLigne^; hEtiq:=hPage div NbParColonne^;
         (* CREATION DES FONTES ET CALCUL DE LA HAUTEUR DE CHAQUE LIGNE *)
         INITIALISATION_FONTES(Styles);
         (* CALCUL DE L'ESPACE ENTRE LE HAUT DE L'ETIQUETTE ET LA 1ERE LIGNE DE TEXTE *)
         h3:=(hEtiq-Hauteurs[id_Nom]-Hauteurs[id_Rue]-Hauteurs[id_CP]) div 2;
         h4:=(hEtiq-Hauteurs[id_Nom]-Hauteurs[id_Rue]-Hauteurs[id_Rue]-Hauteurs[id_CP]) div 2;
         (* RESTAURATION DU CONTEXTE DE PERIPHERIQUE *)
         SetMapMode(DC,AncienMode);
       end;
End;

Function tImprimante.IMPRIMER_ETIQUETTES (Plan : pPlanEtiquettes; Styles : pStyles) : Boolean;
(* IMPRESSION D'UNE PAGE D'ETIQUETTES *)
Var Continuer, Avorter : Boolean;        (* INDIQUENT SI LES OPERATIONS DOIVENT ETRE POURSUIVIES *)
    n : Word;                            (* INDICE DANS LA TABLE DE CHAINES *)
    AncienMode : Integer;                (* ANCIENNE UNITE D'ECRAN *)
    AncienAlignement : Word;             (* ANCIEN ALIGNEMENT DU TEXTE *)
    AncienneFonte : hFont;               (* ANCIENNE FONTE *)
    i, j : Byte;                         (* INDICES DANS LE TABLEAU DE DISPOSITION DES ETIQUETTES *)
    x, y : Integer;                      (* COORDONNEES HAUT/GAUCHE D'UNE ETIQUETTE *)
    hTexte : Integer;                    (* HAUTEUR A APPLIQUER ENTRE LE HAUT DE L'ETIQUETTE ET LA 1ERE LIGNE DE TEXTE *)
    lTexte : Integer;                    (* LARGEUR DU TEXTE DEJA IMPRIME SUR LA MEME LIGNE *)
    Ordonnee : Integer;                  (* HAUTEUR A APPLIQUER ENTRE LE HAUT DE L'ETIQUETTE ET LA LIGNE COURANTE *)
    ti : tDocInfo;                       (* INFORMATIONS UTILES A LA FONCTION StartDoc *)
    Titre : Array [0..10] of Char;       (* TITRE DE LA SESSION D'IMPRESSION *)
    CopieRue : Array [0..120] of Char;   (* COPIE DU CHAMP Rue *)
    Rue2 : pChar;                        (* 2EME LIGNE DU TEXTE MULTILIGNE DU CONTROLE Rue *)
    Erreur : Integer;                    (* RESULTAT DE FONCTION DE COMMANDE D'IMPRESSION *)
          Function VERIFICATION_HAUTEUR_TEXTE : Boolean;
          (* VERIFICATION DE LA HAUTEUR DE TEXTE PAR RAPPORT A LA HAUTEUR D'UNE ETIQUETTE *)
          Begin
            VERIFICATION_HAUTEUR_TEXTE:=true;
            if h3 < 0
               then   (* TOUTES LES ETIQUETTES VONT DEPASSER *)
                 begin
                   h3:=0; h4:=0;
                   VERIFICATION_HAUTEUR_TEXTE:=MESSAGE_ERREUR_IMPRIMANTE(eri_TitreHauteur,eri_Hauteur3);
                 end
               else
                 if h4 < 0
                    then   (* LES ETIQUETTES A 4 LIGNES VONT DEPASSER *)
                      begin
                        h4:=0;
                        VERIFICATION_HAUTEUR_TEXTE:=MESSAGE_ERREUR_IMPRIMANTE(eri_TitreHauteur,eri_Hauteur4);
                      end;
          End;
Begin
  if (DC <> 0) and VERIFICATION_HAUTEUR_TEXTE
     then
       begin
         (* STRUCTURE DE DEMARRAGE DE LA SESSION D'IMPRESSION *)
         LoadString(hInstance,st_SessionImpression,Titre,SizeOf(Titre));
         with ti do
           begin
             lpszDocName:=Titre;
             lpszOutput:=nil;
             cbSize:=(2*SizeOf(pChar) + SizeOf(Integer));
           end;
         (* DEMARRAGE DE LA SESSION D'IMPRESSION *)
         Continuer:=false; Avorter:=false;
         repeat
           if StartDoc(DC,ti) = sp_Error
              then   (* ERREUR *)
                Avorter:=not MESSAGE_ERREUR_IMPRIMANTE(eri_TitreImprimante,eri_InitialisationImprimante)
              else
                Continuer:=true;
         until Continuer or Avorter;
         if not Avorter
            then   (* PREPARATION DE L'IMPRIMANTE A LA RECEPTION DES DONNEES *)
              repeat
                if StartPage(DC) = 0
                   then   (* ERREUR *)
                     Avorter:=not MESSAGE_ERREUR_IMPRIMANTE(eri_TitreImprimante,eri_InitialisationImprimante)
                   else
                     Continuer:=true;
              until Continuer or Avorter;
         if not Avorter
            then   (* ECRITURE DES DONNEES SUR LES ETIQUETTES A IMPRIMER *)
              begin
                AncienMode:=SetMapMode(DC,mm_HiMetric);
                AncienAlignement:=SetTextAlign(DC,ta_Left or ta_BaseLine or ta_NoUpdateCP);
                AncienneFonte:=SelectObject(DC,Fontes[id_Formule]);
                for i:=1 to 17 do for j:=1 to 4 do with Plan^[i,j] do
                  if Adresse <> nil
                    then   (* ETIQUETTE A IMPRIMER *)
                      begin
                        x:=mG + lEtiq * (j-1) + 5;
                        y:=mH + hEtiq * (i-1);
                        with Adresse^.DonneesPers do
                          begin
                            (* DIVISION DE LA RUE EN 2 LIGNES ET DETERMINATION DE LA HAUTEUR DE LA 1ERE LIGNE DE TEXTE *)
                            StrCopy(CopieRue,Rue);
                            Rue2:=StrPos(CopieRue,#13);
                            if Rue2 <> nil
                               then   (* LES DEUX LIGNES DU CONTROLE SONT UTILISEES *)
                                 begin
                                   hTexte:=h4;
                                   Rue2[0]:=#0;   (* MARQUE DE FIN DE LA 1ERE LIGNE DE TEXTE *)
                                   Inc(Rue2,2);   (* ADAPTATION DE L'ADRESSE DE LA 2EME LIGNE *)
                                 end
                               else   (* UNE SEULE LIGNE *)
                                 hTexte:=h3;
                            (* FORMULE, NOM ET PRENOM *)
                            lTexte:=0;
                            if StrLen(Formule) > 0
                               then
                                 begin
                                   SelectObject(DC,Fontes[id_Formule]);
                                   SetTextColor(DC,Styles^[id_Formule].Couleur);
                                   TextOut(DC,x,-(y+hTexte+Hauteurs[id_Nom]),Formule,StrLen(Formule));
                                   lTexte:=LoWord(GetTextExtent(DC,Formule,StrLen(Formule))) + LoWord(GetTextExtent(DC,' ',1));
                                 end;
                            SelectObject(DC,Fontes[id_Nom]);
                            SetTextColor(DC,Styles^[id_Nom].Couleur);
                            TextOut(DC,x+lTexte,-(y+hTexte+Hauteurs[id_Nom]),Nom,StrLen(Nom));
                            lTexte:=lTexte + LoWord(GetTextExtent(DC,Nom,StrLen(Nom))) + LoWord(GetTextExtent(DC,' ',1));
                            if StrLen(Prenom) > 0
                               then
                                 begin
                                   SelectObject(DC,Fontes[id_Prenom]);
                                   SetTextColor(DC,Styles^[id_Prenom].Couleur);
                                   TextOut(DC,x+lTexte,-(y+hTexte+Hauteurs[id_Nom]),Prenom,StrLen(Prenom));
                                 end;
                            (* RUE *)
                            lTexte:=0; Ordonnee:=-(y+hTexte+Hauteurs[id_Nom]+Hauteurs[id_Rue]);
                            if StrLen(Rue) > 0
                               then
                                 begin
                                   SelectObject(DC,Fontes[id_Rue]);
                                   SetTextColor(DC,Styles^[id_Rue].Couleur);
                                   TextOut(DC,x,Ordonnee,CopieRue,StrLen(CopieRue));
                                 end;
                            if Rue2 <> nil
                               then
                                 begin
                                   Dec(Ordonnee,Hauteurs[id_Rue]);
                                   TextOut(DC,x,Ordonnee,Rue2,StrLen(Rue2));
                                 end;
                            (* CODE POSTAL ET LOCALITE *)
                            lTexte:=0;
                            if StrLen(CP) > 0
                               then
                                 begin
                                   SelectObject(DC,Fontes[id_CP]);
                                   SetTextColor(DC,Styles^[id_CP].Couleur);
                                   TextOut(DC,x,Ordonnee-Hauteurs[id_CP],CP,StrLen(CP));
                                   lTexte:=LoWord(GetTextExtent(DC,CP,StrLen(CP))) + LoWord(GetTextExtent(DC,' ',1));
                                 end;
                            if StrLen(Localite) > 0
                               then
                                 begin
                                   SelectObject(DC,Fontes[id_Localite]);
                                   SetTextColor(DC,Styles^[id_Localite].Couleur);
                                   TextOut(DC,x+lTexte,Ordonnee-Hauteurs[id_CP],Localite,StrLen(Localite));
                                 end;
                          end;
                      end;
                (* RESTAURATION DU CONTEXTE DE PERIPHERIQUE *)
                SetMapMode(DC,AncienMode);
                SetTextAlign(DC,AncienAlignement);
                SelectObject(DC,AncienneFonte);
              end;
         if not Avorter
            then   (* ENVOI DE LA PAGE A L'IMPRIMANTE *)
              repeat
                Erreur:=EndPage(DC);
                if (Erreur = sp_Error) or (Erreur = sp_OutOfDisk) or (Erreur = sp_OutOfMemory)
                   then   (* ERREUR MATERIELLE *)
                     begin
                       case Erreur of
                         sp_Error : n:=eri_Impression;
                         sp_OutOfDisk : n:=eri_EspaceDisque;
                         sp_OutOfMemory : n:=eri_MemoireInsuffisante;
                       end;
                       Avorter:=not MESSAGE_ERREUR_IMPRIMANTE(eri_TitreImprimante,n)
                     end
                   else
                     if Erreur < 0
                        then   (* FIN D'IMPRESSION COMMANDEE PAR L'UTILISATEUR *)
                          Avorter:=true
                        else   (* PAS D'ERREUR *)
                          Continuer:=true;
              until Continuer or Avorter;
         (* FIN DE LA SESSION D'IMPRESSION *)
         if Avorter then AbortDoc(DC) else EndDoc(DC);
       end
     else   (* LE CONTEXTE DE PERIPHERIQUE N'A PAS ETE CORRECTEMENT CREE *)
       Avorter:=true;
  IMPRIMER_ETIQUETTES:=not Avorter;
End;

Procedure tImprimante.INITIALISATION_LISTING (Styles : pStyles; Champs : pChamps);
(* CALCULS ET CREATION DES FONTES NECESSAIRES A L'IMPRESSION DU LISTING *)
Var AncienMode : Integer;       (* ANCIENNE UNITE D'ECRAN *)
    lPage : Integer;            (* HAUTEUR DE LA ZONE IMPRIMABLE *)
    HauteurElement : Integer;   (* HAUTEUR D'UN ELEMENT *)
    n : Word;                   (* INDICE *)
Begin
  if DC <> 0
     then
       begin
         (* PASSAGE EN UNITES METRIQUES (1/100 MM) *)
         AncienMode:=SetMapMode(DC,mm_HiMetric);
         (* CALCUL DES MARGES PAR DEFAUT UTILISEES PAR L'IMPRIMANTE *)
         mG:=(21000-(100*GetDeviceCaps(DC,HorzSize))) div 2;
         lPage:=100*GetDeviceCaps(DC,VertSize); mH:=(29700-lPage) div 2;
         (* CREATION DES FONTES ET CALCUL DE LA HAUTEUR DE CHAQUE LIGNE *)
         INITIALISATION_FONTES(Styles);
         (* CALCUL DU NOMBRE D'ELEMENTS IMPRIMABLES SUR UNE PAGE *)
         HauteurElement:=0;
         if (Champs^[id_Formule] = 1) or (Champs^[id_Nom] = 1) or (Champs^[id_Prenom] = 1)
            then
              Inc(HauteurElement,Hauteurs[id_Nom]);
         if Champs^[id_Rue] = 1 then Inc(HauteurElement,2*Hauteurs[id_Rue]);
         if (Champs^[id_CP] = 1) or (Champs^[id_Localite] = 1) then Inc(HauteurElement,Hauteurs[id_CP]);
         for n:=id_TelPrive to id_Remarque do if Champs^[n] = 1 then Inc(HauteurElement,Hauteurs[n]);
         Inc(HauteurElement,1000);   (* AJOUT DES ESPACEMENTS PAR RAPPORT AUX LIGNES HORIZONTALES *)
         if HauteurElement <> 0 then NbElements:=lPage div HauteurElement else NbElements:=0;
         (* RESTAURATION DU CONTEXTE DE PERIPHERIQUE *)
         SetMapMode(DC,AncienMode);
      end;
End;

Function tImprimante.IMPRIMER_LISTING (NbTotal : Word; Styles : pStyles; pTete : pListeDonneesPers;
                                       Champs : pChamps) : Boolean;
(* IMPRESSION DU LISTING COMPLET *)
Var Continuer, Avorter : Boolean;        (* INDIQUENT SI LES OPERATIONS DOIVENT ETRE POURSUIVIES *)
    p : pListeDonneesPers;               (* ELEMENT DE LA LISTE CHAINEE DES DONNEES PERSONNELLES *)
    n : Word;                            (* INDICE DANS LA TABLE DE CHAINES - NOMBRE D'ELEMENTS SUR LA PAGE *)
    nTotal : Word;                       (* NOMBRE D'ELEMENTS DEJA IMPRIMES *)
    i : Word;                            (* INDICE D'ELEMENT A IMPRIMER *)
    AncienMode : Integer;                (* ANCIENNE UNITE D'ECRAN *)
    AncienAlignement : Word;             (* ANCIEN ALIGNEMENT DU TEXTE *)
    AncienneFonte : hFont;               (* ANCIENNE FONTE *)
    AncienCrayon, Crayon : hPen;         (* ANCIEN CRAYON ET CRAYON DE DESSIN DES LIGNES SEPARATRICES *)
    x, y : Integer;                      (* COORDONNEES HAUT/GAUCHE D'UNE LIGNE HORIZONTALE *)
    hTexte : Integer;                    (* HAUTEUR A APPLIQUER ENTRE LA LIGNE HORIZONTALE ET LA LIGNE COURANTE *)
    lTexte : Integer;                    (* LARGEUR DU TEXTE DEJA IMPRIME SUR LA MEME LIGNE *)
    ti : tDocInfo;                       (* INFORMATIONS UTILES A LA FONCTION StartDoc *)
    Titre : Array [0..10] of Char;       (* TITRE DE LA SESSION D'IMPRESSION *)
    CopieRue : Array [0..120] of Char;   (* COPIE DU CHAMP Rue *)
    Rue2 : pChar;                        (* 2EME LIGNE DU TEXTE MULTILIGNE DU CONTROLE Rue *)
    c : Array [0..35] of Char;           (* ELEMENT DE LA TABLE DE CHAINES *)
    Erreur : Integer;                    (* RESULTAT DE FONCTION DE COMMANDE D'IMPRESSION *)
Begin
  if (DC <> 0) and (NbElements > 0)
     then
       begin
         (* STRUCTURE DE DEMARRAGE DE LA SESSION D'IMPRESSION *)
         LoadString(hInstance,st_SessionImpression,Titre,SizeOf(Titre));
         with ti do
           begin
             lpszDocName:=Titre;
             lpszOutput:=nil;
             cbSize:=(2*SizeOf(pChar) + SizeOf(Integer));
           end;
         (* INITIALISATION DU CONTEXTE D'IMPRESSION ET CREATION DES OUTILS DE DESSIN *)
         AncienMode:=SetMapMode(DC,mm_HiMetric);
         AncienAlignement:=SetTextAlign(DC,ta_Left or ta_BaseLine or ta_NoUpdateCP);
         AncienneFonte:=SelectObject(DC,Fontes[id_Formule]);
         Crayon:=CreatePen(ps_Solid,25,RGB(0,0,0));
         AncienCrayon:=SelectObject(DC,Crayon);
         (* DEMARRAGE DE LA SESSION D'IMPRESSION *)
         Continuer:=false; Avorter:=false;
         repeat
           if StartDoc(DC,ti) = sp_Error
              then   (* ERREUR *)
                Avorter:=not MESSAGE_ERREUR_IMPRIMANTE(eri_TitreImprimante,eri_InitialisationImprimante)
              else
                Continuer:=true;
         until Continuer or Avorter;
         if not Avorter
            then   (* BOUCLE GENERALE D'IMPRESSION *)
              begin
                n:=0; nTotal:=0; x:=mG+500; y:=mH+500;
                p:=pTete;
                while (p <> nil) and Continuer do
                  begin
                    if n = 0
                       then   (* DEBUT DE PAGE : PREPARATION DE L'IMPRIMANTE A LA RECEPTION DES DONNEES *)
                         begin
                           Continuer:=false;
                           repeat
                             if StartPage(DC) = 0
                                then   (* ERREUR *)
                                  Avorter:=not MESSAGE_ERREUR_IMPRIMANTE(eri_TitreImprimante,eri_InitialisationImprimante)
                                else
                                  Continuer:=true;
                           until Continuer or Avorter;
                         end;
                    if Continuer
                       then
                         begin
                           (* INITIALISATION DU CONTEXTE D'IMPRESSION *)
                           SetMapMode(DC,mm_HiMetric);
                           SetTextAlign(DC,ta_Left or ta_BaseLine or ta_NoUpdateCP);
                           SelectObject(DC,Crayon);
                           if p^.Selection then with p^.DonneesPers do
                             begin
                               Inc(n); Inc(nTotal);
                               (* FORMULE, NOM ET PRENOM *)
                               lTexte:=0; hTexte:=0;
                               if (Champs^[id_Formule] = 1) and (StrLen(Formule) > 0)
                                  then
                                    begin
                                      SelectObject(DC,Fontes[id_Formule]);
                                      SetTextColor(DC,Styles^[id_Formule].Couleur);
                                      TextOut(DC,x,-(y+Hauteurs[id_Nom]),Formule,StrLen(Formule));
                                      lTexte:=LoWord(GetTextExtent(DC,Formule,StrLen(Formule))) +
                                              LoWord(GetTextExtent(DC,' ',1));
                                      hTexte:=Hauteurs[id_Nom];
                                    end;
                               if (Champs^[id_Nom] = 1) and (StrLen(Nom) > 0)
                                  then
                                    begin
                                      SelectObject(DC,Fontes[id_Nom]);
                                      SetTextColor(DC,Styles^[id_Nom].Couleur);
                                      TextOut(DC,x+lTexte,-(y+Hauteurs[id_Nom]),Nom,StrLen(Nom));
                                      lTexte:=lTexte + LoWord(GetTextExtent(DC,Nom,StrLen(Nom))) +
                                              LoWord(GetTextExtent(DC,' ',1));
                                      hTexte:=Hauteurs[id_Nom];
                                    end;
                               if (Champs^[id_Prenom] = 1) and (StrLen(Prenom) > 0)
                                  then
                                    begin
                                      SelectObject(DC,Fontes[id_Prenom]);
                                      SetTextColor(DC,Styles^[id_Prenom].Couleur);
                                      TextOut(DC,x+lTexte,-(y+Hauteurs[id_Nom]),Prenom,StrLen(Prenom));
                                      hTexte:=Hauteurs[id_Nom];
                                    end;
                               (* RUE *)
                               if (Champs^[id_Rue] = 1) and (StrLen(Rue) > 0)
                                  then
                                    begin
                                      lTexte:=0; Inc(hTexte,Hauteurs[id_Rue]);
                                      (* DIVISION DE LA RUE EN SES DEUX LIGNES EVENTUELLES *)
                                      StrCopy(CopieRue,Rue);
                                      Rue2:=StrPos(CopieRue,#13);
                                      if Rue2 <> nil
                                         then   (* LES DEUX LIGNES DU CONTROLE SONT UTILISEES *)
                                           begin
                                             Rue2[0]:=#0;   (* MARQUE DE FIN DE LA 1ERE LIGNE DE TEXTE *)
                                             Inc(Rue2,2);   (* ADAPTATION DE L'ADRESSE DE LA 2EME LIGNE *)
                                           end;
                                      SelectObject(DC,Fontes[id_Rue]);
                                      SetTextColor(DC,Styles^[id_Rue].Couleur);
                                      TextOut(DC,x,-(y+hTexte),CopieRue,StrLen(CopieRue));
                                      if Rue2 <> nil
                                         then
                                           begin
                                             Inc(hTexte,Hauteurs[id_Rue]);
                                             TextOut(DC,x,-(y+hTexte),Rue2,StrLen(Rue2));
                                           end;
                                    end;
                               (* CODE POSTAL ET LOCALITE *)
                               if (Champs^[id_CP] = 1) or (Champs^[id_Localite] = 1) then Inc(hTexte,Hauteurs[id_CP]);
                               lTexte:=0;
                               if (Champs^[id_CP] = 1) and (StrLen(CP) > 0)
                                  then
                                    begin
                                      SelectObject(DC,Fontes[id_CP]);
                                      SetTextColor(DC,Styles^[id_CP].Couleur);
                                      TextOut(DC,x,-(y+hTexte),CP,StrLen(CP));
                                      lTexte:=LoWord(GetTextExtent(DC,CP,StrLen(CP))) + LoWord(GetTextExtent(DC,' ',1));
                                    end;
                               if (Champs^[id_Localite] = 1) and (StrLen(Localite) > 0)
                                  then
                                    begin
                                      SelectObject(DC,Fontes[id_Localite]);
                                      SetTextColor(DC,Styles^[id_Localite].Couleur);
                                      TextOut(DC,x+lTexte,-(y+hTexte),Localite,StrLen(Localite));
                                    end;
                               (* N DE TELEPHONE ET DE FAX *)
                               lTexte:=0;
                               if Champs^[id_TelPrive] = 1
                                  then
                                    begin
                                      Inc(htexte,Hauteurs[id_TelPrive]);
                                      SelectObject(DC,Fontes[id_TelPrive]);
                                      SetTextColor(DC,Styles^[id_TelPrive].Couleur);
                                      LoadString(hInstance,id_TelPrive,c,SizeOf(c));
                                      TextOut(DC,x,-(y+hTexte),c,StrLen(c));
                                      lTexte:=LoWord(GetTextExtent(DC,c,StrLen(c))) + LoWord(GetTextExtent(DC,' ',1));
                                      TextOut(DC,x+lTexte,-(y+hTexte),TelPrive,StrLen(TelPrive));
                                    end;
                               if Champs^[id_FaxPrive] = 1
                                  then
                                    begin
                                      Inc(htexte,Hauteurs[id_FaxPrive]);
                                      SelectObject(DC,Fontes[id_FaxPrive]);
                                      SetTextColor(DC,Styles^[id_FaxPrive].Couleur);
                                      LoadString(hInstance,id_FaxPrive,c,SizeOf(c));
                                      TextOut(DC,x,-(y+hTexte),c,StrLen(c));
                                      lTexte:=LoWord(GetTextExtent(DC,c,StrLen(c))) + LoWord(GetTextExtent(DC,' ',1));
                                      TextOut(DC,x+lTexte,-(y+hTexte),FaxPrive,StrLen(FaxPrive));
                                    end;
                               if Champs^[id_TelBureau] = 1
                                  then
                                    begin
                                      Inc(htexte,Hauteurs[id_TelBureau]);
                                      SelectObject(DC,Fontes[id_TelBureau]);
                                      SetTextColor(DC,Styles^[id_TelBureau].Couleur);
                                      LoadString(hInstance,id_TelBureau,c,SizeOf(c));
                                      TextOut(DC,x,-(y+hTexte),c,StrLen(c));
                                      lTexte:=LoWord(GetTextExtent(DC,c,StrLen(c))) + LoWord(GetTextExtent(DC,' ',1));
                                      TextOut(DC,x+lTexte,-(y+hTexte),TelBureau,StrLen(TelBureau));
                                    end;
                               if Champs^[id_FaxBureau] = 1
                                  then
                                    begin
                                      Inc(htexte,Hauteurs[id_FaxBureau]);
                                      SelectObject(DC,Fontes[id_FaxBureau]);
                                      SetTextColor(DC,Styles^[id_FaxBureau].Couleur);
                                      LoadString(hInstance,id_FaxBureau,c,SizeOf(c));
                                      TextOut(DC,x,-(y+hTexte),c,StrLen(c));
                                      lTexte:=LoWord(GetTextExtent(DC,c,StrLen(c))) + LoWord(GetTextExtent(DC,' ',1));
                                      TextOut(DC,x+lTexte,-(y+hTexte),FaxBureau,StrLen(FaxBureau));
                                    end;
                               (* E-MAIL *)
                               if Champs^[id_eMail] = 1
                                  then
                                    begin
                                      Inc(htexte,Hauteurs[id_eMail]);
                                      SelectObject(DC,Fontes[id_eMail]);
                                      SetTextColor(DC,Styles^[id_eMail].Couleur);
                                      LoadString(hInstance,id_eMail,c,SizeOf(c));
                                      TextOut(DC,x,-(y+hTexte),c,StrLen(c));
                                      lTexte:=LoWord(GetTextExtent(DC,c,StrLen(c))) + LoWord(GetTextExtent(DC,' ',1));
                                      TextOut(DC,x+lTexte,-(y+hTexte),eMail,StrLen(eMail));
                                    end;
                               (* REMARQUE *)
                               if Champs^[id_Remarque] = 1
                                  then
                                    begin
                                      Inc(htexte,Hauteurs[id_Remarque]);
                                      SelectObject(DC,Fontes[id_Remarque]);
                                      SetTextColor(DC,Styles^[id_Remarque].Couleur);
                                      LoadString(hInstance,id_Remarque,c,SizeOf(c));
                                      TextOut(DC,x,-(y+hTexte),c,StrLen(c));
                                      lTexte:=LoWord(GetTextExtent(DC,c,StrLen(c))) + LoWord(GetTextExtent(DC,' ',1));
                                      TextOut(DC,x+lTexte,-(y+hTexte),Remarque,StrLen(Remarque));
                                    end;
                               (* PREPARATION DE L'ELEMENT SUIVANT OU DE LA PAGE SUIVANTE *)
                               if (n = NbElements) or (nTotal = NbTotal)
                                  then   (* ON EST EN BAS DE PAGE  : ENVOI A L'IMPRIMANTE *)
                                    begin
                                      Continuer:=false;
                                      repeat
                                        Erreur:=EndPage(DC);
                                        if (Erreur = sp_Error) or (Erreur = sp_OutOfDisk) or (Erreur = sp_OutOfMemory)
                                           then   (* ERREUR MATERIELLE *)
                                             begin
                                               case Erreur of
                                                 sp_Error : n:=eri_Impression;
                                                 sp_OutOfDisk : n:=eri_EspaceDisque;
                                                 sp_OutOfMemory : n:=eri_MemoireInsuffisante;
                                               end;
                                               Avorter:=not MESSAGE_ERREUR_IMPRIMANTE(eri_TitreImprimante,n)
                                             end
                                           else
                                             if Erreur < 0
                                                then   (* FIN D'IMPRESSION COMMANDEE PAR L'UTILISATEUR *)
                                                  Avorter:=true
                                                else   (* PAS D'ERREUR *)
                                                  Continuer:=true;
                                      until Continuer or Avorter;
                                      (* PREPARATION D'UNE NOUVELLE PAGE *)
                                      n:=0; y:=mH+500;
                                    end
                                  else   (* LIGNE SEPARATRICE ET PREPARATION DE L'ELEMENT SUIVANT *)
                                    begin
                                      Inc(hTexte,500);
                                      MoveTo(DC,0,-(y+hTexte)); LineTo(DC,21000,-(y+hTexte));
                                      y:=y+hTexte+500;
                                    end;
                             end;
                         end;
                    p:=p^.pSuiv;
                  end;
              end;
         (* RESTAURATION DU CONTEXTE DE PERIPHERIQUE ET DESTRUCTION DES OUTILS DE DESSIN *)
         SetMapMode(DC,AncienMode);
         SetTextAlign(DC,AncienAlignement);
         SelectObject(DC,AncienneFonte);
         SelectObject(DC,AncienCrayon);
         DeleteObject(Crayon);
         (* FIN DE LA SESSION D'IMPRESSION *)
         if Avorter then AbortDoc(DC) else EndDoc(DC);
       end
     else   (* LE CONTEXTE DE PERIPHERIQUE N'A PAS ETE CORRECTEMENT CREE *)
       Avorter:=true;
  IMPRIMER_LISTING:=not Avorter;
End;

Destructor tImprimante.DONE;
(* DESTRUCTION DU CONTEXTE DE PERIPHERIQUE D'IMPRESSION ET DES FONTES *)
Var i : Word;
Begin
  for i:=id_Formule to id_Remarque do if Fontes[i] <> 0 then DeleteObject(Fontes[i]);
  if DC <> 0 then DeleteDC(DC);
  tObject.DONE;
End;

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                          METHODES DE L'OBJET tListePers                                              *)
(* -------------------------------------------------------------------------------------------------------------------- *)

Constructor tListePers.INIT (FenetreParent : pWindowsObject; Id, x, y, w, h : Integer);
(* DEFINITION DU STYLE DU CONTROLE *)
Begin
  tListBox.INIT(FenetreParent,Id,x,y,w,h);
  Attr.Style:=ws_Child or ws_Visible or ws_Border or ws_VScroll or ws_Group or ws_TabStop or
              lbs_Notify or lbs_MultipleSel or lbs_ExtendedSel or lbs_UseTabStops;
End;

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                         METHODES DE L'OBJET tDlgDemarrage                                            *)
(* -------------------------------------------------------------------------------------------------------------------- *)

Procedure tDlgDemarrage.SETUPWINDOW;
(* CENTRAGE DU DIALOGUE A L'ECRAN *)
Var r : tRect;        (* COORDONNEES DE LA FENETRE *)
    l, h : Integer;   (* LARGEUR ET HAUTEUR DE LA FENETRE *)
Begin
  tDialog.SETUPWINDOW;
  GetWindowRect(hWindow,r);
  with r do
    begin
      l:=Right-Left;
      h:=Bottom-Top;
    end;
  MoveWindow(hWindow,(GetSystemMetrics(sm_CXScreen)-l) div 2,(GetSystemMetrics(sm_CYScreen)-h) div 2,l,h,true);
End;

Procedure tDlgDemarrage.DEBUT;
(* AFFICHAGE DU DIALOGUE *)
Begin
  Show(sw_ShowNormal);
End;

Procedure tDlgDemarrage.FIN;
(* FERMETURE DU DIALOGUE *)
Begin
  CloseWindow;
End;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                         METHODES DE L'OBJET tDlgDonneesPers                                            *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Constructor tDlgDonneesPers.INIT (FenetreParent : pWindowsObject; NomDialogue : pChar; Pointeur : pDonneesPers);
(* PASSAGE DE L'ADRESSE DE L'ENREGISTREMENT DE DONNEES A MODIFIER *)
Begin
  tDialog.INIT(FenetreParent,NomDialogue);
  DonneesPers:=Pointeur;
End;

Procedure tDlgDonneesPers.SETUPWINDOW;
(* CENTRAGE A L'ECRAN ET INITIALISATION DES CONTROLES ENFANTS *)
Var r : tRect;        (* COORDONNEES DE LA FENETRE *)
    l, h : Integer;   (* LARGEUR ET HAUTEUR DE LA FENETRE *)
Begin
  tDialog.SETUPWINDOW;
  GetWindowRect(hWindow,r);
  with r do
    begin
      l:=Right-Left;
      h:=Bottom-Top;
    end;
  MoveWindow(hWindow,(GetSystemMetrics(sm_CXScreen)-l) div 2,(GetSystemMetrics(sm_CYScreen)-h) div 2,l,h,true);
  (* DEFINITION DES LONGUEURS DE TEXTE DES CONTROLES D'EDITION *)
  SendDlgItemMessage(hWindow,id_Formule,em_LimitText,30,0);
  SendDlgItemMessage(hWindow,id_Nom,em_LimitText,30,0);
  SendDlgItemMessage(hWindow,id_Prenom,em_LimitText,30,0);
  SendDlgItemMessage(hWindow,id_Rue,em_LimitText,120,0);
  SendDlgItemMessage(hWindow,id_CP,em_LimitText,6,0);
  SendDlgItemMessage(hWindow,id_Localite,em_LimitText,50,0);
  SendDlgItemMessage(hWindow,id_TelPrive,em_LimitText,20,0);
  SendDlgItemMessage(hWindow,id_FaxPrive,em_LimitText,20,0);
  SendDlgItemMessage(hWindow,id_TelBureau,em_LimitText,20,0);
  SendDlgItemMessage(hWindow,id_FaxBureau,em_LimitText,20,0);
  SendDlgItemMessage(hWindow,id_eMail,em_LimitText,50,0);
  SendDlgItemMessage(hWindow,id_Remarque,em_LimitText,50,0);
  (* CHARGEMENT DES VALEURS DES CONTROLES D'EDITION *)
  with DonneesPers^ do
    begin
      SendDlgItemMessage(hWindow,id_Formule,wm_SetText,0,LongInt(@Formule));
      SendDlgItemMessage(hWindow,id_Nom,wm_SetText,0,LongInt(@Nom));
      SendDlgItemMessage(hWindow,id_Prenom,wm_SetText,0,LongInt(@Prenom));
      SendDlgItemMessage(hWindow,id_Rue,wm_SetText,0,LongInt(@Rue));
      SendDlgItemMessage(hWindow,id_CP,wm_SetText,0,LongInt(@CP));
      SendDlgItemMessage(hWindow,id_Localite,wm_SetText,0,LongInt(@Localite));
      SendDlgItemMessage(hWindow,id_TelPrive,wm_SetText,0,LongInt(@TelPrive));
      SendDlgItemMessage(hWindow,id_FaxPrive,wm_SetText,0,LongInt(@FaxPrive));
      SendDlgItemMessage(hWindow,id_TelBureau,wm_SetText,0,LongInt(@TelBureau));
      SendDlgItemMessage(hWindow,id_FaxBureau,wm_SetText,0,LongInt(@FaxBureau));
      SendDlgItemMessage(hWindow,id_eMail,wm_SetText,0,LongInt(@eMail));
      SendDlgItemMessage(hWindow,id_Remarque,wm_SetText,0,LongInt(@Remarque));
    end;
End;

Procedure tDlgDonneesPers.OK (var Msg : tMessage);
(* LORSQUE LE BOUTON "OK" EST PRESSE, CONTROLE DU CONTENU DES CONTROLES AVANT DE QUITTER *)
Var Texte : Array [0..51] of Char;   (* MESSAGE D'ERREUR *)
    Titre : Array [0..33] of Char;   (* TITRE DU MESSAGE D'ERREUR *)
Begin
  with DonneesPers^ do
    if SendDlgItemMessage(hWindow,id_Nom,wm_GetText,SizeOf(Nom),LongInt(@Nom)) > 0
       then   (* LE NOM A BIEN ETE ENCODE : C'EST SUFFISANT ET ON CHARGE LES AUTRES VALEURS *)
         begin
           SendDlgItemMessage(hWindow,id_Formule,wm_GetText,SizeOf(Formule),LongInt(@Formule));
           SendDlgItemMessage(hWindow,id_Prenom,wm_GetText,SizeOf(Prenom),LongInt(@Prenom));
           SendDlgItemMessage(hWindow,id_Rue,wm_GetText,SizeOf(Rue),LongInt(@Rue));
           SendDlgItemMessage(hWindow,id_CP,wm_GetText,SizeOf(CP),LongInt(@CP));
           SendDlgItemMessage(hWindow,id_Localite,wm_GetText,SizeOf(Localite),LongInt(@Localite));
           SendDlgItemMessage(hWindow,id_TelPrive,wm_GetText,SizeOf(TelPrive),LongInt(@TelPrive));
           SendDlgItemMessage(hWindow,id_FaxPrive,wm_GetText,SizeOf(FaxPrive),LongInt(@FaxPrive));
           SendDlgItemMessage(hWindow,id_TelBureau,wm_GetText,SizeOf(TelBureau),LongInt(@TelBureau));
           SendDlgItemMessage(hWindow,id_FaxBureau,wm_GetText,SizeOf(FaxBureau),LongInt(@FaxBureau));
           SendDlgItemMessage(hWindow,id_eMail,wm_GetText,SizeOf(eMail),LongInt(@eMail));
           SendDlgItemMessage(hWindow,id_Remarque,wm_GetText,SizeOf(Remarque),LongInt(@Remarque));
           tDialog.OK(Msg);
         end
       else   (* IL FAUT QUE LE NOM SOIT ENCODE : MESSAGE D'ERREUR *)
         begin
           LoadString(hInstance,erp_TitreDonneesPers,Titre,SizeOf(Titre));
           LoadString(hInstance,erp_DonneesPers,Texte,SizeOf(Texte));
           MESSAGEBOX(hWindow,Texte,Titre,mb_IconExclamation or mb_Ok);
         end;
End;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                             METHODES DE L'OBJET tDlgTri                                                *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Constructor tDlgTri.INIT (FenetreParent : pWindowsObject; NomDialogue : pChar; Ptr1 : pInteger; Ptr2 : pByte);
(* PASSAGE DE L'ADRESSE DES OPTIONS DE TRI A MODIFIER *)
Begin
  tDialog.INIT(FenetreParent,NomDialogue);
  Tri:=Ptr1; Sens:=Ptr2;
End;

Procedure tDlgTri.SETUPWINDOW;
(* CENTRAGE A L'ECRAN ET INITIALISATION DES CONTROLES ENFANTS *)
Var r : tRect;        (* COORDONNEES DE LA FENETRE *)
    l, h : Integer;   (* LARGEUR ET HAUTEUR DE LA FENETRE *)
Begin
  tDialog.SETUPWINDOW;
  GetWindowRect(hWindow,r);
  with r do
    begin
      l:=Right-Left;
      h:=Bottom-Top;
    end;
  MoveWindow(hWindow,(GetSystemMetrics(sm_CXScreen)-l) div 2,(GetSystemMetrics(sm_CYScreen)-h) div 2,l,h,true);
  (* COCHAGE DES OPTIONS COURANTES *)
  SendDlgItemMessage(hWindow,Tri^,bm_SetCheck,1,0);
  if Sens^ = 1 then l:=id_Croissant else l:=id_Decroissant;
  SendDlgItemMessage(hWindow,l,bm_SetCheck,1,0);
End;

Procedure tDlgTri.OK (var Msg : tMessage);
(* LORSQUE LE BOUTON "OK" EST PRESSE, MISE A JOUR DE L'OPTION DE TRI *)
Var Id : Integer;   (* IDENTIFICATEUR DE CONTROLE *)
Begin
  Id:=id_Formule;
  while Id <= id_Remarque do
    if SendDlgItemMessage(hWindow,Id,bm_GetCheck,0,0) <> 0
       then   (* TROUVE ! *)
         begin
           Tri^:=Id;
           Id:=id_Remarque+1;   (* FIN DE BOUCLE *)
         end
       else
         Inc(Id);
  if SendDlgItemMessage(hWindow,id_Croissant,bm_GetCheck,0,0) <> 0 then Sens^:=1 else Sens^:=0;
  tDialog.OK(Msg);
End;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                           METHODES DE L'OBJET tDlgChercher                                             *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Constructor tDlgChercher.INIT (FenetreParent : pWindowsObject; NomDialogue : pChar;
                               Ptr1 : pChamps; Ptr2 : pChar; Ptr3 : pBoolean);
(* PASSAGE DE L'ADRESSE DES OPTIONS A MODIFIER ET DU RESULTAT *)
Begin
  tDialog.INIT(FenetreParent,NomDialogue);
  Champs:=Ptr1;
  Chercher:=Ptr2;
  Resultat:=Ptr3;
End;

Procedure tDlgChercher.SETUPWINDOW;
(* CENTRAGE A L'ECRAN ET INITIALISATION DES CONTROLES ENFANTS *)
Var r : tRect;        (* COORDONNEES DE LA FENETRE *)
    l, h : Integer;   (* LARGEUR ET HAUTEUR DE LA FENETRE *)
    n : Word;         (* INDICE DANS LE TABLEAU DES CHAMPS *)
Begin
  tDialog.SETUPWINDOW;
  GetWindowRect(hWindow,r);
  with r do
    begin
      l:=Right-Left;
      h:=Bottom-Top;
    end;
  MoveWindow(hWindow,(GetSystemMetrics(sm_CXScreen)-l) div 2,(GetSystemMetrics(sm_CYScreen)-h) div 2,l,h,true);
  (* INITIALISATION DES CONTROLES ENFANTS *)
  SendDlgItemMessage(hWindow,id_Chercher,em_LimitText,60,0);
  SendDlgItemMessage(hWindow,id_Chercher,wm_SetText,0,LongInt(Chercher));
  for n:=id_Formule to id_Remarque do SendDlgItemMessage(hWindow,n,bm_SetCheck,Champs^[n],0);
End;

Procedure tDlgChercher.OK (var Msg : tMessage);
(* LORSQUE LE BOUTON "OK" EST PRESSE, MISE A JOUR DES OPTIONS *)
Var n : Integer;                     (* INDICE ET IDENTIFICATEUR DE CONTROLE *)
    Somme : Word;                    (* SOMME DES VALEURS DU TABLEAU DE CHAMPS *)
    Texte : Array [0..49] of Char;   (* MESSAGE D'ERREUR *)
    Titre : Array [0..20] of Char;   (* TITRE DU MESSAGE D'ERREUR *)
    Erreur : Integer;                (* IDENTIFICATEUR DU MESSAGE D'ERREUR *)
Begin
  Erreur:=0;
  if SendDlgItemMessage(hWindow,id_Chercher,wm_GetText,61,LongInt(Chercher)) > 0
     then   (* LA CHAINE A CHERCHER N'EST PAS VIDE : ON CHARGE LES AUTRES VALEURS *)
       begin
         Somme:=0;
         for n:=id_Formule to id_Remarque do
           begin
             Champs^[n]:=SendDlgItemMessage(hWindow,n,bm_GetCheck,0,0);
             Inc(Somme,Champs^[n]);
           end;
         if Somme = 0 then Erreur:=erc_Champs;
       end
     else   (* LA CHAINE A CHERCHER EST VIDE : MESSAGE D'ERREUR *)
       Erreur:=erc_Chercher;
  if Erreur = 0
     then   (* PAS D'ERREUR : ON QUITTE LE DIALOGUE *)
       begin
         Resultat^:=true;
         tDialog.OK(Msg);
       end
     else   (* MESSAGE D'ERREUR *)
       begin
         LoadString(hInstance,erc_TitreChercher,Titre,SizeOf(Titre));
         LoadString(hInstance,Erreur,Texte,SizeOf(Texte));
         MESSAGEBOX(hWindow,Texte,Titre,mb_IconExclamation or mb_Ok);
       end;
End;

Procedure tDlgChercher.CANCEL (var Msg : tMessage);
(* LORSQUE LE BOUTON "Annuler" EST PRESSE, RETOURNE UN RESULTAT false *)
Begin
  Resultat^:=false;
  tDialog.CANCEL(Msg);
End;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                          METHODES DE L'OBJET tDlgEtiquettes                                            *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Constructor tDlgEtiquettes.INIT (FenetreParent : pWindowsObject; NomDialogue : pChar;
                                 Ptr1, Ptr2, Ptr3, Ptr4 : pReal; Ptr5, Ptr6, Resultat : pByte);
(* PASSAGE DE L'ADRESSE DES OPTIONS A MODIFIER *)
Begin
  tDialog.INIT(FenetreParent,NomDialogue);
  MargeHaut:=Ptr1; MargeBas:=Ptr2; MargeGauche:=Ptr3; MargeDroite:=Ptr4;
  NbParLigne:=Ptr5; NbParColonne:=Ptr6;
  Retour:=Resultat;
End;

Procedure tDlgEtiquettes.SETUPWINDOW;
(* CENTRAGE A L'ECRAN ET INITIALISATION DES CONTROLES ENFANTS *)
Var r : tRect;                  (* COORDONNEES DE LA FENETRE *)
    l, h : Integer;             (* LARGEUR ET HAUTEUR DE LA FENETRE *)
    c : Array [0..6] of Char;   (* RESULTAT DE LA CONVERSION DE NOMBRES EN CHAINE *)
Begin
  tDialog.SETUPWINDOW;
  GetWindowRect(hWindow,r);
  with r do
    begin
      l:=Right-Left;
      h:=Bottom-Top;
    end;
  MoveWindow(hWindow,(GetSystemMetrics(sm_CXScreen)-l) div 2,(GetSystemMetrics(sm_CYScreen)-h) div 2,l,h,true);
  (* LIMITATION DE LA LONGUEUR DES CONTROLES D'EDITION *)
  SendDlgItemMessage(hWindow,id_MargeHaut,em_LimitText,6,0);
  SendDlgItemMessage(hWindow,id_MargeBas,em_LimitText,6,0);
  SendDlgItemMessage(hWindow,id_MargeGauche,em_LimitText,6,0);
  SendDlgItemMessage(hWindow,id_MargeDroite,em_LimitText,6,0);
  SendDlgItemMessage(hWindow,id_NbParLigne,em_LimitText,2,0);
  SendDlgItemMessage(hWindow,id_NbParColonne,em_LimitText,6,0);
  (* CHARGEMENT DES VALEURS DES CONTROLES D'EDITION *)
  Str(MargeHaut^:0:2,c); SendDlgItemMessage(hWindow,id_MargeHaut,wm_SetText,0,LongInt(@c));
  Str(MargeBas^:0:2,c); SendDlgItemMessage(hWindow,id_MargeBas,wm_SetText,0,LongInt(@c));
  Str(MargeGauche^:0:2,c); SendDlgItemMessage(hWindow,id_MargeGauche,wm_SetText,0,LongInt(@c));
  Str(MargeDroite^:0:2,c); SendDlgItemMessage(hWindow,id_MargeDroite,wm_SetText,0,LongInt(@c));
  Str(NbParLigne^,c); SendDlgItemMessage(hWindow,id_NbParLigne,wm_SetText,0,LongInt(@c));
  Str(NbParColonne^,c); SendDlgItemMessage(hWindow,id_NbParColonne,wm_SetText,0,LongInt(@c));
End;

Procedure tDlgEtiquettes.OK (var Msg : tMessage);
(* LORSQUE LE BOUTON "OK" EST PRESSE, CONTROLE ET SAUVETAGE DES VALEURS *)
Var s : String [6];                   (* VARIABLE DE CONVERSION *)
    c : Array [0..6] of Char;         (* CONTENU D'UN CONTROLE *)
    Titre : Array [0..33] of Char;    (* TITRE DU MESSAGE D'ERREUR *)
    Texte : Array [0..103] of Char;   (* TEXTE DU MESSAGE D'ERREUR *)
    IdTitre, IdTexte : Integer;       (* IDENTIFICATEURS DANS LA TABLE DE CHAINE *)
    v1, v2, v3, v4 : Real;            (* VALEURS DES MARGES *)
    v5, v6 : Byte;                    (* VALEURS DES NOMBRES D'ETIQUETTES *)
    Erreur : Integer;                 (* RESULTAT DE LA CONVERSION DES NOMBRES EN TEXTE *)
Begin
  (* LECTURE ET CONTROLE DES VALEURS *)
  IdTitre:=0;
  if SendDlgItemMessage(hWindow,id_MargeHaut,wm_GetText,SizeOf(c),LongInt(@c)) > 0
   then
    begin
     s:=StrPas(c); Val(s,v1,Erreur);
     if Erreur = 0
      then
       begin
        if SendDlgItemMessage(hWindow,id_MargeBas,wm_GetText,SizeOf(c),LongInt(@c)) > 0
         then
          begin
           s:=StrPas(c); Val(s,v2,Erreur);
           if Erreur = 0
            then
             begin
              if SendDlgItemMessage(hWindow,id_MargeGauche,wm_GetText,SizeOf(c),LongInt(@c)) > 0
               then
                begin
                 s:=StrPas(c); Val(s,v3,Erreur);
                 if Erreur = 0
                  then
                   begin
                    if SendDlgItemMessage(hWindow,id_MargeDroite,wm_GetText,SizeOf(c),LongInt(@c)) > 0
                     then
                      begin
                       s:=StrPas(c); Val(s,v4,Erreur);
                       if Erreur = 0
                        then
                         begin
                          if SendDlgItemMessage(hWindow,id_NbParLigne,wm_GetText,SizeOf(c),LongInt(@c)) > 0
                           then
                            begin
                             s:=StrPas(c); Val(s,v5,Erreur);
                             if Erreur = 0
                              then
                               begin
                                if (v5 >= 1) and (v5 <= 4)
                                 then
                                  begin
                                   if SendDlgItemMessage(hWindow,id_NbParColonne,wm_GetText,SizeOf(c),LongInt(@c)) <> 0
                                    then
                                     begin
                                      s:=StrPas(c); Val(s,v6,Erreur);
                                      if Erreur = 0
                                       then
                                        begin
                                         if (v6 < 1) or (v6 > 17) then IdTitre:=ere_TitreNbEtiquettes;
                                        end
                                       else
                                        IdTitre:=ere_TitreNbParColonne;
                                     end
                                    else
                                     IdTitre:=ere_TitreOptionsEtiquettes;
                                  end
                                 else
                                  IdTitre:=ere_TitreNbEtiquettes;
                               end
                              else
                               IdTitre:=ere_TitreNbParLigne;
                            end
                           else
                            IdTitre:=ere_TitreOptionsEtiquettes;
                         end
                        else
                          IdTitre:=ere_TitreMargeDroite;
                      end
                     else
                      IdTitre:=ere_TitreOptionsEtiquettes;
                   end
                  else
                   IdTitre:=ere_TitreMargeGauche;
                end
               else
                IdTitre:=ere_TitreOptionsEtiquettes;
             end
            else
             IdTitre:=ere_TitreMargeBas;
          end
         else
          IdTitre:=ere_TitreOptionsEtiquettes;
       end
      else
       IdTitre:=ere_TitreMargeHaut;
    end
   else
   IdTitre:=ere_TitreOptionsEtiquettes;
  if IdTitre = 0
     then   (* PAS D'ERREUR *)
       begin
         (* CHARGEMENT DES VALEURS *)
         MargeHaut^:=v1; MargeBas^:=v2; MargeGauche^:=v3; MargeDroite^:=v4;
         NbParLigne^:=v5; NbParColonne^:=v6;
         (* FERMETURE DU DIALOGUE *)
         tDialog.OK(Msg);
       end
     else   (* MESSAGE D'ERREUR *)
       begin
         LoadString(hInstance,IdTitre,Titre,SizeOf(Titre));
         case IdTitre of
           ere_TitreOptionsEtiquettes : LoadString(hInstance,ere_ManqueChamp,Texte,SizeOf(Texte));
           ere_TitreNbEtiquettes : LoadString(hInstance,ere_NbEtiquettes,Texte,SizeOf(Texte));
         else   (* ERREUR DE SYNTAXE *)
           LoadString(hInstance,ere_Syntaxe,Texte,SizeOf(Texte));
         end;
         MessageBox(hWindow,Texte,Titre,mb_IconExclamation or mb_Ok);
       end;
End;

Procedure tDlgEtiquettes.CANCEL (var Msg : tMessage);
(* LORSQUE LE BOUTON "Annuler" EST PRESSE, RETOURNE LA VALEUR 0 *)
Begin
  Retour^:=0;
  tDialog.CANCEL(Msg);
End;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                         METHODES DE L'OBJET tDlgRepartition                                            *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Constructor tDlgRepartition.INIT (FenetreParent : pWindowsObject; NomDialogue : pChar;
                            NbL, NbC : pByte; No, NbT : pWord; Donnees : pPlanEtiquettes; Resultat : pWord);
(* PASSAGE DES PARAMETRES DE REPARTITION ET DE L'ADRESSE DU RESULTAT *)
Begin
  tDialog.INIT(FenetreParent,NomDialogue);
  NbParLigne:=NbL; NbParColonne:=NbC;
  NumeroFeuille:=No;
  NbEtiquettes:=Resultat;
  NbEtiquettes^:=NbParLigne^ * NbParColonne^;
  NbTotal:=NbT;
  Plan:=Donnees;
End;

Procedure tDlgRepartition.SETUPWINDOW;
(* CENTRAGE A L'ECRAN ET INITIALISATION DES CONTROLES ENFANTS *)
Var r : tRect;                       (* COORDONNEES DE LA FENETRE *)
    l, h : Integer;                  (* LARGEUR ET HAUTEUR DE LA FENETRE *)
    Titre : Array [0..30] of Char;   (* TITRE DU DIALOGUE *)
    c : Array [0..5] of Char;        (* RESULTAT DE LA CONVERSION DE NOMBRES EN CHAINE *)
    Id : Integer;                    (* CALCUL DE L'IDENTIFICATEUR DE BOUTON *)
Begin
  tDialog.SETUPWINDOW;
  GetWindowRect(hWindow,r);
  with r do
    begin
      l:=Right-Left;
      h:=Bottom-Top;
    end;
  MoveWindow(hWindow,(GetSystemMetrics(sm_CXScreen)-l) div 2,(GetSystemMetrics(sm_CYScreen)-h) div 2,l,h,true);
  (* BARRE DE TITRE *)
  LoadString(hInstance,st_CaptionRepartition,Titre,SizeOf(Titre));
  StrCat(Titre,' '); Str(NumeroFeuille^,c); StrCat(Titre,c);
  SetWindowText(hWindow,Titre);
  (* INITIALISATION DES COMPTEURS *)
  Str(NbEtiquettes^,c); SendDlgItemMessage(hWindow,id_NbEtiquettes,wm_SetText,0,LongInt(@c));
  Str(NbTotal^,c); SendDlgItemMessage(hWindow,id_NbTotal,wm_SetText,0,LongInt(@c));
  (* DESACTIVATION DES BOUTONS HORS FORMAT *)
  c[0]:=#0;
  for h:=1 to 17 do for l:=1 to 4 do
    if (h > NbParColonne^) or (l > NbParLigne^)
       then
         begin
           Id:=id_Repartition+(h*10)+l;
           SendDlgItemMessage(hWindow,Id,wm_SetText,0,LongInt(@c));
           EnableWindow(GetDlgItem(hWindow,Id),false);
         end;
End;

Procedure tDlgRepartition.WMCOMMAND (var Msg : tMessage);
(* ACTIVATION OU DESACTIVATION DES BOUTONS REPRESENTANT LES ETIQUETTES *)
Var l, c : Word;                    (* LIGNE ET COLONNE DU BOUTON (ET DONC DE L'ETIQUETTE) *)
    Texte : Array [0..5] of Char;   (* TEXTE A INSCRIRE DANS LE BOUTON OU LE TEXTE STATIQUE DU NOMBRE D'ETIQUETTES *)
Begin
  case Msg.wParam of
    (id_Repartition+1)..(id_Repartition+4),(id_Repartition+11)..(id_Repartition+174) :
       begin   (* UN BOUTON DE CHOIX D'ETIQUETTES EST ACTIONNE *)
         l:=(Msg.wParam-id_Repartition) div 10; c:=(Msg.wParam-id_Repartition) mod 10;
         if Plan^[l,c].Imprimer
            then   (* DESACTIVER L'ETIQUETTE *)
              begin
                StrCopy(Texte,'-');
                Dec(NbEtiquettes^);
              end
            else   (* ACTIVER L'ETIQUETTE *)
              begin
                StrCopy(Texte,'OK');
                Inc(NbEtiquettes^);
              end;
         SendDlgItemMessage(hWindow,Msg.wParam,wm_SetText,0,LongInt(@Texte));
         Str(NbEtiquettes^,Texte); SendDlgItemMessage(hWindow,id_NbEtiquettes,wm_SetText,0,LongInt(@Texte));
         Plan^[l,c].Imprimer:=not Plan^[l,c].Imprimer;
       end;
  else
    tDialog.WMCOMMAND(Msg);
  end;
End;

Procedure tDlgRepartition.CANCEL (var Msg : tMessage);
(* LORSQUE LE BOUTON "Annuler" EST PRESSE, LE NOMBRE D'ETIQUETTES A IMPRIMER EST 0 *)
Begin
  NbEtiquettes^:=0;
  tDialog.CANCEL(Msg);
End;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                           METHODES DE L'OBJET tDlgListing                                              *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Constructor tDlgListing.INIT (FenetreParent : pWindowsObject; NomDialogue : pChar; Donnees : pChamps);
(* PASSAGE DE L'ADRESSE DES OPTIONS A MODIFIER *)
Begin
  tDialog.INIT(FenetreParent,NomDialogue);
  Champs:=Donnees;
End;

Procedure tDlgListing.SETUPWINDOW;
(* CENTRAGE A L'ECRAN ET INITIALISATION DES CONTROLES ENFANTS *)
Var r : tRect;        (* COORDONNEES DE LA FENETRE *)
    l, h : Integer;   (* LARGEUR ET HAUTEUR DE LA FENETRE *)
    n : Word;         (* INDICE ET IDENTIFICATEUR DE CONTROLE *)
Begin
  tDialog.SETUPWINDOW;
  GetWindowRect(hWindow,r);
  with r do
    begin
      l:=Right-Left;
      h:=Bottom-Top;
    end;
  MoveWindow(hWindow,(GetSystemMetrics(sm_CXScreen)-l) div 2,(GetSystemMetrics(sm_CYScreen)-h) div 2,l,h,true);
  (* COCHAGE DES OPTIONS COURANTES *)
  for n:=id_Formule to id_Remarque do SendDlgItemMessage(hWindow,n,bm_SetCheck,Champs^[n],0);
End;

Procedure tDlgListing.OK (var Msg : tMessage);
(* LORSQUE LE BOUTON "OK" EST PRESSE, MISE A JOUR DE L'OPTION DE TRI *)
Var n : Integer;   (* INDICE ET IDENTIFICATEUR DE CONTROLE *)
Begin
  for n:=id_Formule to id_Remarque do Champs^[n]:=SendDlgItemMessage(hWindow,n,bm_GetCheck,0,0);
  tDialog.OK(Msg);
End;

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                            METHODES DE L'OBJET tApercu                                               *)
(* -------------------------------------------------------------------------------------------------------------------- *)

Constructor tApercu.INIT (FenetreParent : pWindowsObject; Donnees : pStyles);
(* PASSAGE DE L'ADRESSE DU TABLEAU DES POLICES DE CARACTERES *)
Var Titre : Array [0..32] of Char;   (* TITRE DE LA FENETRE *)
Begin
  LoadString(hInstance,st_CaptionApercu,Titre,SizeOf(Titre));
  tWindow.INIT(FenetreParent,Titre);
  Attr.Style:=ws_Popup or ws_OverlappedWindow or ws_Visible;
  Styles:=Donnees;
End;

Procedure tApercu.SETUPWINDOW;
(* CREATION DES FONTES, CENTRAGE ET ADAPTATION DE LA TAILLE DE LA FENETRE *)
Var r : tRect;                    (* COORDONNEES DE LA FENETRE *)
    l, h : Integer;               (* LARGEUR ET HAUTEUR DE LA FENETRE *)
    lTexte : Integer;             (* LARGEUR DES LIGNES DE TEXTE *)
    hTitres : Integer;            (* HAUTEUR DE LA FONTE PAR DEFAUT *)
    c : Array [0..35] of Char;    (* ELEMENT DE LA TABLE DE CHAINES *)
    DC : hDC;                     (* CONTEXTE DE PERIPHERIQUE POUR LES CALCULS *)
    AncienneFonte : hFont;        (* ANCIENNE FONTE *)
    MesuresTexte : tTextMetric;   (* MESURES DE FONTE *)
    n1, n2 : Word;                (* INDICES DANS LE TABLEAU DES FONTES *)
          Function FONTE_IDENTIQUE (n1, n2 : Integer) : Boolean;
          (* INDIQUE SI DEUX FONTES LOGIQUES SONT IDENTIQUES *)
          Begin
{
            FONTE_IDENTIQUE:=(Styles^[n1].Taille = Styles^[n2].Taille) and
                             (StrComp(Styles^[n1].Fonte.lfFaceName,Styles^[n2].Fonte.lfFaceName) = 0) and
                             (Styles^[n1].Fonte.lfWeight = Styles^[n2].Fonte.lfWeight) and
                             (Styles^[n1].Fonte.lfItalic = Styles^[n2].Fonte.lfItalic) and
                             (Styles^[n1].Fonte.lfUnderline = Styles^[n2].Fonte.lfUnderline) and
                             (Styles^[n1].Fonte.lfStrikeOut = Styles^[n2].Fonte.lfStrikeOut) and
                             (Styles^[n1].Fonte.lfWidth = Styles^[n2].Fonte.lfWidth) and
                             (Styles^[n1].Fonte.lfEscapement = Styles^[n2].Fonte.lfEscapement) and
                             (Styles^[n1].Fonte.lfOrientation = Styles^[n2].Fonte.lfOrientation) and
                             (Styles^[n1].Fonte.lfCharSet = Styles^[n2].Fonte.lfCharSet) and
                             (Styles^[n1].Fonte.lfOutPrecision = Styles^[n2].Fonte.lfOutPrecision) and
                             (Styles^[n1].Fonte.lfClipPrecision = Styles^[n2].Fonte.lfClipPrecision) and
                             (Styles^[n1].Fonte.lfQuality = Styles^[n2].Fonte.lfQuality) and
                             (Styles^[n1].Fonte.lfPitchAndFamily = Styles^[n2].Fonte.lfPitchAndFamily);
}
            FONTE_IDENTIQUE:=(COMPARE(@Styles^[n1],@Styles^[n2],SizeOf(Styles^[n1]))=0);
          End;
Begin
  tWindow.SETUPWINDOW;
  (* CREATION DU CONTEXTE DE PERIPHERIQUE *)
  DC:=GetDC(hWindow);
  if DC <> 0
     then
       begin
         (* CALCUL DU NOMBRE DE PIXELS PAR POUCE *)
         dy:=GetDeviceCaps(DC,LogPixelsY);
         (* CREATION DES FONTES NECESSAIRES *)
         for n1:=id_Formule to id_Remarque do Fontes[n1]:=0;
         with Styles^[id_Formule] do
           begin
             Fonte.lfHeight:=-MulDiv(Taille,dy,72);
             Fontes[id_Formule]:=CreateFontIndirect(Fonte);
           end;
         for n1:=id_Nom to id_Remarque do with Styles^[n1] do
           begin
             (* RECHERCHE D'UNE FONTE IDENTIQUE DEJA CREEE *)
             n2:=id_Formule;
             while n2 < n1 do
               if FONTE_IDENTIQUE(n2,n1)
                  then   (* LES FONTES SONT IDENTIQUES : MEME HANDLE *)
                    begin
                      Fontes[n1]:=Fontes[n2];
                      n2:=id_Remarque;   (* FIN DE BOUCLE *)
                    end
                  else
                    Inc(n2);
             if Fontes[n1] = 0
                then   (* PAS DE FONTE IDENTIQUE DEJA CREEE : LA CREER *)
                  begin
                    Fonte.lfHeight:=-MulDiv(Taille,dy,72);
                    Fontes[n1]:=CreateFontIndirect(Fonte);
                  end;
           end;
         (* CALCUL DE LA HAUTEUR DES TITRES (POLICE PAR DEFAUT) *)
         GetTextMetrics(DC,MesuresTexte);
         with MesuresTexte do hTitres:=tmHeight + tmExternalLeading;
         (* CALCUL DES LARGEURS ET HAUTEURS DES DIFFERENTES LIGNES *)
         AncienneFonte:=SelectObject(DC,Fontes[id_Formule]);
         GetTextMetrics(DC,MesuresTexte);
         with MesuresTexte do
           Hauteurs[id_Nom]:=tmHeight + tmExternalLeading;
         LoadString(hInstance,st_Formule,c,SizeOf(c));
         Largeurs[id_Formule]:=LoWord(GetTextExtent(DC,c,StrLen(c))) + LoWord(GetTextExtent(DC,' ',1));
         l:=Largeurs[id_Formule];
         SelectObject(DC,Fontes[id_Nom]);
         GetTextMetrics(DC,MesuresTexte);
         with MesuresTexte do
           if Hauteurs[id_Nom] < (tmHeight + tmExternalLeading) then Hauteurs[id_Nom]:=tmHeight + tmExternalLeading;
         LoadString(hInstance,st_Nom,c,SizeOf(c));
         Largeurs[id_Nom]:=LoWord(GetTextExtent(DC,c,StrLen(c))) + LoWord(GetTextExtent(DC,' ',1));
         Inc(l,Largeurs[id_Nom]);
         SelectObject(DC,Fontes[id_Prenom]);
         GetTextMetrics(DC,MesuresTexte);
         with MesuresTexte do
           if Hauteurs[id_Nom] < (tmHeight + tmExternalLeading) then Hauteurs[id_Nom]:=tmHeight + tmExternalLeading;
         LoadString(hInstance,st_Prenom,c,SizeOf(c));
         Largeurs[id_Prenom]:=LoWord(GetTextExtent(DC,c,StrLen(c)));
         Inc(l,Largeurs[id_Prenom]);
         SelectObject(DC,Fontes[id_Rue]);
         GetTextMetrics(DC,MesuresTexte);
         with MesuresTexte do
           Hauteurs[id_Rue]:=tmHeight + tmExternalLeading;
         LoadString(hInstance,st_Rue,c,SizeOf(c));
         Largeurs[id_Rue]:=LoWord(GetTextExtent(DC,c,StrLen(c)));
         if Largeurs[id_Rue] > l then l:=Largeurs[id_Rue];
         SelectObject(DC,Fontes[id_CP]);
         GetTextMetrics(DC,MesuresTexte);
         with MesuresTexte do
           Hauteurs[id_CP]:=tmHeight + tmExternalLeading;
         LoadString(hInstance,st_CP,c,SizeOf(c));
         Largeurs[id_CP]:=LoWord(GetTextExtent(DC,c,StrLen(c))) + GetTextExtent(DC,' ',1);
         lTexte:=Largeurs[id_CP];
         SelectObject(DC,Fontes[id_Localite]);
         GetTextMetrics(DC,MesuresTexte);
         with MesuresTexte do
           if Hauteurs[id_CP] < (tmHeight + tmExternalLeading) then Hauteurs[id_CP]:=tmHeight + tmExternalLeading;
         LoadString(hInstance,st_Localite,c,SizeOf(c));
         Largeurs[id_Localite]:=LoWord(GetTextExtent(DC,c,StrLen(c)));
         Inc(lTexte,Largeurs[id_Localite]);
         if lTexte > l then l:=lTexte;
         for n1:=id_TelPrive to id_Remarque do
           begin
             SelectObject(DC,AncienneFonte);
             LoadString(hInstance,n1,c,SizeOf(c));
             lTitres[n1]:=LoWord(GetTextExtent(DC,c,StrLen(c))) + GetTextExtent(DC,' ',1);
             lTexte:=lTitres[n1];
             Hauteurs[n1]:=hTitres;
             SelectObject(DC,Fontes[n1]);
             GetTextMetrics(DC,MesuresTexte);
             with MesuresTexte do
               if Hauteurs[n1] < (tmHeight + tmExternalLeading) then Hauteurs[n1]:=tmHeight + tmExternalLeading;
             LoadString(hInstance,st_Formule+n1-id_Formule,c,SizeOf(c));
             Largeurs[n1]:=LoWord(GetTextExtent(DC,c,StrLen(c)));
             Inc(lTexte,Largeurs[n1]);
             if lTexte > l then l:=lTexte;
           end;
         (* RESTAURATION ET LIBERATION DU CONTEXTE DE PERIPHERIQUE *)
         SelectObject(DC,AncienneFonte);
         ReleaseDC(hWindow,DC);
         (* CENTRAGE DE LA FENETRE A L'ECRAN *)
         h:=40; Inc(h,Hauteurs[id_Nom]); Inc(h,Hauteurs[id_Rue]); Inc(h,Hauteurs[id_CP]);
         for n1:=id_TelPrive to id_Remarque do Inc(h,Hauteurs[n1]);
         h:=h + GetSystemMetrics(sm_CYCaption) + 2 * GetSystemMetrics(sm_CYBorder);
         if h > GetSystemMetrics(sm_CYScreen) then h:=GetSystemMetrics(sm_CYScreen);
         l:=l + 40 + 2 * GetSystemMetrics(sm_CXBorder);
         if l > GetSystemMetrics(sm_CYScreen) then l:=GetSystemMetrics(sm_CYScreen);
         MoveWindow(hWindow,(GetSystemMetrics(sm_CXScreen)-l) div 2,(GetSystemMetrics(sm_CYScreen)-h) div 2,l,h,true);
       end;
End;

Procedure tApercu.PAINT (PaintDC : hDC; var PaintInfo : tPaintStruct);
(* AFFICHAGE DU CONTENU DE LA FENETRE *)
Var AncienneFonte : hFont;       (* ANCIENNE FONTE *)
    AncienAlignement : Word;     (* ANCIEN ALIGNEMENT DU TEXTE *)
    c : Array [0..35] of Char;   (* ELEMENT DE LA TABLE DE CHAINES *)
    x, y : Integer;              (* ABSCISSE ET ORDONNEE DU TEXTE A DESSINER *)
    n : Word;                    (* INDICE *)
Begin
  AncienAlignement:=SetTextAlign(PaintDC,ta_Left or ta_BaseLine or ta_NoUpdateCP);
  AncienneFonte:=SelectObject(PaintDC,Fontes[id_Formule]);
  x:=10; y:=10 + Hauteurs[id_Nom];
  (* FORMULE, NOM ET PRENOM *)
  SelectObject(PaintDC,Fontes[id_Formule]);
  SetTextColor(PaintDC,Styles^[id_Formule].Couleur);
  LoadString(hInstance,st_Formule,c,SizeOf(c)); TextOut(PaintDC,x,y,c,StrLen(c));
  Inc(x,Largeurs[id_Formule]);
  SelectObject(PaintDC,Fontes[id_Nom]);
  SetTextColor(PaintDC,Styles^[id_Nom].Couleur);
  LoadString(hInstance,st_Nom,c,SizeOf(c)); TextOut(PaintDC,x,y,c,StrLen(c));
  Inc(x,Largeurs[id_Nom]);
  SelectObject(PaintDC,Fontes[id_Prenom]);
  SetTextColor(PaintDC,Styles^[id_Prenom].Couleur);
  LoadString(hInstance,st_Prenom,c,SizeOf(c)); TextOut(PaintDC,x,y,c,StrLen(c));
  (* RUE *)
  x:=10; Inc(y,Hauteurs[id_Rue]);
  SelectObject(PaintDC,Fontes[id_Rue]);
  SetTextColor(PaintDC,Styles^[id_Rue].Couleur);
  LoadString(hInstance,st_Rue,c,SizeOf(c)); TextOut(PaintDC,x,y,c,StrLen(c));
  (* CODE POSTAL ET LOCALITE *)
  Inc(y,Hauteurs[id_CP]);
  SelectObject(PaintDC,Fontes[id_CP]);
  SetTextColor(PaintDC,Styles^[id_CP].Couleur);
  LoadString(hInstance,st_CP,c,SizeOf(c)); TextOut(PaintDC,x,y,c,StrLen(c));
  Inc(x,Largeurs[id_CP]);
  SelectObject(PaintDC,Fontes[id_Localite]);
  SetTextColor(PaintDC,Styles^[id_Localite].Couleur);
  LoadString(hInstance,st_Localite,c,SizeOf(c)); TextOut(PaintDC,x,y,c,StrLen(c));
  (* N DE TELEPHONE, DE FAX, E-MAIL ET REMARQUE *)
  for n:=id_TelPrive to id_Remarque do
    begin
      x:=10; Inc(y,Hauteurs[n]);
      SelectObject(PaintDC,AncienneFonte);
      SetTextColor(PaintDC,RGB(192,192,192));
      LoadString(hInstance,n,c,SizeOf(c)); TextOut(PaintDC,x,y,c,StrLen(c));
      Inc(x,lTitres[n]);
      SelectObject(PaintDC,Fontes[n]);
      SetTextColor(PaintDC,Styles^[n].Couleur);
      LoadString(hInstance,st_Formule+n-id_Formule,c,SizeOf(c)); TextOut(PaintDC,x,y,c,StrLen(c));
    end;
  (* RESTAURATION DU CONTEXTE DE PERIPHERIQUE *)
  SetTextAlign(PaintDC,AncienAlignement);
  SelectObject(PaintDC,AncienneFonte);
End;

Procedure tApercu.WMKEYDOWN (var Msg : tMessage);
(* SI LA TOUCHE ESCAPE A ETE PRESSEE, FERMETURE DE LA FENETRE *)
Begin
  if Msg.wParam = vk_Escape then CloseWindow;
End;

Destructor tApercu.DONE;
(* DESTRUCTION DES FONTES CREEES *)
Var i : Word;
Begin
  for i:=id_Formule to id_Remarque do if Fontes[i] <> 0 then DeleteObject(Fontes[i]);
  tWindow.DONE;
End;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                           METHODES DE L'OBJET tDlgAPropos                                              *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Procedure tDlgAPropos.SETUPWINDOW;
(* CENTRAGE DE LA FENETRE A L'ECRAN *)
Var r : tRect;        (* COORDONNEES DE LA FENETRE *)
    l, h : Integer;   (* LARGEUR ET HAUTEUR DE LA FENETRE *)
Begin
  tDialog.SETUPWINDOW;
  GetWindowRect(hWindow,r);
  with r do
    begin
      l:=Right-Left;
      h:=Bottom-Top;
    end;
  MoveWindow(hWindow,(GetSystemMetrics(sm_CXScreen)-l) div 2,(GetSystemMetrics(sm_CYScreen)-h) div 2,l,h,true);
End;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                           METHODES DE L'OBJET tProgramme                                               *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Constructor tProgramme.INIT (NomProgramme : pChar);
(* REMPLACEMENT DE LA ROUTINE DE GESTION DES ALLOCATIONS DYNAMIQUES *)
Begin
  HeapError:=@ERREUR_ALLOCATION;
  tApplication.INIT(NomProgramme);
End;

Procedure tProgramme.INITMAINWINDOW;
(* CHOIX DE LA FENETRE PRINCIPALE DE L'APPLICATION *)
Begin
  MainWindow:=New(pFenetrePrincipale,INIT(nil,NomFenetrePrincipale));
End;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                       METHODES DE L'OBJET tFenetrePrincipale                                           *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Constructor tFenetrePrincipale.INIT (ApplicationParent : pWindowsObject; Titre : pChar);
(* DIMENSIONS DE LA FENETRE, CHARGEMENT DU MENU, CONSTRUCTION DES CONTROLES ENFANTS *)
Var Void : pControl;             (* ADRESSE DE CONTROLE INUTILISEE *)
    c : Array [0..20] of Char;   (* ELEMENT DE LA TABLE DES CHAINES *)
Begin
  (* AFFICHAGE DU PETIT DIALOGUE D'ATTENTE AU DEMARRAGE *)
  DialogueDemarrage:=pDlgDemarrage(Application^.MakeWindow(New(pDlgDemarrage,INIT(nil,'DIALOGUE_DEMARRAGE'))));
  if DialogueDemarrage <> nil then DialogueDemarrage^.DEBUT;
  (* CONSTRUCTION DE LA FENETRE PRINCIPALE *)
  tWindow.INIT(ApplicationParent,Titre);
  with Attr do
    begin
      (* DIMENSIONS DE LA FENETRE *)
      w:=608+2*GetSystemMetrics(sm_CXBorder);
      h:=444+2*GetSystemMetrics(sm_CYBorder)+GetSystemMetrics(sm_CYCaption)+GetSystemMetrics(sm_CYMenu);
      x:=(GetSystemMetrics(sm_CXScreen)-w) div 2; y:=(GetSystemMetrics(sm_CYScreen)-h) div 2;
      (* CHARGEMENT DU MENU PRINCIPAL *)
      Menu:=LoadMenu(hInstance,'MENU_PRINCIPAL');
    end;
  EnableKBHandler;
  (* CONSTRUCTION DES CONTROLES ENFANTS *)
  Ctl_ListePers:=New(pListePers,INIT(@Self,id_Liste,12,12,304,192));
  LoadString(hInstance,id_Ajouter,c,SizeOf(c));
  Void:=New(pButton,INIT(@Self,id_Ajouter,c,324,12,84,28,false));
  LoadString(hInstance,id_Modifier,c,SizeOf(c));
  Void:=New(pButton,INIT(@Self,id_Modifier,c,324,44,84,28,false));
  LoadString(hInstance,id_Supprimer,c,SizeOf(c));
  Void:=New(pButton,INIT(@Self,id_Supprimer,c,324,76,84,28,false));
  LoadString(hInstance,id_Trier,c,SizeOf(c));
  Void:=New(pButton,INIT(@Self,id_Trier,c,324,108,84,28,false));
  LoadString(hInstance,id_SelectionnerTout,c,SizeOf(c));
  Void:=New(pButton,INIT(@Self,id_SelectionnerTout,c,324,140,144,28,false));
  LoadString(hInstance,id_DeselectionnerTout,c,SizeOf(c));
  Void:=New(pButton,INIT(@Self,id_DeselectionnerTout,c,324,172,144,28,false));
  LoadString(hInstance,id_Listing,c,SizeOf(c));
  Void:=New(pButton,INIT(@Self,id_Listing,c,512,12,84,28,false));
  LoadString(hInstance,id_Etiquettes,c,SizeOf(c));
  Void:=New(pButton,INIT(@Self,id_Etiquettes,c,512,44,84,28,false));
  LoadString(hInstance,id_Polices,c,SizeOf(c));
  Void:=New(pButton,INIT(@Self,id_Polices,c,512,76,84,28,false));
  LoadString(hInstance,id_Chercher,c,SizeOf(c));
  Void:=New(pButton,INIT(@Self,id_Chercher,c,512,108,84,28,false));
  LoadString(hInstance,id_ChercherSuivant,c,SizeOf(c));
  Void:=New(pButton,INIT(@Self,id_ChercherSuivant,c,512,140,84,28,false));
  LoadString(hInstance,id_Quitter,c,SizeOf(c));
  Void:=New(pButton,INIT(@Self,id_Quitter,c,512,172,84,28,false));
  LoadString(hInstance,id_EnvoiDDE,c,SizeOf(c));
  Ctl_EnvoiDDE:=New(pButton,INIT(@Self,id_EnvoiDDE,c,418,12,84,28,false));
End;

Procedure tFenetrePrincipale.GETWINDOWCLASS (var aWndClass : tWndClass);
(* DEFINITION DE L'ICONE DE CLASSE DU PROGRAMME *)
Begin
  tWindow.GETWINDOWCLASS(aWndClass);
  aWndClass.hIcon:=LoadIcon(hInstance,'ICONE_FENETRE_PRINCIPALE');
End;

Procedure tFenetrePrincipale.CHARGEMENT_OPTIONS;
(* CHARGEMENT DES OPTIONS CONTENUES DANS LE FICHIER ADRESSES.INI *)
Var Section, Entree, NomFichierIni : Array [0..17] of Char;   (* SECTION, ENTREE ET NOM DU FICHIER *)
    c : Array [0..11] of Char;                                (* VALEUR LUE *)
    i, j : Word;                                              (* INDICE DANS LE TABLEAU DES STYLES *)
    Erreur : Integer;                                         (* RESULTAT DE CONVERSION *)
Begin
  LoadString(hInstance,ini_NomFichierIni,NomFichierIni,SizeOf(NomFichierIni));
  (* OPTIONS DE TRI *)
  LoadString(hInstance,ini_SectionTri,Section,SizeOf(Section));
  LoadString(hInstance,ini_Tri,Entree,SizeOf(Entree));
  Tri:=GetPrivateProfileInt(Section,Entree,id_Nom,NomFichierIni);
  LoadString(hInstance,ini_SensTri,Entree,SizeOf(Entree));
  SensTri:=GetPrivateProfileInt(Section,Entree,1,NomFichierIni);
  (* OPTIONS POUR L'EDITION D'ETIQUETTES *)
  LoadString(hInstance,ini_SectionEtiquettes,Section,SizeOf(Section));
  LoadString(hInstance,ini_MargeHaut,Entree,SizeOf(Entree));
  GetPrivateProfileString(Section,Entree,'15',c,SizeOf(c),NomFichierIni);
  Val(c,MargeHaut,Erreur); if Erreur <> 0 then MargeHaut:=15;
  LoadString(hInstance,ini_MargeBas,Entree,SizeOf(Entree));
  GetPrivateProfileString(Section,Entree,'15',c,SizeOf(c),NomFichierIni);
  Val(c,MargeBas,Erreur); if Erreur <> 0 then MargeBas:=15;
  LoadString(hInstance,ini_MargeGauche,Entree,SizeOf(Entree));
  GetPrivateProfileString(Section,Entree,'7.5',c,SizeOf(c),NomFichierIni);
  Val(c,MargeGauche,Erreur); if Erreur <> 0 then MargeGauche:=7.5;
  LoadString(hInstance,ini_MargeDroite,Entree,SizeOf(Entree));
  GetPrivateProfileString(Section,Entree,'7.5',c,SizeOf(c),NomFichierIni);
  Val(c,MargeDroite,Erreur); if Erreur <> 0 then MargeDroite:=7.5;
  LoadString(hInstance,ini_NbParLigne,Entree,SizeOf(Entree));
  NbParLigne:=GetPrivateProfileInt(Section,Entree,3,NomFichierIni);
  LoadString(hInstance,ini_NbParColonne,Entree,SizeOf(Entree));
  NbParColonne:=GetPrivateProfileInt(Section,Entree,7,NomFichierIni);
  (* CHAMPS A IMPRIMER DANS LES LISTINGS *)
  LoadString(hInstance,ini_SectionListing,Section,SizeOf(Section));
  for i:=id_Formule to id_Remarque do
    begin
      LoadString(hInstance,ini_ListingFormule+i-id_Formule,Entree,SizeOf(Entree));
      ChampsListing[i]:=GetPrivateProfileInt(Section,Entree,1,NomFichierIni);
    end;
  (* STYLES DES CHAMPS *)
  for i:=id_Formule to id_Remarque do with Styles[i] do
    begin
      LoadString(hInstance,ini_SectionStyleFormule+i-id_Formule,Section,SizeOf(Section));
      with Fonte do
        begin
          LoadString(hInstance,ini_StyleFonte,Entree,SizeOf(Entree));
          LoadString(hInstance,st_FonteDefaut,c,SizeOf(c));
          GetPrivateProfileString(Section,Entree,c,lfFaceName,SizeOf(lfFaceName),NomFichierIni);
          LoadString(hInstance,ini_StylePitch,Entree,SizeOf(Entree));
          lfPitchAndFamily:=GetPrivateProfileInt(Section,Entree,Default_Pitch,NomFichierIni);
          LoadString(hInstance,ini_StyleGras,Entree,SizeOf(Entree));
          lfWeight:=GetPrivateProfileInt(Section,Entree,fw_Normal,NomFichierIni);
          LoadString(hInstance,ini_StyleItalique,Entree,SizeOf(Entree));
          lfItalic:=GetPrivateProfileInt(Section,Entree,0,NomFichierIni);
          LoadString(hInstance,ini_StyleSouligne,Entree,SizeOf(Entree));
          lfUnderline:=GetPrivateProfileInt(Section,Entree,0,NomFichierIni);
          LoadString(hInstance,ini_StyleBarre,Entree,SizeOf(Entree));
          lfStrikeOut:=GetPrivateProfileInt(Section,Entree,0,NomFichierIni);
        end;
      LoadString(hInstance,ini_StyleTaille,Entree,SizeOf(Entree));
      Taille:=GetPrivateProfileInt(Section,Entree,10,NomFichierIni);
      LoadString(hInstance,ini_StyleCouleur,Entree,SizeOf(Entree));
      GetPrivateProfileString(Section,Entree,'0',c,SizeOf(c),NomFichierIni);
      Val(c,Couleur,Erreur); if Erreur <> 0 then Couleur:=0;
    end;
  (* PERSONNALISATION DES COULEURS *)
  LoadString(hInstance,ini_SectionCouleurs,Section,SizeOf(Section));
  LoadString(hInstance,ini_CouleursDefaut,Entree,SizeOf(Entree));
  i:=GetPrivateProfileInt(Section,Entree,1,NomFichierIni);
  if i = 0 then CheckMenuItem(Attr.Menu,cm_CouleursDefaut,mf_ByCommand or mf_Unchecked);
  LoadString(hInstance,ini_CouleurFond,Entree,SizeOf(Entree));
  GetPrivateProfileString(Section,Entree,'0',c,SizeOf(c),NomFichierIni); Val(c,Couleurs[cm_CouleurFond],Erreur);
  if i = 0 then SetClassWord(hWindow,gcw_hBrBackGround,CreateSolidBrush(Couleurs[cm_CouleurFond]));
  LoadString(hInstance,ini_CouleurTitres,Entree,SizeOf(Entree));
  GetPrivateProfileString(Section,Entree,'0',c,SizeOf(c),NomFichierIni); Val(c,Couleurs[cm_CouleurTitres],Erreur);
  j:=cm_CouleurFormule;
  for i:=ini_ListingFormule to ini_ListingRemarque do
    begin
      LoadString(hInstance,i,Entree,SizeOf(Entree));
      GetPrivateProfileString(Section,Entree,'0',c,SizeOf(c),NomFichierIni); Val(c,Couleurs[j],Erreur);
      Inc(j);
    end;
  for i:=1 to 16 do
    begin
      LoadString(hInstance,ini_CouleursPerso,Entree,SizeOf(Entree)); Str(i,c); StrCat(Entree,c);
      GetPrivateProfileString(Section,Entree,'0',c,SizeOf(c),NomFichierIni); Val(c,CouleursPerso[i],Erreur);
    end;
End;

Procedure tFenetrePrincipale.SAUVEGARDE_OPTIONS;
(* SAUVEGARDE DES OPTIONS DANS LE FICHIER ADRESSES.INI *)
Var Section, Entree, NomFichierIni : Array [0..17] of Char;   (* SECTION, ENTRE ET NOM DU FICHIER *)
    c : Array [0..11] of Char;                                (* VALEUR A SAUVEGARDER *)
    i, j : Word;                                              (* INDICES *)
Begin
  LoadString(hInstance,ini_NomFichierIni,NomFichierIni,SizeOf(NomFichierIni));
  (* OPTIONS DE TRI *)
  LoadString(hInstance,ini_SectionTri,Section,SizeOf(Section));
  LoadString(hInstance,ini_Tri,Entree,SizeOf(Entree));
  Str(Tri,c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
  LoadString(hInstance,ini_SensTri,Entree,SizeOf(Entree));
  Str(SensTri,c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
  (* OPTIONS POUR L'EDITION D'ETIQUETTES *)
  LoadString(hInstance,ini_SectionEtiquettes,Section,SizeOf(Section));
  LoadString(hInstance,ini_MargeHaut,Entree,SizeOf(Entree));
  Str(MargeHaut:0:2,c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
  LoadString(hInstance,ini_MargeBas,Entree,SizeOf(Entree));
  Str(MargeBas:0:2,c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
  LoadString(hInstance,ini_MargeGauche,Entree,SizeOf(Entree));
  Str(MargeGauche:0:2,c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
  LoadString(hInstance,ini_MargeDroite,Entree,SizeOf(Entree));
  Str(MargeDroite:0:2,c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
  LoadString(hInstance,ini_NbParLigne,Entree,SizeOf(Entree));
  Str(NbParLigne,c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
  LoadString(hInstance,ini_NbParColonne,Entree,SizeOf(Entree));
  Str(NbParColonne,c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
  (* CHAMPS A IMPRIMER DANS LES LISTINGS *)
  LoadString(hInstance,ini_SectionListing,Section,SizeOf(Section));
  for i:=id_Formule to id_Remarque do
    begin
      LoadString(hInstance,ini_ListingFormule+i-id_Formule,Entree,SizeOf(Entree));
      Str(ChampsListing[i],c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
    end;
  (* STYLES DES CHAMPS *)
  for i:=id_Formule to id_Remarque do with Styles[i] do
    begin
      LoadString(hInstance,ini_SectionStyleFormule+i-id_Formule,Section,SizeOf(Section));
      with Fonte do
        begin
          LoadString(hInstance,ini_StyleFonte,Entree,SizeOf(Entree));
          WritePrivateProfileString(Section,Entree,lfFaceName,NomFichierIni);
          LoadString(hInstance,ini_StylePitch,Entree,SizeOf(Entree));
          Str(lfPitchAndFamily,c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
          LoadString(hInstance,ini_StyleGras,Entree,SizeOf(Entree));
          Str(lfWeight,c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
          LoadString(hInstance,ini_StyleItalique,Entree,SizeOf(Entree));
          Str(lfItalic,c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
          LoadString(hInstance,ini_StyleSouligne,Entree,SizeOf(Entree));
          Str(lfUnderline,c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
          lfUnderline:=GetPrivateProfileInt(Section,Entree,0,NomFichierIni);
          LoadString(hInstance,ini_StyleBarre,Entree,SizeOf(Entree));
          Str(lfStrikeOut,c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
        end;
      LoadString(hInstance,ini_StyleTaille,Entree,SizeOf(Entree));
      Str(Taille,c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
      LoadString(hInstance,ini_StyleCouleur,Entree,SizeOf(Entree));
      Str(Couleur,c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
    end;
  (* PERSONNALISATION DES COULEURS *)
  LoadString(hInstance,ini_SectionCouleurs,Section,SizeOf(Section));
  LoadString(hInstance,ini_CouleursDefaut,Entree,SizeOf(Entree));
  if (GetMenuState(Attr.Menu,cm_CouleursDefaut,mf_ByCommand) and mf_Checked) = mf_Checked
     then StrCopy(c,'1')
     else StrCopy(c,'0');
  WritePrivateProfileString(Section,Entree,c,NomFichierIni);
  LoadString(hInstance,ini_CouleurFond,Entree,SizeOf(Entree));
  Str(Couleurs[cm_CouleurFond],c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
  LoadString(hInstance,ini_CouleurTitres,Entree,SizeOf(Entree));
  Str(Couleurs[cm_CouleurTitres],c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
  j:=cm_CouleurFormule;
  for i:=ini_ListingFormule to ini_ListingRemarque do
    begin
      LoadString(hInstance,i,Entree,SizeOf(Entree));
      Str(Couleurs[j],c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
      Inc(j);
    end;
  for i:=1 to 16 do
    begin
      LoadString(hInstance,ini_CouleursPerso,Entree,SizeOf(Entree)); Str(i,c); StrCat(Entree,c);
      Str(CouleursPerso[i],c); WritePrivateProfileString(Section,Entree,c,NomFichierIni);
    end;
End;

Procedure tFenetrePrincipale.MESSAGE_ERREUR_FICHIER (n : Word);
(* AFFICHAGE D'UN MESSAGE D'ERREUR DE MANIPULATION DU FICHIER ADRESSES.DTA *)
Var c : Array [0..38] of Char;   (* MESSAGE D'ERREUR *)
Begin
  LoadString(hInstance,n,c,SizeOf(c));
  MessageBox(hWindow,c,NomFichier,mb_IconHand or mb_Ok);
End;

Procedure tFenetrePrincipale.MESSAGE_ERREUR_MEMOIRE (n : Word);
(* MESSAGE D'ERREUR FATALE D'ALLOCATION DE MEMOIRE - n EST L'IDENTIFICATEUR DU TITRE DE LA BOITE MESSAGE *)
Var Texte, Titre : Array [0..45] of Char;   (* TEXTE ET TITRE DE LA BOITE MESSAGE *)
Begin
  LoadString(hInstance,erm_Memoire,Texte,SizeOf(Texte));
  LoadString(hInstance,n,Titre,SizeOf(Titre));
  MessageBox(hWindow,Texte,Titre,mb_Ok or mb_IconHand);
End;

Function tFenetrePrincipale.CREATION_FICHIER : Boolean;
(* CREATION DU FICHIER ADRESSES.DTA (UTILISATION DES FONCTIONS FICHIERS DU KERNEL WINDOWS) *)
Begin
  HandleFichier:=_lCreat(NomFichier,0);
  if HandleFichier = -1
     then   (* ERREUR *)
       begin
         CREATION_FICHIER:=false;
         MESSAGE_ERREUR_FICHIER(erf_CreationFichier);
       end
     else
       CREATION_FICHIER:=true;
End;

Function tFenetrePrincipale.OUVERTURE_FICHIER : Boolean;
(* OUVERTURE DU FICHIER ADRESSES.DTA (UTILISATION DES FONCTIONS FICHIERS DU KERNEL WINDOWS) *)
Begin
  HandleFichier:=_lOpen(NomFichier,of_Read or of_Share_Deny_Read);
  if HandleFichier = -1
     then   (* ERREUR *)
       begin
         OUVERTURE_FICHIER:=false;
         MESSAGE_ERREUR_FICHIER(erf_OuvertureFichier);
       end
     else
       OUVERTURE_FICHIER:=true;
End;

Function tFenetrePrincipale.LECTURE_FICHIER : Boolean;
(* LECTURE DU FICHIER ADRESSES.DTA (UTILISATION DES FONCTIONS FICHIERS DU KERNEL WINDOWS) *)
Var n : Word;   (* NOMBRE D'OCTETS LUS *)
Begin
  LECTURE_FICHIER:=false;
  n:=_lRead(HandleFichier,Buffer,TailleBuffer);
  if n = $FFFF
     then   (* ERREUR *)
       MESSAGE_ERREUR_FICHIER(erf_LectureFichier)
     else
       if n = TailleBuffer then LECTURE_FICHIER:=true;
End;

Function tFenetrePrincipale.ECRITURE_FICHIER : Boolean;
(* ECRITURE DU FICHIER ADRESSES.DTA (UTILISATION DES FONCTIONS FICHIERS DU KERNEL WINDOWS) *)
Begin
  if _lWrite(HandleFichier,Buffer,TailleBuffer) = $FFFF
     then   (* ERREUR *)
       begin
         ECRITURE_FICHIER:=false;
         MESSAGE_ERREUR_FICHIER(erf_EcritureFichier);
       end
     else
       ECRITURE_FICHIER:=true;
End;

Function tFenetrePrincipale.FERMETURE_FICHIER : Boolean;
(* FERMETURE DU FICHIER ADRESSES.DTA (UTILISATION DES FONCTIONS FICHIERS DU KERNEL WINDOWS) *)
Begin
  if _lClose(HandleFichier) <> 0
     then   (* ERREUR *)
       begin
         FERMETURE_FICHIER:=false;
         MESSAGE_ERREUR_FICHIER(erf_FermetureFichier);
       end
     else
       FERMETURE_FICHIER:=true;
End;

Procedure tFenetrePrincipale.CHARGEMENT_DONNEES_PERS;
(* CHARGEMENT DES DONNEES CONTENUES DANS LE FICHIER ADRESSES.DTA *)
Var p : pListeDonneesPers;   (* ELEMENT DE LA LISTE CHAINEE DES DONNEES PERSONNELLES *)
    Erreur : Boolean;        (* INDIQUE UNE ERREUR MEMOIRE *)
Begin
  if OUVERTURE_FICHIER
     then
       begin
         Erreur:=false;
         while LECTURE_FICHIER and not Erreur do
           begin
             New(p);
             if p <> nil
                then   (* ALLOCATION CORRECTE *)
                  begin
                    (* CHARGEMENT DES DONNEES *)
                    Move(Buffer,p^.DonneesPers,SizeOf(tDonneesPers));
                    (* AJOUT A LA FIN DE LA LISTE CHAINEE *)
                    if pTete = nil
                       then   (* LA LISTE EST ENCORE VIDE *)
                         begin
                           pTete:=p; pQueue:=p;
                           p^.pPrec:=nil;
                         end
                       else   (* LA LISTE N'EST PAS VIDE *)
                         begin
                           pQueue^.pSuiv:=p; p^.pPrec:=pQueue;
                           pQueue:=p;
                         end;
                    p^.pSuiv:=nil;
                  end
                else   (* ERREUR D'ALLOCATION *)
                  begin
                    MESSAGE_ERREUR_MEMOIRE(erm_TitreLectureFichier);
                    Erreur:=true;
                  end;
           end;
         FERMETURE_FICHIER;
       end;
End;

Function tFenetrePrincipale.SAUVEGARDE_DONNEES_PERS : Boolean;
(* ENREGISTREMENT DES DONNEES PERSONNELLES DANS LE FICHIER ADRESSES.DTA *)
Var p : pListeDonneesPers;   (* ELEMENT DE LA LISTE CHAINEE DES DONNEES PERSONNELLES *)
    Resultat1 : Boolean;     (* RESULTAT DES OPERATIONS DE CREATION ET D'ECRITURE DU FICHIER *)
    Resultat2 : Boolean;     (* RESULTAT DE LA FERMETURE DU FICHIER *)
Begin
  Resultat1:=false; Resultat2:=false;
  if CREATION_FICHIER
     then
       begin
         p:=pTete; Resultat1:=true;
         while (p <> nil) and Resultat1 do
           begin
             Move(p^.DonneesPers,Buffer,SizeOf(tDonneesPers));
             Resultat1:=ECRITURE_FICHIER;
             p:=p^.pSuiv;
           end;
         Resultat2:=FERMETURE_FICHIER;
       end
     else
       Resultat1:=false;
  SAUVEGARDE_DONNEES_PERS:=(Resultat1 and Resultat2);
End;

Procedure tFenetrePrincipale.SETUPWINDOW;
(* INITIALISATION DES CHAMPS, CHARGEMENT DU FICHIER D'ADRESSES ET INITIALISATION DES CONTROLES ENFANTS *)
Var p : pListeDonneesPers;            (* ELEMENT DE LA LISTE CHAINEE *)
    Tabulation : LongInt;             (* VALEUR DU TAQUET DE TABULATION DE LA BOITE LISTE *)
    NomPrenom : tNomPrenom;           (* GROUPE NOM+PRENOM A CHARGER DANS LA BOITE LISTE *)
    Section : Array [0..4] of Char;   (* NOM DE SECTION DANS LE FICHIER WIN.INI *)
    Entree : Array [0..5] of Char;    (* ENTREE DANS LE FICHIER WIN.INI *)
    c : Array [0..255] of Char;       (* ELEMENT DE LA TABLE DE CHAINES *)
    i, j : Word;                      (* INDICES *)
Begin
  tWindow.SETUPWINDOW;
  (* INITIALISATION DES CHAMPS *)
  for i:=1 to 16 do CouleursPerso[i]:=RGB(255,255,255);
  for i:=cm_CouleurFormule to cm_CouleurRemarque do Couleurs[i]:=RGB(0,0,0);
  Couleurs[cm_CouleurFond]:=GetSysColor(color_Window);
  Couleurs[cm_CouleurTitres]:=GetSysColor(color_WindowText);
  GetClientRect(hWindow,RectDonneesPers); RectDonneesPers.Top:=210;
  pTete:=nil; pQueue:=nil;
  LoadString(hInstance,st_NomFichier,NomFichier,SizeOf(NomFichier));
  HandleFichier:=-1;
  Tri:=id_Nom; SensTri:=1;
  LoadString(hInstance,st_FonteDefaut,c,SizeOf(c));
  for i:=id_Formule to id_Remarque do with Styles[i] do
    begin
      with Fonte do
        begin
          lfHeight:=0;
          lfWidth:=0;
          lfEscapement:=0;
          lfOrientation:=0;
          lfWeight:=fw_Normal;
          lfItalic:=0;
          lfUnderline:=0;
          lfStrikeOut:=0;
          lfCharSet:=Default_CharSet;
          lfOutPrecision:=Out_Default_Precis;
          lfClipPrecision:=Clip_Default_Precis;
          lfQuality:=Default_Quality;
          lfPitchAndFamily:=Variable_Pitch;
          StrCopy(lfFaceName,c);
        end;
      Taille:=10;
      Couleur:=RGB(0,0,0);
    end;
  Styles[id_Nom].Fonte.lfWeight:=fw_Bold; Styles[id_Prenom].Fonte.lfWeight:=fw_Bold;
  MargeHaut:=15; MargeBas:=15; MargeGauche:=7.5; MargeDroite:=7.5; NbParLigne:=3; NbParColonne:=7;
  for i:=1 to 17 do for j:=1 to 4 do with PlanEtiquettes[i,j] do
    begin
      Imprimer:=true;
      Adresse:=nil;
    end;
  for i:=id_Formule to id_Remarque do ChampsListing[i]:=1;
  for i:=id_Formule to id_Remarque do ChampsChercher[i]:=1;
  Chercher[0]:=#0;
  EnvoiManuel:=false;
  EnvoiPressePapier:=false;
  LoadString(hInstance,ini_SectionSeparateur,Section,SizeOf(Section));
  LoadString(hInstance,ini_EntreeSeparateur,Entree,SizeOf(Entree));
  GetProfileString(Section,Entree,';',Separateur,SizeOf(Separateur));
  Modification:=false; ModificationOptions:=false;
  Imprimante:=nil;
  (* CHARGEMENT DES OPTIONS *)
  CHARGEMENT_OPTIONS;
  (* CHARGEMENT DU FICHIER *)
  CHARGEMENT_DONNEES_PERS;
  (* TRI DES DONNEES *)
  TRI_LISTE_DONNEES_PERS;
  (* POSITION DU TAQUET DE TABULATION DE LA BOITE LISTE *)
  Tabulation:=152;
  SendDlgItemMessage(hWindow,id_Liste,lb_SetTabStops,1,LongInt(@Tabulation));
  (* REMPLISSAGE DE LA BOITE LISTE *)
  p:=pTete;
  while p <> nil do with p^.DonneesPers do
    begin
      CONSTRUCTION_GROUPE_NOM_PRENOM(p,NomPrenom);
      SendDlgItemMessage(hWindow,id_Liste,lb_AddString,0,LongInt(@NomPrenom));
      p:=p^.pSuiv;
    end;
  SendDlgItemMessage(hWindow,id_Liste,lb_SetCaretIndex,0,0);   (* "CURSEUR" SUR LE 1ER ELEMENT *)
  SetFocus(Ctl_ListePers^.hWindow);
  (* LE BOUTON D'ENVOI DES DONNEES AU CLIENT DDE EST RENDU INVISIBLE *)
  Ctl_EnvoiDDE^.Show(sw_Hide);
  (* EFFACEMENT DU DIALOGUE DE DEMARRAGE *)
  if DialogueDemarrage <> nil then DialogueDemarrage^.FIN;
End;

Procedure tFenetrePrincipale.PAINT (PaintDC : hDC; var PaintInfo : tPaintStruct);
(* AFFICHAGE DES DONNEES DE LA PERSONNE AYANT LE FOCUS DANS LA BOITE LISTE *)
Var i : Word;                               (* INDICE DE LA PERSONNE AYANT LE FOCUS DANS LA BOITE LISTE *)
    n : Integer;                            (* NOMBRE DE CARACTERES DE L'ELEMENT DE LA TABLE DE CHAINES *)
    c : Array [0..38] of Char;              (* ELEMENT DE LA TABLE DE CHAINES *)
    NomPrenom : tNomPrenom;                 (* GROUPE NOM+PRENOM DANS LA BOITE LISTE *)
    CopieRue : Array [0..120] of Char;      (* COPIE DU CHAMP Rue *)
    Rue2 : pChar;                           (* 2EME LIGNE DU TEXTE MULTILIGNE DU CONTROLE Rue *)
    Nom, Prenom : Array [0..30] of Char;    (* CHAINES A RECHERCHER DANS LA LISTE DES PERSONNES *)
    AncienFond, Fond : tColorRef;           (* ANCIEN ET NOUVEAU FOND DE TEXTE *)
    AncienneCouleur, Couleur : tColorRef;   (* ANCIENNE ET NOUVELLE COULEUR DE TEXTE *)
    Perso : Boolean;                        (* INDIQUE S'IL FAUT UTILISER LES COULEURS PERSONNALISEES *)
    p : pListeDonneesPers;                  (* ELEMENT DE LA LISTE CHAINEE DES DONNEES PERSONNELLES *)
Begin
  Perso:=not((GetMenuState(Attr.Menu,cm_CouleursDefaut,mf_ByCommand) and mf_Checked) = mf_Checked);
  (* TITRES *)
  if Perso
     then   (* UTILISATION DES COULEURS PERSONNALISEES *)
       begin
         Fond:=Couleurs[cm_CouleurFond];
         Couleur:=Couleurs[cm_CouleurTitres];
       end
     else   (* UTILISATION DES COULEURS PAR DEFAUT *)
       begin
         Fond:=GetSysColor(color_Window);
         Couleur:=GetSysColor(color_WindowText);
       end;
  AncienFond:=SetBkColor(PaintDC,Fond);
  AncienneCouleur:=SetTextColor(PaintDC,Couleur);
  n:=LoadString(hInstance,id_Formule,c,SizeOf(c));
  TextOut(PaintDC,12,216,c,n);
  n:=LoadString(hInstance,id_Nom,c,15);
  TextOut(PaintDC,12,240,c,n);
  n:=LoadString(hInstance,id_Prenom,c,15);
  TextOut(PaintDC,300,240,c,n);
  n:=LoadString(hInstance,id_Rue,c,15);
  TextOut(PaintDC,12,268,c,n);
  n:=LoadString(hInstance,id_CP,c,15);
  TextOut(PaintDC,12,308,c,n);
  n:=LoadString(hInstance,id_Localite,c,15);
  TextOut(PaintDC,160,308,c,n);
  n:=LoadString(hInstance,id_TelPrive,c,15);
  TextOut(PaintDC,40,336,c,n);
  n:=LoadString(hInstance,id_FaxPrive,c,15);
  TextOut(PaintDC,40,360,c,n);
  n:=LoadString(hInstance,id_TelBureau,c,15);
  TextOut(PaintDC,308,336,c,n);
  n:=LoadString(hInstance,id_FaxBureau,c,15);
  TextOut(PaintDC,308,360,c,n);
  n:=LoadString(hInstance,id_eMail,c,15);
  TextOut(PaintDC,12,388,c,n);
  n:=LoadString(hInstance,id_Remarque,c,15);
  TextOut(PaintDC,12,412,c,n);
  (* DONNEES CORRESPONDANTES *)
  i:=SendDlgItemMessage(hWindow,id_Liste,lb_GetCaretIndex,0,0);
  if SendDlgItemMessage(hWindow,id_Liste,lb_GetText,i,LongInt(@NomPrenom)) <> lb_Err
     then   (* UNE PERSONNE A LE FOCUS *)
       begin
         (* RECHERCHE DANS LA LISTE CHAINEE DES PERSONNES *)
         p:=POINTEUR_CORRESPONDANT_NOM_PRENOM(NomPrenom);
         if p <> nil   (* AFFICHAGE DES DONNEES TROUVEES *)
            then with p^.DonneesPers do
              begin
                if Perso
                   then   (* UTILISATION DES COULEURS PERSONNALISEES *)
                     Couleur:=Couleurs[cm_CouleurFormule]
                   else   (* UTILISATION DES COULEURS PAR DEFAUT *)
                     begin
                       Fond:=not Fond; Couleur:=not Couleur;
                     end;
                SetBkColor(PaintDC,Fond);
                SetTextColor(PaintDC,Couleur);
                TextOut(PaintDC,256,216,Formule,StrLen(Formule));
                if Perso then SetTextColor(PaintDC,Couleurs[cm_CouleurNom]);
                TextOut(PaintDC,60,240,Nom,StrLen(Nom));
                if Perso then SetTextColor(PaintDC,Couleurs[cm_CouleurPrenom]);
                TextOut(PaintDC,364,240,Prenom,StrLen(Prenom));
                if Perso then SetTextColor(PaintDC,Couleurs[cm_CouleurRue]);
                StrCopy(CopieRue,Rue);
                Rue2:=StrPos(CopieRue,#13);
                if Rue2 <> nil
                   then   (* LES DEUX LIGNES DU CONTROLE SONT UTILISEES *)
                     begin
                       Rue2[0]:=#0;   (* MARQUE DE FIN DE LA 1ERE LIGNE DE TEXTE *)
                       Inc(Rue2,2);   (* ADAPTATION DE L'ADRESSE DE LA 2EME LIGNE *)
                       TextOut(PaintDC,76,284,Rue2,StrLen(Rue2));
                     end;
                TextOut(PaintDC,76,268,Rue,StrLen(CopieRue));
                if Perso then SetTextColor(PaintDC,Couleurs[cm_CouleurCP]);
                TextOut(PaintDC,76,308,CP,StrLen(CP));
                if Perso then SetTextColor(PaintDC,Couleurs[cm_CouleurLocalite]);
                TextOut(PaintDC,232,308,Localite,StrLen(Localite));
                if Perso then SetTextColor(PaintDC,Couleurs[cm_CouleurTelPrive]);
                TextOut(PaintDC,124,336,TelPrive,StrLen(TelPrive));
                if Perso then SetTextColor(PaintDC,Couleurs[cm_CouleurFaxPrive]);
                TextOut(PaintDC,124,360,FaxPrive,StrLen(FaxPrive));
                if Perso then SetTextColor(PaintDC,Couleurs[cm_CouleurTelBureau]);
                TextOut(PaintDC,404,336,TelBureau,StrLen(TelBureau));
                if Perso then SetTextColor(PaintDC,Couleurs[cm_CouleurFaxBureau]);
                TextOut(PaintDC,404,360,FaxBureau,StrLen(FaxBureau));
                if Perso then SetTextColor(PaintDC,Couleurs[cm_CouleurEMail]);
                TextOut(PaintDC,92,388,eMail,StrLen(eMail));
                if Perso then SetTextColor(PaintDC,Couleurs[cm_CouleurRemarque]);
                TextOut(PaintDC,92,412,Remarque,StrLen(Remarque));
              end;
       end;
  (* RESTAURATION DES CARACTERISTIQUES DU CONTEXTE D'AFFICHAGE *)
  SetBkColor(PaintDC,AncienFond);
  SetTextColor(PaintDC,AncienneCouleur);
End;

Procedure tFenetrePrincipale.WMCOMMAND (var Msg : tMessage);
(* RECEPTION DES MESSAGES DE NOTIFICATION EMANANT DE LA BOITE LISTE *)
Var Void : tMessage;   (* MESSAGE INUTILISE *)
Begin
  case Msg.lParamHi of
    lbn_DblClk : begin   (* DOUBLE CLIC SUR UN DES ELEMENTS DE LA LISTE : MODIFICATION *)
                   IDMODIFIER(Void);
                 end;
    lbn_SelChange : begin   (* L'ELEMENT COURANT A CHANGE : MISE A JOUR DES DONNEES AU BAS DE LA FENETRE *)
                      InvalidateRect(hWindow,@RectDonneesPers,true);
                      UpdateWindow(hWindow);
                    end;
  end;
  tWindow.WMCOMMAND(Msg);
End;

Procedure tFenetrePrincipale.TRI_LISTE_DONNEES_PERS;
(* TRI DE LA LISTE DES DONNEES PERSONNELLES SELON LE CRITERE COURANT *)
Var AncienCurseur : hCursor;                                                   (* CURSEUR A RESTAURER A LA FIN *)
    pCourant, pSuivant, pTeteTemp, pQueueTemp, pTemp, p : pListeDonneesPers;   (* ELEMENTS DE LA LISTE *)
    Trouve : Boolean;                                                          (* TROUVE UN ELEMENT PLUS PETIT *)
Begin
  AncienCurseur:=SetCursor(LoadCursor(0,idc_Wait));
  pTeteTemp:=nil; pQueueTemp:=nil;
  pCourant:=pTete;
  while pCourant <> nil do
    begin
      pSuivant:=pCourant^.pSuiv;
      if pTeteTemp = nil
         then   (* ENCORE AUCUN ELEMENT DANS LA NOUVELLE LISTE *)
           begin
             pTeteTemp:=pCourant; pQueueTemp:=pCourant;
             pTeteTemp^.pPrec:=nil; pTeteTemp^.pSuiv:=nil;
           end
         else   (* INSERTION DE L'ELEMENT DANS LA NOUVELLE LISTE *)
           begin
             pTemp:=pTeteTemp; Trouve:=false;
             while (pTemp <> nil) and (not Trouve) do
               begin
                 (* COMPARAISON DE pCourant ET pTemp *)
                 case Tri of
                   id_Formule : Trouve:=(StrComp(pCourant^.DonneesPers.Formule,pTemp^.DonneesPers.Formule) < 0) or
                                        ((StrComp(pCourant^.DonneesPers.Formule,pTemp^.DonneesPers.Formule) = 0) and
                                         ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) < 0) or
                                          ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) = 0) and
                                           (StrComp(pCourant^.DonneesPers.Prenom,pTemp^.DonneesPers.Prenom) < 0))));
                   id_Nom : Trouve:=(StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) < 0) or
                                    ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) = 0) and
                                     (StrComp(pCourant^.DonneesPers.Prenom,pTemp^.DonneesPers.Prenom) < 0));
                   id_Prenom : Trouve:=(StrComp(pCourant^.DonneesPers.Prenom,pTemp^.DonneesPers.Prenom) < 0) or
                                       ((StrComp(pCourant^.DonneesPers.Prenom,pTemp^.DonneesPers.Prenom) = 0) and
                                        (StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) < 0));
                   id_Rue : Trouve:=(StrComp(pCourant^.DonneesPers.Rue,pTemp^.DonneesPers.Rue) < 0) or
                                    ((StrComp(pCourant^.DonneesPers.Rue,pTemp^.DonneesPers.Rue) = 0) and
                                     ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) < 0) or
                                      ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) = 0) and
                                       (StrComp(pCourant^.DonneesPers.Prenom,pTemp^.DonneesPers.Prenom) < 0))));
                   id_CP : Trouve:=(StrComp(pCourant^.DonneesPers.CP,pTemp^.DonneesPers.CP) < 0) or
                                   ((StrComp(pCourant^.DonneesPers.CP,pTemp^.DonneesPers.CP) = 0) and
                                    ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) < 0) or
                                     ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) = 0) and
                                      (StrComp(pCourant^.DonneesPers.Prenom,pTemp^.DonneesPers.Prenom) < 0))));
                   id_Localite : Trouve:=(StrComp(pCourant^.DonneesPers.Localite,pTemp^.DonneesPers.Localite) < 0) or
                                        ((StrComp(pCourant^.DonneesPers.Localite,pTemp^.DonneesPers.Localite) = 0) and
                                         ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) < 0) or
                                          ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) = 0) and
                                           (StrComp(pCourant^.DonneesPers.Prenom,pTemp^.DonneesPers.Prenom) < 0))));
                   id_TelPrive : Trouve:=(StrComp(pCourant^.DonneesPers.TelPrive,pTemp^.DonneesPers.TelPrive) < 0) or
                                         ((StrComp(pCourant^.DonneesPers.TelPrive,pTemp^.DonneesPers.TelPrive) = 0) and
                                          ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) < 0) or
                                           ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) = 0) and
                                            (StrComp(pCourant^.DonneesPers.Prenom,pTemp^.DonneesPers.Prenom) < 0))));
                   id_FaxPrive : Trouve:=(StrComp(pCourant^.DonneesPers.FaxPrive,pTemp^.DonneesPers.FaxPrive) < 0) or
                                         ((StrComp(pCourant^.DonneesPers.FaxPrive,pTemp^.DonneesPers.FaxPrive) = 0) and
                                          ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) < 0) or
                                           ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) = 0) and
                                            (StrComp(pCourant^.DonneesPers.Prenom,pTemp^.DonneesPers.Prenom) < 0))));
                   id_TelBureau : Trouve:=(StrComp(pCourant^.DonneesPers.TelBureau,pTemp^.DonneesPers.TelBureau) < 0) or
                                          ((StrComp(pCourant^.DonneesPers.TelBureau,pTemp^.DonneesPers.TelBureau) = 0) and
                                           ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) < 0) or
                                            ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) = 0) and
                                             (StrComp(pCourant^.DonneesPers.Prenom,pTemp^.DonneesPers.Prenom) < 0))));
                   id_FaxBureau : Trouve:=(StrComp(pCourant^.DonneesPers.FaxBureau,pTemp^.DonneesPers.FaxBureau) < 0) or
                                          ((StrComp(pCourant^.DonneesPers.FaxBureau,pTemp^.DonneesPers.FaxBureau) = 0) and
                                           ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) < 0) or
                                            ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) = 0) and
                                             (StrComp(pCourant^.DonneesPers.Prenom,pTemp^.DonneesPers.Prenom) < 0))));
                   id_eMail : Trouve:=(StrComp(pCourant^.DonneesPers.eMail,pTemp^.DonneesPers.eMail) < 0) or
                                      ((StrComp(pCourant^.DonneesPers.eMail,pTemp^.DonneesPers.eMail) = 0) and
                                       ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) < 0) or
                                        ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) = 0) and
                                         (StrComp(pCourant^.DonneesPers.Prenom,pTemp^.DonneesPers.Prenom) < 0))));
                   id_Remarque : Trouve:=(StrComp(pCourant^.DonneesPers.Remarque,pTemp^.DonneesPers.Remarque) < 0) or
                                         ((StrComp(pCourant^.DonneesPers.Remarque,pTemp^.DonneesPers.Remarque) = 0) and
                                          ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) < 0) or
                                           ((StrComp(pCourant^.DonneesPers.Nom,pTemp^.DonneesPers.Nom) = 0) and
                                            (StrComp(pCourant^.DonneesPers.Prenom,pTemp^.DonneesPers.Prenom) < 0))));
                 end;
                 if Trouve
                    then   (* pCourant DOIT ETRE INSERE AVANT pTemp *)
                      begin
                        p:=pTemp^.pPrec;
                        if p = nil
                           then   (* pTemp EST LA TETE DE LISTE *)
                             begin
                               pTeteTemp:=pCourant; pTeteTemp^.pPrec:=nil;
                             end
                           else   (* pTemp N'EST PAS LA TETE DE LISTE *)
                             begin
                               p^.pSuiv:=pCourant; pCourant^.pPrec:=p;
                             end;
                        pCourant^.pSuiv:=pTemp; pTemp^.pPrec:=pCourant;
                      end
                    else   (* PASSAGE A L'ELEMENT SUIVANT *)
                      pTemp:=pTemp^.pSuiv;
               end;
             if not Trouve
                then   (* pCourant EST PLUS GRAND QUE TOUS LES AUTRES ELEMENTS DE LA LISTE : IL SE PLACE EN QUEUE *)
                  begin
                    pQueueTemp^.pSuiv:=pCourant; pCourant^.pPrec:=pQueueTemp;
                    pQueueTemp:=pCourant; pQueueTemp^.pSuiv:=nil;
                  end;
           end;
      (* PASSAGE A L'ELEMENT SUIVANT *)
      pCourant:=pSuivant;
    end;
  pTete:=pTeteTemp; pQueue:=pQueueTemp;
  (* RESTAURATION DU CURSEUR ORIGINAL *)
  SetCursor(AncienCurseur);
End;

Function tFenetrePrincipale.POINTEUR_CORRESPONDANT_NOM_PRENOM (Chaine : pChar) : pListeDonneesPers;
(* RETOURNE L'ELEMENT DE LISTE CHAINEE CORRESPONDANT A UN NOM ET UN PRENOM *)
Var NomPrenom : tNomPrenom;         (* COPIE DE TRAVAIL DU GROUPE NOM+PRENOM *)
    Nom, Prenom, Rue, CP : pChar;   (* ADRESSES DU NOM, DU PRENOM, DE LA RUE ET DU CODE POSTAL *)
    p : pListeDonneesPers;          (* ELEMENT DE LA LISTE CHAINEE DES DONNEES PERSONNELLES *)
    Trouve : Boolean;               (* INDIQUE SI L'ELEMENT EST TROUVE *)
Begin
  StrCopy(NomPrenom,Chaine);
  (* RECHERCHE DU CODE POSTAL *)
  CP:=StrPos(NomPrenom,#182);
  if CP <> nil
     then   (* NOUVELLE DELIMITATION DU GROUPE NOM+PRENOM *)
       begin
         CP[0]:=#0; Inc(CP);
       end;
  (* RECHERCHE DE LA RUE *)
  Rue:=StrPos(NomPrenom,#9);
  if Rue <> nil
     then   (* NOUVELLE DELIMITATION DU GROUPE NOM+PRENOM *)
       begin
         Rue[0]:=#0; Inc(Rue);
       end;
  (* RECHERCHE DU PRENOM *)
  Prenom:=StrPos(NomPrenom,#160);
  if Prenom <> nil
     then   (* IL Y A BIEN UN PRENOM *)
       begin
         Prenom[0]:=#0; Inc(Prenom);
       end;
  (* ADRESSE DU NOM *)
  Nom:=NomPrenom;
  (* RECHERCHE DANS LA LISTE *)
  p:=pTete; Trouve:=false;
  while (p <> nil) and (not Trouve) do
    begin
      if Nom <> nil then Trouve:=(StrComp(p^.DonneesPers.Nom,Nom) = 0);
      if Trouve then if Prenom <> nil then Trouve:=(StrComp(p^.DonneesPers.Prenom,Prenom) = 0);
      if Trouve then if Rue <> nil then Trouve:=(StrComp(p^.DonneesPers.Rue,Rue) = 0);
      if Trouve then if CP <> nil then Trouve:=(StrComp(p^.DonneesPers.CP,CP) = 0);
      if not Trouve then p:=p^.pSuiv;
    end;
  if Trouve then POINTEUR_CORRESPONDANT_NOM_PRENOM:=p else POINTEUR_CORRESPONDANT_NOM_PRENOM:=nil;
End;

Procedure tFenetrePrincipale.CONSTRUCTION_GROUPE_NOM_PRENOM (p : pListeDonneesPers; NomPrenom : pChar);
(* CONSTRUCTION D'UN GROUPE NOM+PRENOM A PARTIR DES DONNEES DE p *)
Begin
  with p^.DonneesPers do
    begin
      StrCopy(NomPrenom,Nom);
      StrCat(NomPrenom,#160);   (* SEPARATEUR ENTRE NOM ET PRENOM *)
      StrCat(NomPrenom,Prenom);
      StrCat(NomPrenom,#9);   (* TABULATION *)
      StrCat(NomPrenom,Rue);
      StrCat(NomPrenom,#182);   (* SEPARATEUR ENTRE RUE ET CODE POSTAL *)
      StrCat(NomPrenom,CP);
    end;
End;

Function tFenetrePrincipale.LECTURE_SELECTIONS : Word;
(* DANS LA LISTE CHAINEE, SELECTION DES ELEMENTS DE LA BOITE LISTE SELECTIONNES. RETOURNE LE NOMBRE TOTAL DE SELECTIONS *)
Var NomPrenom : tNomPrenom;   (* GROUPE NOM+PRENOM DANS LA BOITE LISTE *)
    p : pListeDonneesPers;    (* ELEMENT DE LA LISTE CHAINEE DES DONNEES PERSONNELLES *)
    Index, Nb : Word;         (* INDICE ET NOMBRE D'ELEMENTS DANS LA BOITE LISTE *)
    Resultat : Word;          (* RESULTAT RENVOYE PAR LA FONCTION *)
Begin
  (* DESELECTION DE TOUS LES ELEMENTS DE LA LISTE CHAINEE *)
  p:=pTete;
  while p <> nil do
    begin
      p^.Selection:=false;
      p:=p^.pSuiv;
    end;
  (* LECTURE DES SELECTIONS DE LA BOITE LISTE *)
  Resultat:=0;
  Nb:=SendDlgItemMessage(hWindow,id_Liste,lb_GetCount,0,0);
  if Nb <> lb_Err
     then
       begin
         for Index:=0 to (Nb-1) do
           if SendDlgItemMessage(hWindow,id_Liste,lb_GetSel,Index,0) > 0
              then   (* L'ELEMENT EST SELECTIONNE *)
                if SendDlgItemMessage(hWindow,id_Liste,lb_GetText,Index,LongInt(@NomPrenom)) <> lb_Err
                   then
                     begin
                       p:=POINTEUR_CORRESPONDANT_NOM_PRENOM(NomPrenom);
                       if p <> nil
                          then
                            begin
                              p^.Selection:=true;
                              Inc(Resultat);
                            end;
                     end;
       end;
  LECTURE_SELECTIONS:=Resultat;
End;

Procedure tFenetrePrincipale.ECRITURE_SELECTIONS;
(* DANS LA BOITE LISTE, SELECTION DES ELEMENTS DE LA LISTE CHAINEE SELECTIONNES *)
Var NomPrenom : tNomPrenom;     (* GROUPE NOM+PRENOM DANS LA BOITE LISTE *)
    p : pListeDonneesPers;      (* ELEMENT DE LA LISTE CHAINEE DES DONNEES PERSONNELLES *)
    Index : Word;               (* INDICE DANS LA BOITE LISTE *)
Begin
  p:=pTete;
  while p <> nil do
    begin
      if p^.Selection
         then   (* L'ELEMENT EST SELECTIONNE *)
           begin
             CONSTRUCTION_GROUPE_NOM_PRENOM(p,NomPrenom);
             Index:=SendDlgItemMessage(hWindow,id_Liste,lb_FindString,$FFFF,LongInt(@NomPrenom));
             if Index <> lb_Err then SendDlgItemMessage(hWindow,id_Liste,lb_SetSel,Word(true),MakeLong(Index,0));
           end;
      p:=p^.pSuiv;
    end;
End;

Procedure tFenetrePrincipale.MISE_A_JOUR_BOITE_LISTE;
(* MISE A JOUR DU CONTENU DE LA BOITE LISTE *)
Var p : pListeDonneesPers;    (* ELEMENT DE LA LISTE CHAINEE DES DONNEES PERSONNELLES *)
    NomPrenom : tNomPrenom;   (* GROUPE NOM+PRENOM *)
Begin
  (* LECTURE DES FICHES SELECTIONNEES *)
  LECTURE_SELECTIONS;
  (* MISE A JOUR DE LA LISTE *)
  SendDlgItemMessage(hWindow,id_Liste,lb_ResetContent,0,0);
  if SensTri = 1
     then   (* TRI CROISSANT *)
       begin
         p:=pTete;
         while p <> nil do with p^.DonneesPers do
           begin
             CONSTRUCTION_GROUPE_NOM_PRENOM(p,NomPrenom);
             SendDlgItemMessage(hWindow,id_Liste,lb_AddString,0,LongInt(@NomPrenom));
             p:=p^.pSuiv;
           end;
       end
     else   (* TRI DECROISSANT *)
       begin
         p:=pQueue;
         while p <> nil do with p^.DonneesPers do
           begin
             CONSTRUCTION_GROUPE_NOM_PRENOM(p,NomPrenom);
             SendDlgItemMessage(hWindow,id_Liste,lb_AddString,0,LongInt(@NomPrenom));
             p:=p^.pPrec;
           end;
       end;
  (* RE-SELECTION DES FICHES PRECEDEMMENT SELECTIONNEES *)
  ECRITURE_SELECTIONS;
End;

Function tFenetrePrincipale.DDE_TOUTES : pChaineDDE;
(* SELECTION DE TOUTES LES FICHES POUR ENVOYER AU CLIENT DDE - RENVOIE nil SI ERREUR *)
Var p : pListeDonneesPers;               (* ELEMENT DE LA LISTE CHAINEE DES DONNEES PERSONNELLES *)
    ChaineDDE : pChaineDDE;              (* CHAINE DE CONSTRUCTION DES DONNEES A RENVOYER (DANS LE TAS GLOBAL) *)
    Longueur : Word;                     (* LONGUEUR DE LA CHAINE DE CONSTRUCTION *)
    CopieRue : Array [0..120] of Char;   (* COPIE DU CHAMP Rue *)
    Rue2 : pChar;                        (* ADRESSE DE LA 2EME LIGNE DU TEXTE MULTILIGNE DU CONTROLE Rue *)
Begin
  New(ChaineDDE);
  if ChaineDDE <> nil
     then
       begin
         ChaineDDE^[0]:=#0;
         p:=pTete;
         while p <> nil do with p^.DonneesPers do
           begin
             if ChampsChercher[id_Formule] = 1
                then
                  begin
                    StrCat(ChaineDDE^,Formule); StrCat(ChaineDDE^,Separateur);
                  end;
             if ChampsChercher[id_Nom] = 1
                then
                  begin
                    StrCat(ChaineDDE^,Nom); StrCat(ChaineDDE^,Separateur);
                  end;
             if ChampsChercher[id_Prenom] = 1
                then
                  begin
                    StrCat(ChaineDDE^,Prenom); StrCat(ChaineDDE^,Separateur);
                  end;
             if ChampsChercher[id_Rue] = 1
                then
                  begin
                    StrCopy(CopieRue,Rue); Rue2:=StrPos(CopieRue,#13);
                    if Rue2 <> nil
                       then   (* LA RUE EST DIVISEE EN DEUX LIGNES *)
                         begin
                           Rue2[0]:=#0;   (* MARQUE DE FIN DE LA 1ERE LIGNE DE TEXTE *)
                           Inc(Rue2,2);   (* ADAPTATION DE L'ADRESSE DE LA 2EME LIGNE *)
                           StrCat(ChaineDDE^,CopieRue); StrCat(ChaineDDE^,' - '); StrCat(ChaineDDE^,Rue2);
                         end
                       else   (* LA RUE N'EST PAS DIVISEE *)
                         StrCat(ChaineDDE^,Rue);
                    StrCat(ChaineDDE^,Separateur);
                  end;
             if ChampsChercher[id_CP] = 1
                then
                  begin
                    StrCat(ChaineDDE^,CP); StrCat(ChaineDDE^,Separateur);
                  end;
             if ChampsChercher[id_Localite] = 1
                then
                  begin
                    StrCat(ChaineDDE^,Localite); StrCat(ChaineDDE^,Separateur);
                  end;
             if ChampsChercher[id_TelPrive] = 1
                then
                  begin
                    StrCat(ChaineDDE^,TelPrive); StrCat(ChaineDDE^,Separateur);
                  end;
             if ChampsChercher[id_FaxPrive] = 1
                then
                  begin
                    StrCat(ChaineDDE^,FaxPrive); StrCat(ChaineDDE^,Separateur);
                  end;
             if ChampsChercher[id_TelBureau] = 1
                then
                  begin
                    StrCat(ChaineDDE^,TelBureau); StrCat(ChaineDDE^,Separateur);
                  end;
             if ChampsChercher[id_FaxBureau] = 1
                then
                  begin
                    StrCat(ChaineDDE^,FaxBureau); StrCat(ChaineDDE^,Separateur);
                  end;
             if ChampsChercher[id_eMail] = 1
                then
                  begin
                    StrCat(ChaineDDE^,eMail); StrCat(ChaineDDE^,Separateur);
                  end;
             if ChampsChercher[id_Remarque] = 1
                then
                  begin
                    StrCat(ChaineDDE^,Remarque); StrCat(ChaineDDE^,Separateur);
                  end;
             (* SUPPRESSION DU DERNIER SEPARATEUR ET AJOUT D'UN SAUT DE LIGNE *)
             Longueur:=StrLen(ChaineDDE^); if Longueur > 2 then ChaineDDE^[Longueur-1]:=#0;
             StrCat(ChaineDDE^,#13);
             (* PASSAGE AU SUIVANT *)
             p:=p^.pSuiv;
           end;
       end;
  DDE_TOUTES:=ChaineDDE;
End;

Function tFenetrePrincipale.DDE_MANUELLEMENT : pChaineDDE;
(* CONSTRUCTION DE LA CHAINE DE DONNEES AVEC LES FICHES SELECTIONNEES MANUELLEMENT - RENVOIE nil SI ERREUR *)
Var p : pListeDonneesPers;               (* ELEMENT DE LA LISTE CHAINEE DES DONNEES PERSONNELLES *)
    ChaineDDE : pChaineDDE;              (* CHAINE DE CONSTRUCTION DES DONNEES A RENVOYER (DANS LE TAS GLOBAL) *)
    Longueur : Word;                     (* LONGUEUR DE LA CHAINE DE CONSTRUCTION *)
    CopieRue : Array [0..120] of Char;   (* COPIE DU CHAMP Rue *)
    Rue2 : pChar;                        (* ADRESSE DE LA 2EME LIGNE DU TEXTE MULTILIGNE DU CONTROLE Rue *)
Begin
  New(ChaineDDE);
  if ChaineDDE <> nil
     then
       if LECTURE_SELECTIONS > 0
          then
            begin
              ChaineDDE^[0]:=#0;
              p:=pTete;
              while p <> nil do
                begin
                  if p^.Selection
                     then with p^.DonneesPers do
                       begin
                         if ChampsChercher[id_Formule] = 1
                            then
                              begin
                                StrCat(ChaineDDE^,Formule); StrCat(ChaineDDE^,Separateur);
                              end;
                         if ChampsChercher[id_Nom] = 1
                            then
                              begin
                                StrCat(ChaineDDE^,Nom); StrCat(ChaineDDE^,Separateur);
                              end;
                         if ChampsChercher[id_Prenom] = 1
                            then
                              begin
                                StrCat(ChaineDDE^,Prenom); StrCat(ChaineDDE^,Separateur);
                              end;
                         if ChampsChercher[id_Rue] = 1
                            then
                              begin
                                StrCopy(CopieRue,Rue); Rue2:=StrPos(CopieRue,#13);
                                if Rue2 <> nil
                                   then   (* LA RUE EST DIVISEE EN DEUX LIGNES *)
                                     begin
                                       Rue2[0]:=#0;   (* MARQUE DE FIN DE LA 1ERE LIGNE DE TEXTE *)
                                       Inc(Rue2,2);   (* ADAPTATION DE L'ADRESSE DE LA 2EME LIGNE *)
                                       StrCat(ChaineDDE^,CopieRue); StrCat(ChaineDDE^,' - '); StrCat(ChaineDDE^,Rue2);
                                     end
                                   else   (* LA RUE N'EST PAS DIVISEE *)
                                     StrCat(ChaineDDE^,Rue);
                                StrCat(ChaineDDE^,Separateur);
                              end;
                         if ChampsChercher[id_CP] = 1
                            then
                              begin
                                StrCat(ChaineDDE^,CP); StrCat(ChaineDDE^,Separateur);
                              end;
                         if ChampsChercher[id_Localite] = 1
                            then
                              begin
                                StrCat(ChaineDDE^,Localite); StrCat(ChaineDDE^,Separateur);
                              end;
                         if ChampsChercher[id_TelPrive] = 1
                            then
                              begin
                                StrCat(ChaineDDE^,TelPrive); StrCat(ChaineDDE^,Separateur);
                              end;
                         if ChampsChercher[id_FaxPrive] = 1
                            then
                              begin
                                StrCat(ChaineDDE^,FaxPrive); StrCat(ChaineDDE^,Separateur);
                              end;
                         if ChampsChercher[id_TelBureau] = 1
                            then
                              begin
                                StrCat(ChaineDDE^,TelBureau); StrCat(ChaineDDE^,Separateur);
                              end;
                         if ChampsChercher[id_FaxBureau] = 1
                            then
                              begin
                                StrCat(ChaineDDE^,FaxBureau); StrCat(ChaineDDE^,Separateur);
                              end;
                         if ChampsChercher[id_eMail] = 1
                            then
                              begin
                                StrCat(ChaineDDE^,eMail); StrCat(ChaineDDE^,Separateur);
                              end;
                         if ChampsChercher[id_Remarque] = 1
                            then
                              begin
                                StrCat(ChaineDDE^,Remarque); StrCat(ChaineDDE^,Separateur);
                              end;
                         (* SUPPRESSION DU DERNIER SEPARATEUR ET AJOUT D'UN SAUT DE LIGNE *)
                         Longueur:=StrLen(ChaineDDE^); if Longueur > 2 then ChaineDDE^[Longueur-1]:=#0;
                         StrCat(ChaineDDE^,#13);
                       end;
                  (* PASSAGE AU SUIVANT *)
                  p:=p^.pSuiv;
                end;
            end
          else   (* AUCUNE FICHE SELECTIONNEE : ERREUR *)
            begin
              Dispose(ChaineDDE); ChaineDDE:=nil;
            end;
  DDE_MANUELLEMENT:=ChaineDDE;
End;

Function tFenetrePrincipale.DDE_AUTOMATIQUE : pChaineDDE;
(* RECHERCHE DE FICHES POUR ENVOYER AU CLIENT DDE - RENVOIE nil SI ERREUR *)
Var p : pListeDonneesPers;               (* ELEMENT DE LA LISTE CHAINEE DES DONNEES PERSONNELLES *)
    ChaineDDE : pChaineDDE;              (* CHAINE DE CONSTRUCTION DES DONNEES A RENVOYER (DANS LE TAS GLOBAL) *)
    n : Word;                            (* LONGUEUR DE LA CHAINE DE CONSTRUCTION - INDICE *)
    Somme : Word;                        (* SOMME DE TEST DES CHAMPS A PASSER EN REVUE *)
    CopieRue : Array [0..120] of Char;   (* COPIE DU CHAMP Rue *)
    Rue2 : pChar;                        (* ADRESSE DE LA 2EME LIGNE DU TEXTE MULTILIGNE DU CONTROLE Rue *)
Begin
  New(ChaineDDE);
  if ChaineDDE <> nil
     then
       begin
         (* TESTE SI LES OPTIONS DE RECHERCHE SONT CORRECTES *)
         if StrLen(Chercher) > 0
            then
              begin
                Somme:=0;
                for n:=id_Formule to id_Remarque do Inc(Somme,ChampsChercher[n]);
                if Somme > 0
                   then   (* OPTIONS CORRECTES : ON Y VA *)
                     begin
                       ChaineDDE^[0]:=#0;
                       p:=RECHERCHE(pTete,false);
                       while p <> nil do with p^.DonneesPers do
                         begin
                           if ChampsChercher[id_Formule] = 1
                              then
                                begin
                                  StrCat(ChaineDDE^,Formule); StrCat(ChaineDDE^,Separateur);
                                end;
                           if ChampsChercher[id_Nom] = 1
                              then
                                begin
                                  StrCat(ChaineDDE^,Nom); StrCat(ChaineDDE^,Separateur);
                                end;
                           if ChampsChercher[id_Prenom] = 1
                              then
                                begin
                                  StrCat(ChaineDDE^,Prenom); StrCat(ChaineDDE^,Separateur);
                                end;
                           if ChampsChercher[id_Rue] = 1
                              then
                                begin
                                  StrCopy(CopieRue,Rue); Rue2:=StrPos(CopieRue,#13);
                                  if Rue2 <> nil
                                     then   (* LA RUE EST DIVISEE EN DEUX LIGNES *)
                                       begin
                                         Rue2[0]:=#0;   (* MARQUE DE FIN DE LA 1ERE LIGNE DE TEXTE *)
                                         Inc(Rue2,2);   (* ADAPTATION DE L'ADRESSE DE LA 2EME LIGNE *)
                                         StrCat(ChaineDDE^,CopieRue); StrCat(ChaineDDE^,' - '); StrCat(ChaineDDE^,Rue2);
                                       end
                                     else   (* LA RUE N'EST PAS DIVISEE *)
                                       StrCat(ChaineDDE^,Rue);
                                  StrCat(ChaineDDE^,Separateur);
                                end;
                           if ChampsChercher[id_CP] = 1
                              then
                                begin
                                  StrCat(ChaineDDE^,CP); StrCat(ChaineDDE^,Separateur);
                                end;
                           if ChampsChercher[id_Localite] = 1
                              then
                                begin
                                  StrCat(ChaineDDE^,Localite); StrCat(ChaineDDE^,Separateur);
                                end;
                           if ChampsChercher[id_TelPrive] = 1
                              then
                                begin
                                  StrCat(ChaineDDE^,TelPrive); StrCat(ChaineDDE^,Separateur);
                                end;
                           if ChampsChercher[id_FaxPrive] = 1
                              then
                                begin
                                  StrCat(ChaineDDE^,FaxPrive); StrCat(ChaineDDE^,Separateur);
                                end;
                           if ChampsChercher[id_TelBureau] = 1
                              then
                                begin
                                  StrCat(ChaineDDE^,TelBureau); StrCat(ChaineDDE^,Separateur);
                                end;
                           if ChampsChercher[id_FaxBureau] = 1
                              then
                                begin
                                  StrCat(ChaineDDE^,FaxBureau); StrCat(ChaineDDE^,Separateur);
                                end;
                           if ChampsChercher[id_eMail] = 1
                              then
                                begin
                                  StrCat(ChaineDDE^,eMail); StrCat(ChaineDDE^,Separateur);
                                end;
                           if ChampsChercher[id_Remarque] = 1
                              then
                                begin
                                  StrCat(ChaineDDE^,Remarque); StrCat(ChaineDDE^,Separateur);
                                end;
                           (* SUPPRESSION DU DERNIER SEPARATEUR ET AJOUT D'UN SAUT DE LIGNE *)
                           n:=StrLen(ChaineDDE^); if n > 2 then ChaineDDE^[n-1]:=#0;
                           StrCat(ChaineDDE^,#13);
                           (* PASSAGE AU SUIVANT *)
                           p:=RECHERCHE(p^.pSuiv,false);
                         end;
                     end
                   else   (* OPTIONS INCOMPLETES *)
                     begin
                       Dispose(ChaineDDE); ChaineDDE:=nil;
                     end;
              end;
       end;
  DDE_AUTOMATIQUE:=ChaineDDE;
End;

Procedure tFenetrePrincipale.ENVOI_DDE_PRESSE_PAPIER (Requete : Byte);
(* ENVOI DES DONNEES DANS LE PRESSE-PAOPIER ET D'UN ACCUSE DE RECEPTION *)
Var ChaineDDE : pChaineDDE;   (* ADRESSE DES DONNEES CONSTRUITES *)
    Donnees : pChar;          (* ADRESSE DU BLOC MEMOIRE DANS LE PRESSE-PAPIER *)
    LongParam : LongInt;      (* PARAMETRE DE L'ACCUSE DE RECEPTION *)
Begin
  LongParam:=MakeLong(0,AtomeRequete);   (* PAR DEFAUT : ACCUSE DE RECEPTION NEGATIF *)
  case Requete of
    req_Tout : ChaineDDE:=DDE_TOUTES;
    req_Manuel : ChaineDDE:=DDE_MANUELLEMENT;
    req_Auto : ChaineDDE:=DDE_AUTOMATIQUE;
  end;
  if ChaineDDE <> nil
     then   (* LA CHAINE DE DONNEES A ETE CORRECTEMENT CREEE *)
       begin
         HandleDonnees:=GlobalAlloc(gmem_Moveable,StrLen(ChaineDDE^)+1);
         if HandleDonnees <> 0
            then
              begin
                Donnees:=GlobalLock(HandleDonnees);
                if Donnees <> nil
                   then
                     begin
                       StrCopy(Donnees,pChar(ChaineDDE));
                       GlobalUnlock(HandleDonnees);
                       if OpenClipBoard(hWindow)
                          then   (* CHARGEMENT DU HANDLE DES DONNEES DANS LE PRESSE-PAPIER *)
                            begin
                              EmptyClipboard;
                              SetClipboardData(cf_Text,HandleDonnees);
                              CloseClipboard;
                              LongParam:=MakeLong(dde_ACK,AtomeRequete);   (* ACCUSE DE RECEPTION POSITIF *)
                            end
                          else   (* IMPOSSIBLE D'OUVRIR LE PRESSE-PAPIER *)
                            GlobalFree(HandleDonnees);
                     end
                   else   (* IMPOSSIBLE DE VERROUILLER LE BLOC DE DONNEES *)
                     GlobalFree(HandleDonnees);
              end;
         Dispose(ChaineDDE);
       end;
  (* ENVOI DE L'ACCUSE DE RECEPTION POSITIF OU NEGATIF *)
  if not PostMessage(HandleClient,wm_DDE_ACK,hWindow,LongParam)
     then   (* MESSAGE NON RECU : SUPPRESSION DE L'ATOME RUBRIQUE *)
       if AtomeRequete <> 0 then GlobalDeleteAtom(AtomeRequete);
End;

Procedure tFenetrePrincipale.ENVOI_DDE_REQUETE (Requete : Byte);
(* ENVOI DES DONNEES DDE VIA UN MESSAGE wm_DDE_Data *)
Var ChaineDDE : pChaineDDE;   (* ADRESSE DES DONNEES CONSTRUITES *)
    Donnees : pDDEData;       (* ADRESSE DU BLOC MEMOIRE DE LA REPONSE *)
    ACKNegatif : Boolean;     (* INDIQUE S'IL FAUT RENVOYER UN ACK NEGATIF *)
Begin
  ACKNegatif:=true;
  case Requete of
    req_Tout : ChaineDDE:=DDE_TOUTES;
    req_Manuel : ChaineDDE:=DDE_MANUELLEMENT;
    req_Auto : ChaineDDE:=DDE_AUTOMATIQUE;
  end;
  if ChaineDDE <> nil
     then   (* LA CHAINE DE DONNEES A ETE CORRECTEMENT CREEE *)
       begin
         HandleDonnees:=GlobalAlloc(gmem_DDEShare,SizeOf(tDDEData)+StrLen(ChaineDDE^)+1);
         if HandleDonnees <> 0
            then
              begin
                Donnees:=GlobalLock(HandleDonnees);
                if Donnees <> nil
                   then with Donnees^ do
                     begin
                       Flags:=dde_ACKReq or dde_Release;
                       cfFormat:=cf_Text;
                       Move(ChaineDDE^,Value,StrLen(ChaineDDE^)+1);
                       GlobalUnlock(HandleDonnees);
                       (* REPONSE A LA REQUETE *)
                       if PostMessage(HandleClient,wm_DDE_Data,hWindow,MakeLong(HandleDonnees,AtomeRequete))
                          then   (* LE CLIENT A BIEN RECU LES DONNEES *)
                            ACKNegatif:=false
                          else   (* LE CLIENT N'A PAS RECU LES DONNEES : SUPPRESSION DE CELLES-CI ET DE L'ATOME REQUETE *)
                            begin
                              GlobalFree(HandleDonnees);
                              GlobalDeleteAtom(AtomeRequete);
                            end;
                     end;
              end;
         Dispose(ChaineDDE);
       end;
  if ACKNegatif
     then   (* ACCUSE DE RECEPTION NEGATIF *)
       if not PostMessage(HandleClient,wm_DDE_ACK,hWindow,MakeLong(0,AtomeRequete))
          then   (* MESSAGE NON RECU : SUPPRESSION DE L'ATOME REQUETE *)
            if AtomeRequete <> 0 then GlobalDeleteAtom(AtomeRequete);
End;

Procedure tFenetrePrincipale.IDENVOIDDE (var Msg : tMessage);
(* ENVOI DES DONNEES SELECTIONNEES MANUELLEMENT AU CLIENT DDE *)
Begin
  if EnvoiPressePapier then ENVOI_DDE_PRESSE_PAPIER(req_Manuel) else ENVOI_DDE_REQUETE(req_Manuel);
End;

Procedure tFenetrePrincipale.WMDDEINITIATE (var Msg : tMessage);
(* APPEL DDE D'UNE APPLICATION CLIENT *)
Var AtomeApplication, AtomeRubrique : tAtom;   (* NOM DE L'APPLICATION ET RUBRIQUE DE LA CONVERSATION *)
    DetruireAtomes : Boolean;                  (* INDIQUE SI LES DEUX ATOMES CI-DESSUS DOIVENT ETRE DETRUITS A LA FIN *)
    c : Array [0..11] of Char;                 (* ELEMENT DE LA TABLE DE CHAINES *)
Begin
  DetruireAtomes:=false;
  HandleClient:=Msg.wParam;
  AtomeApplication:=LoWord(Msg.lParam); if AtomeApplication <> 0 then GlobalDeleteAtom(AtomeApplication);
  LoadString(hInstance,dde_Application,c,SizeOf(c));
  AtomeApplication:=GlobalAddAtom(c);
  AtomeRubrique:=HiWord(Msg.lParam);
  if AtomeRubrique = 0
     then   (* SUJET NUL : ENVOI DE LA LISTE DES SUJETS RECONNUS PAR L'APPLICATION *)
       begin
         LoadString(hInstance,dde_Mailing,c,SizeOf(c));
         AtomeRubrique:=GlobalAddAtom(c);
         if SendMessage(HandleClient,wm_DDE_ACK,hWindow,MakeLong(AtomeApplication,AtomeRubrique)) <> 0
            then
              begin
                if AtomeRubrique <> 0 then GlobalDeleteAtom(AtomeRubrique);
                LoadString(hInstance,dde_ListeChamps,c,SizeOf(c));
                AtomeRubrique:=GlobalAddAtom(c);
                if SendMessage(HandleClient,wm_DDE_ACK,hWindow,MakeLong(AtomeApplication,AtomeRubrique)) <> 0
                   then
                     begin
                       if AtomeRubrique <> 0 then GlobalDeleteAtom(AtomeRubrique);
                       LoadString(hInstance,dde_Tout,c,SizeOf(c));
                       AtomeRubrique:=GlobalAddAtom(c);
                       if SendMessage(HandleClient,wm_DDE_ACK,hWindow,MakeLong(AtomeApplication,AtomeRubrique)) <> 0
                          then
                            begin
                              if AtomeRubrique <> 0 then GlobalDeleteAtom(AtomeRubrique);
                              LoadString(hInstance,dde_Manuel,c,SizeOf(c));
                              AtomeRubrique:=GlobalAddAtom(c);
                              if SendMessage(HandleClient,wm_DDE_ACK,hWindow,MakeLong(AtomeApplication,AtomeRubrique)) <> 0
                                 then
                                   begin
                                     if AtomeRubrique <> 0 then GlobalDeleteAtom(AtomeRubrique);
                                     LoadString(hInstance,dde_Auto,c,SizeOf(c));
                                     AtomeRubrique:=GlobalAddAtom(c);
                                     if SendMessage(HandleClient,wm_DDE_ACK,hWindow,
                                                    MakeLong(AtomeApplication,AtomeRubrique)) = 0
                                        then
                                          DetruireAtomes:=true;
                                   end
                                 else
                                   DetruireAtomes:=true;
                            end
                          else
                            DetruireAtomes:=true;
                     end
                   else
                     DetruireAtomes:=true;
              end
            else
              DetruireAtomes:=true;
       end
     else   (* ENVOI D'UN ACCUSE DE RECEPTION SIMPLE *)
       begin
         GlobalDeleteAtom(AtomeRubrique);
         LoadString(hInstance,dde_Mailing,c,SizeOf(c));
         AtomeRubrique:=GlobalAddAtom(c);
         if SendMessage(HandleClient,wm_DDE_ACK,hWindow,MakeLong(AtomeApplication,AtomeRubrique)) = 0
            then
              DetruireAtomes:=true;
       end;
  (* SUPPRESSION EVENTUELLE DES ATOMES *)
  if AtomeApplication <> 0 then GlobalDeleteAtom(AtomeApplication);
  if AtomeRubrique <> 0 then GlobalDeleteAtom(AtomeRubrique);
End;

Procedure tFenetrePrincipale.WMDDEPOKE (var Msg : tMessage);
(* RECEPTION DE LA LISTE DES CHAMPS OU DE LA SELECTION DESIRES PAR L'APPLICATION CLIENT *)
Var Rubrique : Array [0..255] of Char;   (* RUBRIQUE DEMANDEE PAR L'APPLICATION CLIENT *)
    HandleDonneesDDE : tHandle;          (* HANDLE DU BLOC MEMOIRE DES DONNEES PASSEES AU PROGRAMME *)
    DonneesDDE : pDDEPoke;               (* ADRESSE DE LA LISTE DES CHAMPS *)
    n : Word;                            (* INDICE DANS LA LISTE DES CHAMPS *)
    SupprimerDonnees : Boolean;          (* INDIQUE S'IL FAUT SUPPRIMER LES DONNEES A LA FIN *)
    c : Array [0..11] of Char;           (* ELEMENT DE LA TABLE DES CHAINES *)
    Titre : Array [0..32] of Char;       (* TITRE DE LA BOITE A MESSAGES DE SELECTION MANUELLE *)
    Texte : Array [0..73] of Char;       (* TEXTE DE LA BOITE A MESSAGES DE SELECTION MANUELLE *)
Begin
  SupprimerDonnees:=false;
  AtomeRequete:=HiWord(Msg.lParam);
  if GlobalGetAtomName(AtomeRequete,Rubrique,SizeOf(Rubrique)) > 0
     then
       begin
         (* DETERMINATION DU HANDLE DES DONNEES ET VERROUILLAGE *)
         HandleDonneesDDE:=LoWord(Msg.lParam);
         DonneesDDE:=GlobalLock(HandleDonneesDDE);
         (* REACTION A LA RUBRIQUE DEMANDEE *)
         LoadString(hInstance,dde_ListeChamps,c,SizeOf(c));
         if StrComp(Rubrique,c) = 0
            then   (* IL S'AGIT DE LA LISTE DES CHAMPS *)
              begin
                if (DonneesDDE <> nil) and (DonneesDDE^.cfFormat = cf_Text)
                   then   (* CHARGEMENT DES CHAMPS DESIRES *)
                     begin
                       if (DonneesDDE^.Flags and dde_Release) <> 0 then SupprimerDonnees:=true;
                       for n:=id_Formule to id_Remarque do ChampsChercher[n]:=1;
                       for n:=0 to 12 do if Char(DonneesDDE^.Value[n]) = '0' then ChampsChercher[id_Formule+n]:=0;
                       GlobalUnlock(HandleDonneesDDE);
                       (* ENVOI DE L'ACCUSE DE RECEPTION *)
                       if not PostMessage(Msg.wParam,wm_DDE_ACK,hWindow,MakeLong(dde_ACK,AtomeRequete))
                          then   (* MESSAGE NON RECU : SUPPRESSION DE L'ATOME RUBRIQUE ET DES DONNEES *)
                            begin
                              GlobalDeleteAtom(AtomeRequete);
                              SupprimerDonnees:=true;
                            end;
                     end;
              end
            else
              begin
                if (DonneesDDE <> nil) and ((DonneesDDE^.Flags and dde_Release) <> 0) then SupprimerDonnees:=true;
                LoadString(hInstance,dde_Tout,c,SizeOf(c));
                if StrComp(Rubrique,c) = 0
                   then   (* SELECTIONNER TOUT *)
                     begin
                       EnvoiPressePapier:=true;
                       ENVOI_DDE_PRESSE_PAPIER(req_Tout);
                     end
                   else
                     begin
                       LoadString(hInstance,dde_Manuel,c,SizeOf(c));
                       if StrComp(Rubrique,c) = 0
                          then   (* SELECTION ET ENVOI MANUELS DES DONNEES *)
                            begin
                              EnvoiPressePapier:=true;
                              (* AFFICHAGE DU BOUTON D'ENVOI *)
                              Ctl_EnvoiDDE^.Show(sw_Normal); EnvoiManuel:=true;
                              (* MESSAGE D'EXPLICATION *)
                              LoadString(hInstance,dde_TitreEnvoi,Titre,SizeOf(Titre));
                              LoadString(hInstance,dde_TexteEnvoi,Texte,SizeOf(Texte));
                              if MessageBox(hWindow,Texte,Titre,mb_OkCancel or mb_IconExclamation) <> id_Ok
                                 then   (* L'OPERATION EST ANNULEE PAR L'UTILISATEUR : EFFACEMENT DU BOUTON D'ENVOI *)
                                   Ctl_EnvoiDDE^.Show(sw_Hide);
                            end
                          else
                            begin
                              LoadString(hInstance,dde_Auto,c,SizeOf(c));
                              if StrLComp(Rubrique,c,4) = 0
                                 then   (* RECHERCHE AUTOMATIQUE D'UNE CHAINE *)
                                   begin
                                     StrCopy(Chercher,Rubrique+4);   (* CHAINE A RECHERCHER *)
                                     EnvoiPressePapier:=true;
                                     ENVOI_DDE_PRESSE_PAPIER(req_Auto);
                                   end;
                            end;
                     end;
              end;
       end;
  if SupprimerDonnees then GlobalFree(HandleDonneesDDE);
End;

Procedure tFenetrePrincipale.WMDDEREQUEST (var Msg : tMessage);
(* REPONSE A LA REQUETE DDE D'UNE APPLICATION CLIENT *)
Var Rubrique : Array [0..255] of Char;   (* RUBRIQUE DEMANDEE PAR LE CLIENT *)
    ACKNegatif : Boolean;                (* INDIQUE S'IL FAUT RENVOYER UN ACK NEGATIF *)
    c : Array [0..11] of Char;           (* ELEMENT DE LA TABLE DE CHAINES *)
    Titre : Array [0..32] of Char;       (* TITRE DE LA BOITE A MESSAGES DE SELECTION MANUELLE *)
    Texte : Array [0..73] of Char;       (* TEXTE DE LA BOITE A MESSAGES DE SELECTION MANUELLE *)
Begin
  ACKNegatif:=false;
  AtomeRequete:=HiWord(Msg.lParam);
  if (AtomeRequete <> 0) and (GlobalGetAtomName(AtomeRequete,Rubrique,SizeOf(Rubrique)) > 0)
     then   (* LE CLIENT A INTRODUIT UNE REQUETE *)
       begin
         EnvoiPressePapier:=false;
         LoadString(hInstance,dde_Tout,c,SizeOf(c));
         if StrComp(Rubrique,c) = 0
            then   (* IL FAUT RENVOYER TOUS LES ELEMENTS DE LA LISTE *)
              ENVOI_DDE_REQUETE(req_Tout)
            else
              begin
                LoadString(hInstance,dde_Manuel,c,SizeOf(c));
                if StrComp(Rubrique,c) = 0
                   then   (* LA SELECTION ET L'ENVOI DOIVENT ETRE MANUELS *)
                     begin
                       (* AFFICHAGE DU BOUTON D'ENVOI *)
                       Ctl_EnvoiDDE^.Show(sw_Normal); EnvoiManuel:=true;
                       (* MESSAGE D'EXPLICATION *)
                       LoadString(hInstance,dde_TitreEnvoi,Titre,SizeOf(Titre));
                       LoadString(hInstance,dde_TexteEnvoi,Texte,SizeOf(Texte));
                       if MessageBox(hWindow,Texte,Titre,mb_OkCancel or mb_IconExclamation) <> id_Ok
                          then   (* L'OPERATION EST ANNULEE PAR L'UTILISATEUR : EFFACEMENT DU BOUTON D'ENVOI *)
                            Ctl_EnvoiDDE^.Show(sw_Hide);
                     end
                   else
                     begin
                       LoadString(hInstance,dde_Auto,c,SizeOf(c));
                       if StrLComp(Rubrique,c,4) = 0
                          then   (* RECHERCHE AUTOMATIQUE D'UNE CHAINE (QUI SUIT Auto DANS LA RUBRIQUE) *)
                            begin
                              StrCopy(Chercher,Rubrique+4);   (* CHAINE A RECHERCHER *)
                              ENVOI_DDE_REQUETE(req_Auto);
                            end
                          else   (* REQUETE INCONNUE *)
                            ACKNegatif:=true;
                     end;
              end;
       end
     else   (* PAS D'ATOME REQUETE OU CHAINE VIDE *)
       ACKNegatif:=true;
  if ACKNegatif
     then   (* ACCUSE DE RECEPTION NEGATIF *)
       if not PostMessage(HandleClient,wm_DDE_ACK,hWindow,MakeLong(0,AtomeRequete))
          then   (* MESSAGE NON RECU : SUPPRESSION DE L'ATOME RUBRIQUE *)
            if AtomeRequete <> 0 then GlobalDeleteAtom(AtomeRequete);
End;

Procedure tFenetrePrincipale.WMDDEACK (var Msg : tMessage);
(* RECEPTION D'UN ACCUSE DE RECEPTION DES DONNEES DE LA REQUETE *)
Var AtomeRubrique : tAtom;               (* RUBRIQUE CONCERNEE PAR L'ACCUSEE DE RECEPTION *)
    Rubrique : Array [0..255] of Char;   (* COPIE DE LA RUBRIQUE *)
    c1, c2, c3 : Array [0..5] of Char;   (* ELEMENTS DE LA TABLE DE CHAINES *)
Begin
  AtomeRubrique:=HiWord(Msg.lParam);
  LoadString(hInstance,dde_Tout,c1,SizeOf(c1));
  LoadString(hInstance,dde_Manuel,c2,SizeOf(c2));
  LoadString(hInstance,dde_Auto,c3,SizeOf(c3));
  if (AtomeRubrique <> 0) and (GlobalGetAtomName(AtomeRubrique,Rubrique,SizeOf(Rubrique)) > 0) and
     ((StrComp(Rubrique,c1) = 0) or (StrComp(Rubrique,c2) = 0) or (StrLComp(Rubrique,c3,4) = 0))
     then   (* LE CLIENT N'A PAS RECU LES DONNEES CORRECTEMENT : DESTRUCTION DE CELLES-CI *)
       begin
         GlobalFree(HandleDonnees);
         GlobalDeleteAtom(AtomeRubrique);
       end;
End;

Procedure tFenetrePrincipale.WMDDETERMINATE (var Msg : tMessage);
(* FIN DE COMMUNICATION DDE AVEC UNE APPLICATION CLIENT *)
Begin
  if EnvoiManuel
     then   (* L'ENVOI DES DONNEES ETAIT MANUEL : EFFACER LE BOUTON *)
       begin
         Ctl_EnvoiDDE^.Show(sw_Hide); EnvoiManuel:=false;
       end;
  PostMessage(Msg.wParam,wm_DDE_Terminate,hWindow,0);
End;

Procedure tFenetrePrincipale.IDAJOUTER (var Msg : tMessage);
(* AJOUT D'UNE NOUVELLE PERSONNE DANS LA LISTE *)
Var p : pListeDonneesPers;    (* NOUVEL ELEMENT DANS LA LISTE CHAINEE *)
    pr : pListeDonneesPers;   (* ELEMENT DE RECHERCHE DANS LA LISTE CHAINEE *)
    NomPrenom : tNomPrenom;   (* GROUPE NOM+PRENOM DANS LA BOITE LISTE *)
    Index : Word;             (* INDEX DU NOUVEL ELEMENT DANS LA BOITE LISTE *)
Begin
  New(p);
  if p <> nil
     then
       begin
         FillChar(p^.DonneesPers,SizeOf(p^.DonneesPers),#0);
         Application^.ExecDialog(New(pDlgDonneesPers,INIT(@Self,'DIALOGUE_DONNEES_PERS',@p^.DonneesPers)));
         if StrLen(p^.DonneesPers.Nom) > 0
            then   (* LA NOUVELLE FICHE A ETE ENCODEE : INSERTION DANS LA LISTE *)
              begin
                (* GROUPE NOM+PRENOM POUR RECHERCHE ULTERIEURE DE L'INDICE DE LA NOUVELLE FICHE DANS LA BOITE LISTE *)
                CONSTRUCTION_GROUPE_NOM_PRENOM(p,NomPrenom);
                Modification:=true;
                (* AJOUT DANS LA LISTE CHAINEE *)
                if pQueue = nil
                   then   (* LA LISTE EST ENCORE VIDE *)
                     begin
                       pTete:=p; pQueue:=p;
                       p^.pPrec:=nil;
                     end
                   else   (* AJOUT A LA FIN DE LA LISTE *)
                     begin
                       pQueue^.pSuiv:=p; p^.pPrec:=pQueue;
                       pQueue:=p;
                     end;
                p^.pSuiv:=nil;
                (* TRI DE LA LISTE CHAINEE *)
                TRI_LISTE_DONNEES_PERS;
                (* MISE A JOUR DE LA BOITE LISTE *)
                MISE_A_JOUR_BOITE_LISTE;
                (* SELECTION DU NOUVEL ELEMENT DANS LA BOITE LISTE *)
                Index:=SendDlgItemMessage(hWindow,id_Liste,lb_FindString,$FFFF,LongInt(@NomPrenom));
                SendDlgItemMessage(hWindow,id_Liste,lb_SetCaretIndex,Index,0);
                (* MISE A JOUR DE L'AFFICHAGE AU BAS DE LA FENETRE *)
                InvalidateRect(hWindow,@RectDonneesPers,true);
                UpdateWindow(hWindow);
              end
            else   (* ENCODAGE ANNULE : DESALLOCATION DE p *)
              Dispose(p);
       end
     else   (* ERREUR D'ALLOCATION *)
       MESSAGE_ERREUR_MEMOIRE(erm_TitreAjoutFiche);
End;

Procedure tFenetrePrincipale.IDMODIFIER (var Msg : tMessage);
(* MODIFICATION DES DONNEES PERSONNELLES DE LA PERSONNE COURANTE *)
Var Index : Word;                 (* INDICE DE LA PERSONNE AYANT LE FOCUS DANS LA BOITE LISTE, INDICE *)
    NomPrenom : tNomPrenom;       (* GROUPE NOM+PRENOM DANS LA BOITE LISTE *)
    p : pListeDonneesPers;        (* ELEMENT DE LA LISTE CHAINEE DES DONNEES PERSONNELLES *)
    DonneesTemp : tDonneesPers;   (* COPIE DES DONNEES DE DEPART *)
Begin
  Index:=SendDlgItemMessage(hWindow,id_Liste,lb_GetCaretIndex,0,0);
  if SendDlgItemMessage(hWindow,id_Liste,lb_GetText,Index,LongInt(@NomPrenom)) <> lb_Err
     then   (* UNE PERSONNE A LE FOCUS *)
       begin
         (* RECHERCHE DANS LA LISTE CHAINEE DES PERSONNES *)
         p:=POINTEUR_CORRESPONDANT_NOM_PRENOM(NomPrenom);
         if p <> nil
            then
              begin
                (* COPIE DES DONNEES DE DEPART *)
                DonneesTemp:=p^.DonneesPers;
                (* DIALOGUE DE MODIFICATION *)
                Application^.ExecDialog(New(pDlgDonneesPers,INIT(@Self,'DIALOGUE_DONNEES_PERS',@p^.DonneesPers)));
                (* TEST SI MODIFICATIONS *)
{
                with p^.DonneesPers do
                  if (StrComp(Formule,DonneesTemp.Formule) <> 0) or (StrComp(Nom,DonneesTemp.Nom) <> 0) or
                     (StrComp(Prenom,DonneesTemp.Prenom) <> 0) or (StrComp(Rue,DonneesTemp.Rue) <> 0) or
                     (StrComp(CP,DonneesTemp.CP) <> 0) or (StrComp(Localite,DonneesTemp.Localite) <> 0) or
                     (StrComp(TelPrive,DonneesTemp.TelPrive) <> 0) or (StrComp(FaxPrive,DonneesTemp.FaxPrive) <> 0) or
                     (StrComp(TelBureau,DonneesTemp.TelBureau) <> 0) or (StrComp(FaxBureau,DonneesTemp.FaxBureau) <> 0) or
                     (StrComp(eMail,DonneesTemp.eMail) <> 0) or (StrComp(Remarque,DonneesTemp.Remarque) <> 0)
}
                if COMPARE(@p^.DonneesPers,@DonneesTemp,SizeOf(p^.DonneesPers)) <> 0
                   then   (* IL Y A EU MODIFICATION *)
                     begin
                       Modification:=true;
                       (* TRI DE LA LISTE CHAINEE *)
                       TRI_LISTE_DONNEES_PERS;
                       (* MISE A JOUR DE LA BOITE LISTE *)
                       MISE_A_JOUR_BOITE_LISTE;
                       (* MISE A JOUR DE L'AFFICHAGE AU BAS DE LA FENETRE *)
                       InvalidateRect(hWindow,@RectDonneesPers,true);
                       UpdateWindow(hWindow);
                     end;
              end;
       end
     else   (* AUCUNE PERSONNE N'A LE FOCUS *)
       MessageBeep($FFFF);
End;

Procedure tFenetrePrincipale.IDSUPPRIMER (var Msg : tMessage);
(* SUPPRESSION DE LA PERSONNE COURANTE *)
Var Index : Word;                    (* INDICE DE LA PERSONNE AYANT LE FOCUS DANS LA BOITE LISTE, INDICE *)
    NomPrenom : tNomPrenom;          (* GROUPE NOM+PRENOM DANS LA BOITE LISTE *)
    p, pAux : pListeDonneesPers;     (* ELEMENT DE LA LISTE CHAINEE DES DONNEES PERSONNELLES *)
    Titre : Array [0..23] of Char;   (* TITRE DU MESSAGE DE CONFIRMATION *)
    Texte : Array [0..42] of Char;   (* TEXTE DU MESSAGE DE CONFIRMATION *)
Begin
  Index:=SendDlgItemMessage(hWindow,id_Liste,lb_GetCaretIndex,0,0);
  if SendDlgItemMessage(hWindow,id_Liste,lb_GetText,Index,LongInt(@NomPrenom)) <> lb_Err
     then   (* UNE PERSONNE A LE FOCUS *)
       begin
         (* RECHERCHE DANS LA LISTE CHAINEE DES PERSONNES *)
         p:=POINTEUR_CORRESPONDANT_NOM_PRENOM(NomPrenom);
         (* CONFIRMATION ET SUPPRESSION *)
         LoadString(hInstance,msg_TitreSupprimer,Titre,SizeOf(Titre));
         LoadString(hInstance,msg_Supprimer,Texte,SizeOf(Texte));
         if (p <> nil) and (MessageBox(hWindow,Texte,Titre,mb_IconQuestion or mb_YesNo) = id_Yes)
            then
              begin
                (* SUPPRESSION DANS LA BOITE LISTE *)
                SendDlgItemMessage(hWindow,id_Liste,lb_DeleteString,Index,0);
                (* SUPPRESSION DANS LA LISTE CHAINEE *)
                pAux:=p^.pPrec;
                if pAux = nil then pTete:=p^.pSuiv else pAux^.pSuiv:=p^.pSuiv;
                pAux:=p^.pSuiv;
                if pAux = nil then pQueue:=p^.pPrec else pAux^.pPrec:=p^.pPrec;
                Dispose(p);
                Modification:=true;
              end;
       end
     else   (* AUCUNE PERSONNE N'A LE FOCUS *)
       MessageBeep($FFFF);
End;

Procedure tFenetrePrincipale.IDTRIER (var Msg : tMessage);
(* TRI DE LA LISTE DES DONNEES PERSONNELLES *)
Var TriTemp : Integer;    (* COPIE DE L'OPTION DE TRI DE DEPART *)
    SensTriTemp : Byte;   (* COPIE DU SENS DE TRI DE DEPART *)
Begin
  (* SAUVEGARDE DE L'ETAT DES OPTIONS *)
  TriTemp:=Tri; SensTriTemp:=SensTri;
  (* CHOIX DU CRITERE DE TRI *)
  Application^.ExecDialog(New(pDlgTri,INIT(@Self,'DIALOGUE_TRI',@Tri,@SensTri)));
  (* DETERMINE S'IL Y A EU MODIFICATION *)
  if not ModificationOptions
     then
       if (Tri <> TriTemp) or (SensTri <> SensTriTemp) then ModificationOptions:=true;
  (* TRI *)
  TRI_LISTE_DONNEES_PERS;
  (* MISE A JOUR DE LA BOITE LISTE *)
  MISE_A_JOUR_BOITE_LISTE;
  (* MISE A JOUR DE L'AFFICHAGE AU BAS DE LA FENETRE *)
  InvalidateRect(hWindow,@RectDonneesPers,true);
  UpdateWindow(hWindow);
End;

Function tFenetrePrincipale.RECHERCHE (pDepart : pListeDonneesPers; MsgFin : Boolean) : pListeDonneesPers;
(* RECHERCHE DE L'OCCURENCE SUIVANTE DE L'EXTRAIT DE TEXTE Chercher.
   SI MsgFin = true ALORS, A LA FIN DE LA LISTE, DEMANDER S'IL FAUT RECOMMENCER LA RECHERCHE AU DEBUT *)
Var p : pListeDonneesPers;                   (* ELEMENT DE LA LISTE DES DONNEES PERSONNELLES *)
    n : Word;                                (* INDICE DANS LE TABLEAU DES CHAMPS *)
    CopieChamp : Array [0..120] of Char;     (* COPIE EN MAJUSCULES DU CHAMP OU S'EFFECTUE LA RECHERCHE *)
    CopieChercher : Array [0..60] of Char;   (* COPIE EN MAJUSCULES DE LA CHAINE A CGERCHER *)
    Titre : Array [0..8] of Char;            (* TITRE DE LA BOITE DE MESSAGE *)
    Texte : Array [0..70] of Char;           (* TEXTE DE LA BOITE DE MESSAGE *)
    Trouve : Boolean;                        (* INDIQUE SI LA CHAINE EST TROUVEE *)
Begin
  StrCopy(CopieChercher,Chercher); StrUpper(CopieChercher);   (* MISE EN MAJUSCULES DE L'EXTRAIT *)
  p:=pDepart; Trouve:=false;
  while (p <> nil) and (not Trouve) do with p^.DonneesPers do
    begin
      if ChampsChercher[id_Formule] = 1
         then
           begin
             StrCopy(CopieChamp,Formule); StrUpper(CopieChamp);
             Trouve:=(StrPos(CopieChamp,CopieChercher) <> nil);
           end;
      if (not Trouve) and (ChampsChercher[id_Nom] = 1)
         then
           begin
             StrCopy(CopieChamp,Nom); StrUpper(CopieChamp);
             Trouve:=(StrPos(CopieChamp,CopieChercher) <> nil);
           end;
      if (not Trouve) and (ChampsChercher[id_Prenom] = 1)
         then
           begin
             StrCopy(CopieChamp,Prenom); StrUpper(CopieChamp);
             Trouve:=(StrPos(CopieChamp,CopieChercher) <> nil);
           end;
      if (not Trouve) and (ChampsChercher[id_Rue] = 1)
         then
           begin
             StrCopy(CopieChamp,Rue); StrUpper(CopieChamp);
             Trouve:=(StrPos(CopieChamp,CopieChercher) <> nil);
           end;
      if (not Trouve) and (ChampsChercher[id_CP] = 1)
         then
           begin
             StrCopy(CopieChamp,CP); StrUpper(CopieChamp);
             Trouve:=(StrPos(CopieChamp,CopieChercher) <> nil);
           end;
      if (not Trouve) and (ChampsChercher[id_Localite] = 1)
         then
           begin
             StrCopy(CopieChamp,Localite); StrUpper(CopieChamp);
             Trouve:=(StrPos(CopieChamp,CopieChercher) <> nil);
           end;
      if (not Trouve) and (ChampsChercher[id_TelPrive] = 1)
         then
           begin
             StrCopy(CopieChamp,TelPrive); StrUpper(CopieChamp);
             Trouve:=(StrPos(CopieChamp,CopieChercher) <> nil);
           end;
      if (not Trouve) and (ChampsChercher[id_FaxPrive] = 1)
         then
           begin
             StrCopy(CopieChamp,FaxPrive); StrUpper(CopieChamp);
             Trouve:=(StrPos(CopieChamp,CopieChercher) <> nil);
           end;
      if (not Trouve) and (ChampsChercher[id_TelBureau] = 1)
         then
           begin
             StrCopy(CopieChamp,TelBureau); StrUpper(CopieChamp);
             Trouve:=(StrPos(CopieChamp,CopieChercher) <> nil);
           end;
      if (not Trouve) and (ChampsChercher[id_FaxBureau] = 1)
         then
           begin
             StrCopy(CopieChamp,FaxBureau); StrUpper(CopieChamp);
             Trouve:=(StrPos(CopieChamp,CopieChercher) <> nil);
           end;
      if (not Trouve) and (ChampsChercher[id_eMail] = 1)
         then
           begin
             StrCopy(CopieChamp,eMail); StrUpper(CopieChamp);
             Trouve:=(StrPos(CopieChamp,CopieChercher) <> nil);
           end;
      if (not Trouve) and (ChampsChercher[id_Remarque] = 1)
         then
           begin
             StrCopy(CopieChamp,Remarque); StrUpper(CopieChamp);
             Trouve:=(StrPos(CopieChamp,CopieChercher) <> nil);
           end;
      if not Trouve
         then   (* PAS TROUVE : ELEMENT SUIVANT *)
           begin
             p:=p^.pSuiv;
             if (p = nil) and MsgFin
                then   (* FIN DE LISTE : DEMANDE S'IL FAUT REPRENDRE AU DEBUT DE LA LISTE *)
                  begin
                    LoadString(hInstance,msg_TitreChercher,Titre,SizeOf(Titre));
                    LoadString(hInstance,msg_Chercher,Texte,SizeOf(Texte));
                    if MessageBox(hWindow,Texte,Titre,mb_IconQuestion or mb_YesNo) = id_Yes
                       then   (* ON REPREND DEPUIS LE DEBUT DE LA LISTE *)
                         p:=pTete;
                  end;
           end;
    end;
  if Trouve then RECHERCHE:=p else RECHERCHE:=nil;
End;

Procedure tFenetrePrincipale.IDCHERCHER (var Msg : tMessage);
(* RECHERCHE D'UN EXTRAIT DE CHAINE DANS UN OU PLUSIEURS CHAMPS *)
Var Continuer : Boolean;             (* RESULTAT DU DIALOGUE *)
    p : pListeDonneesPers;           (* ADRESSE DE L'ELEMENT CORRESPONDANT A LA RECHERCHE *)
    Index : Word;                    (* INDICE DE L'ELEMENT DANS LA BOITE LISTE *)
    NomPrenom : tNomPrenom;          (* GROUPE NOM+PRENOM DE L'ELEMENT TROUVE *)
    Titre : Array [0..8] of Char;    (* TITRE DE LA BOITE DE MESSAGES *)
    Texte : Array [0..56] of Char;   (* TEXTE DE LA BOITE DE MESSAGES *)
Begin
  if pTete <> nil
     then
       begin
         (* DIALOGUE DE CHOIX DES OPTIONS DE RECHERCHE *)
         Application^.ExecDialog(New(pDlgChercher,INIT(@Self,'DIALOGUE_CHERCHER',@ChampsChercher,Chercher,@Continuer)));
         if Continuer
            then   (* LE BOUTON "OK" A ETE PRESSE *)
              begin
                p:=RECHERCHE(pTete,true);
                if p <> nil
                   then   (* LA RECHERCHE EST POSITIVE : POSITIONNEMENT DU FOCUS SUR L'ELEMENT TROUVE *)
                     begin
                       CONSTRUCTION_GROUPE_NOM_PRENOM(p,NomPrenom);
                       Index:=SendDlgItemMessage(hWindow,id_Liste,lb_FindString,$FFFF,LongInt(@NomPrenom));
                       if Index <> lb_Err
                          then
                            begin
                              SendDlgItemMessage(hWindow,id_Liste,lb_SetCaretIndex,Index,0);
                              SendDlgItemMessage(hWindow,id_Liste,lb_SetSel,Word(true),Index);
                            end;
                       (* MISE A JOUR DE L'AFFICHAGE AU BAS DE LA FENETRE *)
                       InvalidateRect(hWindow,@RectDonneesPers,true);
                       UpdateWindow(hWindow);
                     end
                   else   (* RECHERCHE NEGATIVE : MESSAGE DE CARENCE *)
                     begin
                       LoadString(hInstance,msg_TitreChercher,Titre,SizeOf(Titre));
                       LoadString(hInstance,msg_RechercheNegative,Texte,SizeOf(Texte));
                       MessageBox(hWindow,Texte,Titre,mb_IconExclamation or mb_Ok);
                     end;
              end;
       end
     else   (* AUCUN ELEMENT DANS LA LISTE DES DONNEES PERSONNELLES *)
       MessageBeep($FFFF);
End;

Procedure tFenetrePrincipale.IDCHERCHERSUIVANT (var Msg : tMessage);
(* RECHERCHE DE L'OCCURENCE SUIVANTE D'UN EXTRAIT DE CHAINE DANS UN OU PLUSIEURS CHAMPS *)
Var Somme : Word;                    (* SOMME DES ELEMENTS DU TABLEAU DES CHAMPS *)
    n : Integer;                     (* INDICE DANS LE TABLEAU DES CHAMPS *)
    Erreur : Integer;                (* IDENTIFICATEUR DU MESSAGE D'ERREUR *)
    Texte : Array [0..56] of Char;   (* MESSAGE D'ERREUR *)
    Titre : Array [0..20] of Char;   (* TITRE DU MESSAGE D'ERREUR *)
    NomPrenom : tNomPrenom;          (* GROUPE NOM+PRENOM DANS LA BOITE LISTE *)
    Index : Word;                    (* INDICE DE L'ELEMENT COURANT DANS LA BOITE LISTE *)
    p : pListeDonneesPers;           (* ELEMENT DE LA LISTE DES DONNEES PERSONNELLES *)
Begin
  if pTete <> nil
     then
       begin
         Erreur:=0;
         (* TESTE SI LES OPTIONS DE RECHERCHE SONT CORRECTES *)
         if StrLen(Chercher) = 0
            then
              Erreur:=erc_Chercher
            else
              begin
                Somme:=0;
                for n:=id_Formule to id_Remarque do Inc(Somme,ChampsChercher[n]);
                if Somme = 0 then Erreur:=erc_Champs;
              end;
         if Erreur = 0
            then   (* PAS D'ERREUR : RECHERCHE *)
              begin
                Index:=SendDlgItemMessage(hWindow,id_Liste,lb_GetCaretIndex,0,0);
                if SendDlgItemMessage(hWindow,id_Liste,lb_GetText,Index,LongInt(@NomPrenom)) <> lb_Err
                   then   (* UNE PERSONNE A LE FOCUS *)
                     begin
                       (* RECHERCHE DANS LA LISTE CHAINEE DES PERSONNES *)
                       p:=POINTEUR_CORRESPONDANT_NOM_PRENOM(NomPrenom);
                       if p <> nil
                          then   (* RECHERCHE *)
                            begin
                              p:=p^.pSuiv;
                              if p <> nil then p:=RECHERCHE(p,true);
                              if p <> nil
                                 then   (* LA RECHERCHE EST POSITIVE : POSITIONNEMENT DU FOCUS SUR L'ELEMENT TROUVE *)
                                   begin
                                     CONSTRUCTION_GROUPE_NOM_PRENOM(p,NomPrenom);
                                     Index:=SendDlgItemMessage(hWindow,id_Liste,lb_FindString,$FFFF,LongInt(@NomPrenom));
                                     if Index <> lb_Err
                                        then
                                          begin
                                            SendDlgItemMessage(hWindow,id_Liste,lb_SetCaretIndex,Index,0);
                                            SendDlgItemMessage(hWindow,id_Liste,lb_SetSel,Word(true),Index);
                                          end;
                                     (* MISE A JOUR DE L'AFFICHAGE AU BAS DE LA FENETRE *)
                                     InvalidateRect(hWindow,@RectDonneesPers,true);
                                     UpdateWindow(hWindow);
                                   end
                                 else   (* RECHERCHE NEGATIVE : MESSAGE DE CARENCE *)
                                   begin
                                     LoadString(hInstance,msg_TitreChercher,Titre,SizeOf(Titre));
                                     LoadString(hInstance,msg_RechercheNegative,Texte,SizeOf(Texte));
                                     MessageBox(hWindow,Texte,Titre,mb_IconExclamation or mb_Ok);
                                   end;
                            end
                          else
                            MessageBeep($FFFF);
                     end
                   else   (* AUCUNE PERSONNE N'A LE FOCUS : ERREUR *)
                     MessageBeep($FFFF);
              end
            else   (* MESSAGE D'ERREUR *)
              begin
                LoadString(hInstance,erc_TitreChercher,Titre,SizeOf(Titre));
                LoadString(hInstance,Erreur,Texte,SizeOf(Texte));
                MESSAGEBOX(hWindow,Texte,Titre,mb_IconExclamation or mb_Ok);
              end;
       end
     else   (* AUCUN ELEMENT DANS LA LISTE DES DONNEES PERSONNELLES *)
       MessageBeep($FFFF);
End;

Procedure tFenetrePrincipale.IDSELECTIONNERTOUT (var Msg : tMessage);
(* SELECTION DE TOUS LES ELEMENTS DE LA BOITE LISTE *)
Var Nb : Word;   (* NOMBRE D'ELEMENTS DANS LA BOITE LISTE *)
Begin
  (* DETERMINATION DU NOMBRE D'ELEMENTS DE LA LISTE *)
  Nb:=SendDlgItemMessage(hWindow,id_Liste,lb_GetCount,0,0);
  (* SELECTION *)
  if (Nb > 0) and (Nb <> lb_Err) then SendDlgItemMessage(hWindow,id_Liste,lb_SelItemRange,1,MakeLong(0,Nb-1));
End;

Procedure tFenetrePrincipale.IDDESELECTIONNERTOUT (var Msg : tMessage);
(* SELECTION DE TOUS LES ELEMENTS DE LA BOITE LISTE *)
Var Nb : Word;   (* NOMBRE D'ELEMENTS DANS LA BOITE LISTE *)
Begin
  (* DETERMINATION DU NOMBRE D'ELEMENTS DE LA LISTE *)
  Nb:=SendDlgItemMessage(hWindow,id_Liste,lb_GetCount,0,0);
  (* SELECTION *)
  if (Nb > 0) and (Nb <> lb_Err) then SendDlgItemMessage(hWindow,id_Liste,lb_SelItemRange,0,MakeLong(0,Nb-1));
End;

Procedure tFenetrePrincipale.IDETIQUETTES (var Msg : tMessage);
(* IMPRESSION D'ETIQUETTES *)
Var v1, v2, v3, v4 : Real;              (* COPIE DES MARGES *)
    v5, v6 : Byte;                      (* COPIE DES NOMBRES D'ETIQUETTES *)
    i, j : Byte;                        (* INDICES *)
    Numero : Word;                      (* NUMERO DE LA FEUILLE D'ETIQUETTES COURANTE *)
    NbTotal, NbFeuille : Word;          (* NOMBRE TOTAL D'ETIQUETTES A IMPRIMER ET NOMBRE POUR LA FEUILLE COURANTE *)
    Compteur : Word;                    (* COMPTEUR D'ELEMENTS *)
    p, pCourant : pListeDonneesPers;    (* ELEMENTS DE LA LISTE CHAINEE DES DONNEES PERSONNELLES *)
Begin
  (* DANS LA LISTE CHAINEE, SELECTION DES PERSONNES SELECTIONNEES DANS LA BOITE LISTE *)
  NbTotal:=LECTURE_SELECTIONS;
  if NbTotal <> 0
     then
       begin
         (* COPIE DES OPTIONS COURANTES *)
         v1:=MargeHaut; v2:=MargeBas; v3:=MargeGauche; v4:=MargeDroite; v5:=NbParLigne; v6:=NbParColonne;
         (* DIALOGUE DE DEFINITION DES MARGES *)
         Application^.EXECDIALOG(New(pDlgEtiquettes,INIT(@Self,'DIALOGUE_ETIQUETTES',
                                 @MargeHaut,@MargeBas,@MargeGauche,@MargeDroite,@NbParLigne,@NbParColonne,@NbTotal)));
         (* TEST SI MODIFICATION DES OPTIONS (POUR LA FIN DE PROGRAMME) *)
         if not ModificationOptions
            then
              if (v1 <> MargeHaut) or (v2 <> MargeBas) or (v3 <> MargeGauche) or (v4 <> MargeDroite) or
                 (v5 <> NbParLigne) or (v6 <> NbParColonne)
                 then
                   ModificationOptions:=true;
         (* ALLOCATION DU MODULE D'IMPRESSION *)
         Imprimante:=New(pImprimante,INIT);
         if Imprimante <> nil
            then   (* IMPRESSION *)
              begin
                Imprimante^.INITIALISATION_ETIQUETTES(@MargeHaut,@MargeBas,@MargeGauche,@MargeDroite,
                                                      @NbParLigne,@NbParColonne,@Styles);
                (* BOUCLE GENERALE D'IMPRESSION *)
                Numero:=1; pCourant:=pTete;
                while NbTotal > 0 do
                  begin
                    (* REPARTITION DES ETIQUETTES SUR LA FEUILLE COURANTE *)
                    for i:=1 to 17 do for j:=1 to 4 do with PlanEtiquettes[i,j] do
                      begin
                        Imprimer:=false;
                        Adresse:=nil;
                      end;
                    for i:=1 to NbParColonne do for j:=1 to NbParLigne do PlanEtiquettes[i,j].Imprimer:=true;
                    Application^.EXECDIALOG(New(pDlgRepartition,INIT(@Self,'DIALOGUE_REPARTITION',
                                            @NbParLigne,@NbParColonne,@Numero,@NbTotal,@PlanEtiquettes,@NbFeuille)));
                    if NbFeuille > 0
                       then
                         begin
                           (* CONSTRUCTION DU PLAN FINAL DE LA FEUILLE *)
                           p:=pCourant; Compteur:=0;
                           while (p <> nil) and (Compteur < NbFeuille) do
                             begin
                               if p^.Selection
                                  then   (* ELEMENT A IMPRIMER *)
                                    begin
                                      Inc(Compteur);
                                      i:=1; j:=1;
                                      while i <= NbParColonne do
                                        begin
                                          if PlanEtiquettes[i,j].Imprimer
                                             then   (* UNE PLACE EST TROUVEE *)
                                               begin
                                                 PlanEtiquettes[i,j].Adresse:=p;
                                                 PlanEtiquettes[i,j].Imprimer:=false;
                                                 i:=NbParColonne+1;   (* FIN DE BOUCLE *)
                                               end
                                             else   (* SUIVANT *)
                                               if j = NbParLigne
                                                  then
                                                    begin
                                                      j:=1; Inc(i);
                                                    end
                                                  else
                                                    Inc(j);
                                        end;
                                    end;
                               p:=p^.pSuiv;
                             end;
                           (* IMPRESSION *)
                           Imprimante^.IMPRIMER_ETIQUETTES(@PlanEtiquettes,@Styles);
                           (* MISE A JOUR DU NOMBRE D'ETIQUETTES RESTANT *)
                           Dec(NbTotal,Compteur);
                           if NbTotal > 0
                              then   (* CE N'EST PAS ENCORE FINI *)
                                begin
                                  (* MISE A JOUR DE L'ELEMENT DE DEPART *)
                                  pCourant:=p;
                                  (* PASSAGE A LA FEUILLE SUIVANTE *)
                                  Inc(Numero);
                                end;
                         end
                       else   (* L'IMPRESSION EST ANNULEE *)
                         NbTotal:=0;
                  end;
                (* DESALLOCATION DU MODULE D'IMPRESSION *)
                Dispose(Imprimante,DONE);
              end
            else   (* ERREUR D'ALLOCATION DU MODULE D'IMPRESSION *)
              MESSAGE_ERREUR_MEMOIRE(erm_TitreInterfaceImprimante);
       end
     else   (* AUCUNE PERSONNE SELECTIONNEE DANS LA BOITE LISTE OU ERREUR *)
       MessageBeep($FFFF);
End;

Procedure tFenetrePrincipale.IDLISTING (var Msg : tMessage);
(* IMPRESSION D'UN LISTING DES FICHES SELECTIONNEES *)
Var ChampsTemp : tChamps;   (* COPIE DES OPTIONS DE DEPART *)
    NbTotal : Word;         (* NOMBRE DE PERSONNES A IMPRIMER *)
    i : Word;               (* INDICE DANS LES TABLEAUX DE CHAMPS A IMPRIMER *)
Begin
  (* DANS LA LISTE CHAINEE, SELECTION DES PERSONNES SELECTIONNEES DANS LA BOITE LISTE *)
  NbTotal:=LECTURE_SELECTIONS;
  if NbTotal <> 0
     then
       begin
         (* SAUVEGARDE DE L'ETAT DES OPTIONS *)
         ChampsTemp:=ChampsListing;
         (* CHOIX DES CHAMPS A IMPRIMER *)
         Application^.ExecDialog(New(pDlgListing,INIT(@Self,'DIALOGUE_LISTING',@ChampsListing)));
         (* DETERMINE S'IL Y A EU MODIFICATION *)
         if not ModificationOptions
            then
              begin
                i:=id_Formule;
                while i <= id_Remarque do
                  if ChampsTemp[i] <> ChampsListing[i]
                     then   (* IL Y A MODIFICATION *)
                       begin
                         ModificationOptions:=true;
                         i:=id_Remarque + 1;   (* FIN DE BOUCLE *)
                       end
                     else
                       Inc(i);
              end;
         (* ALLOCATION DU MODULE D'IMPRESSION *)
         Imprimante:=New(pImprimante,INIT);
         if Imprimante <> nil
            then   (* IMPRESSION *)
              begin
                Imprimante^.INITIALISATION_LISTING(@Styles,@ChampsListing);
                Imprimante^.IMPRIMER_LISTING(NbTotal,@Styles,pTete,@ChampsListing);
                (* DESALLOCATION DU MODULE D'IMPRESSION *)
                Dispose(Imprimante,DONE);
              end
            else   (* ERREUR D'ALLOCATION DU MODULE D'IMPRESSION *)
              MESSAGE_ERREUR_MEMOIRE(erm_TitreInterfaceImprimante);
       end
     else   (* AUCUNE PERSONNE SELECTIONNEE DANS LA BOITE LISTE OU ERREUR *)
       MessageBeep($FFFF);
End;

Procedure tFenetrePrincipale.IDPOLICES (var Msg : tMessage);
(* AFFICHAGE DU MENU FLOTTANT DE DEFINITION DE LA MISE EN FORME DES DONNEES LORS DE L'IMPRESSION *)
Var HandleMenu : hMenu;          (* HANDLE DU MENU FLOTTANT *)
    c : Array [0..13] of Char;   (* ELEMENT DE LA TABLE DES CHAINES *)
    Id : Integer;                (* IDENTIFICATEUR *)
    Coord : tPoint;              (* COORDONNEES D'AFFICHAGE DU MENU *)
Begin
  (* CREATION DU MENU *)
  HandleMenu:=CreatePopupMenu;
  for Id:=cm_PoliceFormule to cm_PoliceRemarque do
    begin
      LoadString(hInstance,Id,c,SizeOf(c));
      AppendMenu(HandleMenu,mf_Enabled,Id,c);
    end;
  AppendMenu(HandleMenu,mf_Separator,0,c);
  LoadString(hInstance,cm_PoliceApercu,c,SizeOf(c));
  AppendMenu(HandleMenu,mf_Enabled,cm_PoliceApercu,c);
  (* TRANSFORMATION DES COORDONNEES FENETRE EN COORDONNEES ECRAN *)
  with Coord do begin x:=511; y:=76; end;
  ClientToScreen(hWindow,Coord);
  (* AFFICHAGE DU MENU *)
  TrackPopupMenu(HandleMenu,tpm_RightAlign,Coord.x,Coord.y,0,hWindow,nil);
  (* DESTRUCTION DU MENU *)
  DestroyMenu(HandleMenu);
End;

Procedure tFenetrePrincipale.IDQUITTER (var Msg : tMessage);
(* ACTIVATION DU BOUTON "QUITTER" : FIN DE PROGRAMME *)
Begin
  CloseWindow;
End;

Procedure tFenetrePrincipale.CMAJOUTER (var Msg : tMessage);
(* AJOUT D'UNE NOUVELLE PERSONNE DANS LA LISTE *)
Begin
  IDAJOUTER(Msg);
End;

Procedure tFenetrePrincipale.CMMODIFIER (var Msg : tMessage);
(* MODIFICATION DES DONNEES PERSONNELLES DE LA PERSONNE COURANTE *)
Begin
  IDMODIFIER(Msg);
End;

Procedure tFenetrePrincipale.CMSUPPRIMER (var Msg : tMessage);
(* SUPPRESSION DE LA PERSONNE COURANTE *)
Begin
  IDSUPPRIMER(Msg);
End;

Procedure tFenetrePrincipale.CMTRIER (var Msg : tMessage);
(* TRI DE LA LISTE DES DONNEES PERSONNELLES *)
Begin
  IDTRIER(Msg);
End;

Procedure tFenetrePrincipale.CMCHERCHER (var Msg : tMessage);
(* RECHERCHE D'UN EXTRAIT DE TEXTE DANS UN OU PLUSIEURS CHAMPS *)
Begin
  IDCHERCHER(Msg);
End;

Procedure tFenetrePrincipale.CMCHERCHERSUIVANT (var Msg : tMessage);
(* RECHERCHE DE L'OCCURENCE SUIVANTE D'UN EXTRAIT DE TEXTE DANS UN OU PLUSIEURS CHAMPS *)
Begin
  IDCHERCHERSUIVANT(Msg);
End;

Procedure tFenetrePrincipale.CMLISTING (var Msg : tMessage);
(* ACTIVATION DU MENU "COMMANDES/LISTING" *)
Begin
  IDLISTING(Msg);
End;

Procedure tFenetrePrincipale.CMETIQUETTES (var Msg : tMessage);
(* ACTIVATION DU MENU "COMMANDES/ETIQUETTES" *)
Begin
  IDETIQUETTES(Msg);
End;

Procedure tFenetrePrincipale.CMQUITTER (var Msg : tMessage);
(* ACTIVATION DU MENU "COMMANDES/QUITTER" *)
Begin
  CloseWindow;
End;

Procedure tFenetrePrincipale.STYLE_TEXTE (Id : Word);
(* DIALOGUE WINDOWS 3.1 DE CHOIX DE LA POLICE ET DE LA MISE EN FORME DU CHAMP n *)
Var ParametresDlg : tChooseFont;   (* PARAMETRES DU DIALOGUE DE WINDOWS 3.1 *)
    StyleTemp : tStyleTexte;       (* COPIE DU STYLE DE DEPART POUR DETERMINER SI MODIFICATION DES OPTIONS *)
    n : LongInt;                   (* TAILLE DE LA STRUCTURE tChooseFont *)
    DC : hDC;                      (* CONTEXTE DE PERIPHERIQUE POUR LE CALCUL DU NOMBRE DE POINTS PAR POUCE *)
Begin
  with Styles[Id] do
    begin
      StyleTemp:=Styles[Id];
      (* TRANSFORMATION DE LA TAILLE DE LA FONTE EN UNITES LOGIQUES *)
      DC:=GetDC(hWindow);
      Fonte.lfHeight:=-MulDiv(Taille,GetDeviceCaps(DC,LogPixelsY),72);
      ReleaseDC(hWindow,DC);
      (* APPEL DU DIALOGUE WINDOWS *)
      n:=SizeOf(ParametresDlg);
      FillChar(ParametresDlg,n,0);
      with ParametresDlg do
        begin
          lStructSize:=n;
          hWndOwner:=hWindow;
          Flags:=cf_InitToLogFontStruct or cf_Effects or cf_Both;
          lpLogFont:=@Fonte;
          RGBColors:=Couleur;
          if ChooseFont(ParametresDlg)
             then   (* LE BOUTON "OK" A ETE ACTIONNE : RECUPERATION DES VALEURS *)
               begin
                 Couleur:=RGBColors;
                 Taille:=iPointSize div 10;
                 (* TESTE SI LES OPTIONS ONT ETE MODIFIEES *)
                 if StrLComp(pChar(@StyleTemp),pChar(@Styles[Id]),SizeOf(StyleTemp)) <> 0 then ModificationOptions:=true;
               end;
        end;
    end;
End;

Procedure tFenetrePrincipale.CMPOLICEFORMULE (var Msg : tMessage);
(* DEFINITION DE LA MISE EN FORME DE LA FORMULE D'INTRODUCTION *)
Begin
  STYLE_TEXTE(id_Formule);
End;

Procedure tFenetrePrincipale.CMPOLICENOM (var Msg : tMessage);
(* DEFINITION DE LA MISE EN FORME DU NOM *)
Begin
  STYLE_TEXTE(id_Nom);
End;

Procedure tFenetrePrincipale.CMPOLICEPRENOM (var Msg : tMessage);
(* DEFINITION DE LA MISE EN FORME DU PRENOM *)
Begin
  STYLE_TEXTE(id_Prenom);
End;

Procedure tFenetrePrincipale.CMPOLICERUE (var Msg : tMessage);
(* DEFINITION DE LA MISE EN FORME DU NOM DE RUE *)
Begin
  STYLE_TEXTE(id_Rue);
End;

Procedure tFenetrePrincipale.CMPOLICECP (var Msg : tMessage);
(* DEFINITION DE LA MISE EN FORME DU CODE POSTAL *)
Begin
  STYLE_TEXTE(id_CP);
End;

Procedure tFenetrePrincipale.CMPOLICELOCALITE (var Msg : tMessage);
(* DEFINITION DE LA MISE EN FORME DU NOM DE LOCALITE *)
Begin
  STYLE_TEXTE(id_Localite);
End;

Procedure tFenetrePrincipale.CMPOLICETELPRIVE (var Msg : tMessage);
(* DEFINITION DE LA MISE EN FORME DU N DE TELEPHONE PRIVE *)
Begin
  STYLE_TEXTE(id_TelPrive);
End;

Procedure tFenetrePrincipale.CMPOLICEFAXPRIVE (var Msg : tMessage);
(* DEFINITION DE LA MISE EN FORME DU N DE FAX PRIVE *)
Begin
  STYLE_TEXTE(id_FaxPrive);
End;

Procedure tFenetrePrincipale.CMPOLICETELBUREAU (var Msg : tMessage);
(* DEFINITION DE LA MISE EN FORME DU N DE TELEPHONE AU BUREAU *)
Begin
  STYLE_TEXTE(id_TelBureau);
End;

Procedure tFenetrePrincipale.CMPOLICEFAXBUREAU (var Msg : tMessage);
(* DEFINITION DE LA MISE EN FORME DU N DE FAX AU BUREAU *)
Begin
  STYLE_TEXTE(id_FaxBureau);
End;

Procedure tFenetrePrincipale.CMPOLICEEMAIL (var Msg : tMessage);
(* DEFINITION DE LA MISE EN FORME L'ADRESSE E-MAIL *)
Begin
  STYLE_TEXTE(id_eMail);
End;

Procedure tFenetrePrincipale.CMPOLICEREMARQUE (var Msg : tMessage);
(* DEFINITION DE LA MISE EN FORME DE LA REMARQUE FACULTATIVE *)
Begin
  STYLE_TEXTE(id_Remarque);
End;

Procedure tFenetrePrincipale.CMPOLICEAPERCU (var Msg : tMessage);
(* AFFICHAGE DE L'APERCU DES POLICES DE CARACTERES *)
Begin
  Application^.MAKEWINDOW(New(pApercu,INIT(@Self,@Styles)));
End;

Procedure tFenetrePrincipale.CMCOULEURSDEFAUT (var Msg : tMessage);
(* COCHAGE OU DECOCHAGE DU MENU D'UTILISATION DES COULEURS PAR DEFAUT *)
Var Option : Word;   (* OPTION DE COCHAGE A APPLIQUER AU MENU *)
Begin
  if (GetMenuState(Attr.Menu,cm_CouleursDefaut,mf_ByCommand) and mf_Checked) = mf_Checked
     then   (* UTILISATION DES COULEURS PERSONNALISEES *)
       begin
         Option:=mf_ByCommand or mf_Unchecked;
         SetClassWord(hWindow,gcw_hBrBackGround,CreateSolidBrush(Couleurs[cm_CouleurFond]));
       end
     else   (* RETOUR AUX COULEUR PAR DEFAUT *)
       begin
         Option:=mf_ByCommand or mf_Checked;
         SetClassWord(hWindow,gcw_hBrBackGround,CreateSolidBrush(GetSysColor(color_Window)));
       end;
  CheckMenuItem(Attr.Menu,cm_CouleursDefaut,Option);
  ModificationOptions:=true;
  (* MISE A JOUR DE L'AFFICHAGE *)
  InvalidateRect(hWindow,nil,true);
  UpdateWindow(hWindow);
End;

Procedure tFenetrePrincipale.COULEUR_ELEMENT (Id : Word);
(* DIALOGUE WINDOWS 3.1 DE CHOIX DE LA COULEUR D'UN ELEMENT AFFICHE *)
Var cc : tChooseColor;                    (* DONNEES PASSEES AU DIALOGUE *)
    CouleursTemp : tCouleurs;             (* COPIE DES COULEURS DES ELEMENTS AFFICHES *)
    CouleursPersoTemp : tCouleursPerso;   (* COPIE DU TABLEAU DES 16 COULEURS PREDEFINIES *)
Begin
  (* COPIE DES OPTIONS COURANTES *)
  CouleursTemp:=Couleurs;
  CouleursPersoTemp:=CouleursPerso;
  (* EXECUTION DU DIALOGUE *)
  FillChar(cc,SizeOf(cc),0);
  with cc do
    begin
      lStructSize:=SizeOf(cc);
      hWndOwner:=hWindow;
      RGBResult:=Couleurs[Id];
      lpCustColors:=@CouleursPerso;
      Flags:=cc_RGBInit;
    end;
  if ChooseColor(cc)
     then   (* LE BOUTON "OK" A ETE PRESSE *)
       begin
         (* ENREGISTREMENT DU RESULTAT *)
         Couleurs[Id]:=cc.RGBResult;
         if (Compare(@Couleurs,@CouleursTemp,SizeOf(Couleurs)) <> 0) or
            (Compare(@CouleursPerso,@CouleursPersoTemp,SizeOf(CouleursPerso)) <> 0)
            then ModificationOptions:=true;
         if (GetMenuState(Attr.Menu,cm_CouleursDefaut,mf_ByCommand) and mf_Checked) <> mf_Checked
            then   (* MISE A JOUR DE L'AFFICHAGE *)
              begin
                SetClassWord(hWindow,gcw_hBrBackGround,CreateSolidBrush(Couleurs[cm_CouleurFond]));
                InvalidateRect(hWindow,nil,true);
                UpdateWindow(hWindow);
              end;
       end;
End;

Procedure tFenetrePrincipale.CMCOULEURFOND (var Msg : tMessage);
(* MODIFICATION DE LA COULEUR DE FOND DE LA FENETRE *)
Begin
  COULEUR_ELEMENT(cm_CouleurFond);
End;

Procedure tFenetrePrincipale.CMCOULEURTITRES (var Msg : tMessage);
(* MODIFICATION DE LA COULEUR DES TITRES DE CHAMPS *)
Begin
  COULEUR_ELEMENT(cm_CouleurTitres);
End;

Procedure tFenetrePrincipale.CMCOULEURFORMULE (var Msg : tMessage);
(* MODIFICATION DE LA COULEUR DU CHAMP Formule *)
Begin
  COULEUR_ELEMENT(cm_CouleurFormule);
End;

Procedure tFenetrePrincipale.CMCOULEURNOM (var Msg : tMessage);
(* MODIFICATION DE LA COULEUR DU CHAMP Nom *)
Begin
  COULEUR_ELEMENT(cm_CouleurNom);
End;

Procedure tFenetrePrincipale.CMCOULEURPRENOM (var Msg : tMessage);
(* MODIFICATION DE LA COULEUR DU CHAMP Prenom *)
Begin
  COULEUR_ELEMENT(cm_CouleurPrenom);
End;

Procedure tFenetrePrincipale.CMCOULEURRUE (var Msg : tMessage);
(* MODIFICATION DE LA COULEUR DU CHAMP Rue *)
Begin
  COULEUR_ELEMENT(cm_CouleurRue);
End;

Procedure tFenetrePrincipale.CMCOULEURCP (var Msg : tMessage);
(* MODIFICATION DE LA COULEUR DU CHAMP CP *)
Begin
  COULEUR_ELEMENT(cm_CouleurCP);
End;

Procedure tFenetrePrincipale.CMCOULEURLOCALITE (var Msg : tMessage);
(* MODIFICATION DE LA COULEUR DU CHAMP Localite *)
Begin
  COULEUR_ELEMENT(cm_CouleurLocalite);
End;

Procedure tFenetrePrincipale.CMCOULEURTELPRIVE (var Msg : tMessage);
(* MODIFICATION DE LA COULEUR DU CHAMP TelPrive *)
Begin
  COULEUR_ELEMENT(cm_CouleurTelPrive);
End;

Procedure tFenetrePrincipale.CMCOULEURFAXPRIVE (var Msg : tMessage);
(* MODIFICATION DE LA COULEUR DU CHAMP FaxPrive *)
Begin
  COULEUR_ELEMENT(cm_CouleurFaxPrive);
End;

Procedure tFenetrePrincipale.CMCOULEURTELBUREAU (var Msg : tMessage);
(* MODIFICATION DE LA COULEUR DU CHAMP TelBureau *)
Begin
  COULEUR_ELEMENT(cm_CouleurTelBureau);
End;

Procedure tFenetrePrincipale.CMCOULEURFAXBUREAU (var Msg : tMessage);
(* MODIFICATION DE LA COULEUR DU CHAMP FaxBureau *)
Begin
  COULEUR_ELEMENT(cm_CouleurFaxBureau);
End;

Procedure tFenetrePrincipale.CMCOULEUREMAIL (var Msg : tMessage);
(* MODIFICATION DE LA COULEUR DU CHAMP eMail *)
Begin
  COULEUR_ELEMENT(cm_CouleurEMail);
End;

Procedure tFenetrePrincipale.CMCOULEURREMARQUE (var Msg : tMessage);
(* MODIFICATION DE LA COULEUR DU CHAMP Remarque *)
Begin
  COULEUR_ELEMENT(cm_CouleurRemarque);
End;

Procedure tFenetrePrincipale.CMAPROPOS (var Msg : tMessage);
(* AFFICHAGE DU DIALOGUE "A PROPOS DE" *)
Begin
  Application^.ExecDialog(New(pDlgAPropos,INIT(@Self,'DIALOGUE_APROPOS')));
End;

Function tFenetrePrincipale.CANCLOSE : Boolean;
(* SAUVEGARDE EVENTUELLE DES OPTIONS COURANTES ET DES MODIFICATIONS A LA LISTE DES DONNEES PERSONNELLES *)
Var Texte : Array [0..60] of Char;   (* MESSAGE DE LA BOITE A MESSAGES *)
    Titre : Array [0..22] of Char;   (* TITRE DE LA BOITE A MESSAGES *)
    Reponse : Integer;               (* REPONSE RENVOYEE PAR LA BOITE A MESSAGES *)
    Fermer : Boolean;                (* INDIQUE SI L'APPLICATION PEUT ETRE FERMEE *)
Begin
  Fermer:=true;
  if Modification
     then   (* SAUVEGARDE DE LA LISTE DES DONNEES PERSONNELLES ? *)
       begin
         LoadString(hInstance,msg_SauverDonnees,Texte,SizeOf(Texte));
         LoadString(hInstance,msg_TitreSauverDonnees,Titre,SizeOf(Titre));
         Reponse:=MessageBox(hWindow,Texte,Titre,mb_IconQuestion or mb_YesNoCancel);
         case Reponse of
           id_Yes : Fermer:=SAUVEGARDE_DONNEES_PERS;
           id_No : Fermer:=true;
           id_Cancel : Fermer:=false;
         end;
       end;
  if Fermer and ModificationOptions
     then   (* SAUVEGARDE DES OPTIONS ? *)
       begin
         LoadString(hInstance,msg_SauverOptions,Texte,SizeOf(Texte));
         LoadString(hInstance,msg_TitreSauverOptions,Titre,SizeOf(Titre));
         Reponse:=MessageBox(hWindow,Texte,Titre,mb_IconQuestion or mb_YesNoCancel);
         case Reponse of
           id_Yes : begin
                      SAUVEGARDE_OPTIONS;
                      Fermer:=true;
                    end;
           id_No : Fermer:=true;
           id_Cancel : Fermer:=false;
         end;
       end;
  CANCLOSE:=Fermer;
End;

Destructor tFenetrePrincipale.DONE;
(* DESALLOCATION DES VARIABLES DYNAMIQUES *)
Var p1, p2 : pListeDonneesPers;   (* ELEMENTS DE LA LISTE CHAINEE DES DONNEES PERSONNELLES *)
Begin
  p1:=pTete;
  while p1 <> nil do
    begin
      p2:=p1^.pSuiv;
      Dispose(p1);
      p1:=p2;
    end;
  tWindow.DONE;
End;

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                                  PROGRAMME PRINCIPAL                                                 *)
(* -------------------------------------------------------------------------------------------------------------------- *)

BEGIN
  Programme.INIT(NomApplication);
  Programme.RUN;
  Programme.DONE;
END.
